/* Test des EditWin.


//================================================================ */


#ifdef _MSC_VER
#define _CRT_SECURE_NO_DEPRECATE
#endif

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#include "ut_gtk.h"
#include "ut_gtkEd.h"

#include "../ut/ut_txfil.h"
#include "../gr/ut_UI.h"


const double UT_VAL_MAX  =  9999999999999.999;   // ut_geo.c


extern char *UTF_FilBuf0;
extern long UTF_FilBuf0Len;  // die aktuelle Filesize
extern long UTF_FilBuf0Siz;  // die max. Filesize

#define mem_cbuf1_SIZ 25000
char mem_cbuf1[mem_cbuf1_SIZ];




//============ Lokale Var: =======================================
  char      fnam[128], cBuf[256];

  GIO_WinEd winED = {NULL, NULL, 0};    // das Editorfenster

  GtkWidget *gWin;    // dasrechte Win.



  void UI_EdChange (GtkWidget *parent, void *data);
  int  UI_open     (GtkWidget *parent, void *data);




/*========================================================================= */
  void UI_EdChange (GtkWidget *parent, void *data) {
/*==================
*/

  // letzter eingegebener Char ?
  char c1;

  c1 = GUI_Ed_RdChr (&winED, -1);

  if(c1 == '\n')  {
    printf("Newline\n");
  }

  printf("UI_EdChange |%c|\n",c1);

}



/*===================================================================== */
  int UI_save (GtkWidget *parent, void *data) {
/*============
Datei abspeichern; zuerst vom Window ins Memory kopieren,
  von dort in Datei raus.
*/

  char      *t1;


  printf("UI_save %d\n", (int)data);


  if(strcmp(data, "save")) {

    // den filename (incl. Pfad) nach fnam holen.
    t1 = (char*)gtk_file_selection_get_filename (GTK_FILE_SELECTION (data));
    strcpy(fnam, t1);
    printf("Sel.fn = !%s\n!",fnam);
    gtk_widget_destroy ((GtkWidget*) data);

  }


  // vom Window ins Memory kopieren
  GUI_Ed_Read (&winED, UTF_FilBuf0, &UTF_FilBuf0Len);

  // in Datei rausschreiben
  UTF_wri_file (fnam, 0);



  return 0;

}




/*===================================================================== */
  int UI_open (GtkWidget *parent, void *data) {
/*============
Neue Datei einlesen; zuerst ins Memory, von dort ins Window.
*/

  char      *t1;


  printf("UI_open %d\n", (int)data);
  

  // den filename (incl. Pfad) nach fnam holen.
  t1 = (char*)gtk_file_selection_get_filename (GTK_FILE_SELECTION (data));
  strcpy(fnam, t1);
  printf("Sel.fn = %s\n",fnam);
  gtk_widget_destroy ((GtkWidget*) data);




  // Datei fnam laden
  UTF_add_file (fnam); // Datei ins Memory einlesen
  // Memory > Editfenster
  GUI_Ed_Write (&winED, UTF_FilBuf0, &UTF_FilBuf0Len, UTF_FilBuf0Siz);

  


  return 0;

}



/*===================================================================== */
  int UI_work1 (GtkWidget *parent, void *data) {
/*============
Fr Mainfunktionen, die kein eigenes Panel haben.
*/


  int   i1;
  char  *cp1;
  static int   cpos=0, cpos1, cpos2;


  printf("UI_work1,  /%s/\n",(char*)data);




  /* work ..  */
  cp1 = (char*)data;




  if(!strcmp(cp1, "GetCpos")) {
    cpos = GUI_Ed_getCpos (&winED);
    printf("cpos = %d\n",cpos);


  } else if(!strcmp(cp1, "SetCpos")) {
    cpos += 2;
    GUI_Ed_setCpos (&winED, cpos);


  } else if(!strcmp(cp1, "select")) {

    cpos = GUI_Ed_getCpos (&winED);
    printf("cpos = %d\n",cpos);
    
    // get starting a. ending Pos of line
    GUI_Ed_getLpos  (&cpos1, &cpos2, cpos, &winED);

    // select_region von cpos bis cpos (und scroll!)
    GUI_Ed_sel__ (&winED, cpos1, cpos2);



  } else if(!strcmp(cp1, "DelSel")) {
    GUI_Ed_sel_del (&winED);


  
  } else if(!strcmp(cp1, "unselect")) {
    // ein implizites unselect !!
    // GUI_Ed_scroll_u (&winED, cpos);
    GUI_Ed_setCpos (&winED, cpos);
    

  } else if(!strcmp(cp1, "InsTx")) {
    cpos = GUI_Ed_getCpos (&winED);
    GUI_Ed_Insert (&winED, cpos, "abc", 3);
    // GUI_Ed_Focus (&winED);
    cpos += 3;
    GUI_Ed_setCpos (&winED, cpos);




  } else if(!strcmp(cp1, "InsLn")) {
    cpos = GUI_Ed_getCpos (&winED);
    // find eol
    cpos = GUI_Ed_getLend (&winED, cpos);
    // insert newline
    GUI_Ed_Insert (&winED, cpos, "\n", 1);
    cpos += 1;
    GUI_Ed_setCpos (&winED, cpos);


  } else if(!strcmp(cp1, "GetActLn")) {
    GUI_Ed_RdLnAct (&winED, cBuf, &i1);


  } else if(!strcmp(cp1, "GetStat")) {


  } else if(!strcmp(cp1, "NxtLin")) {
    GUI_Ed_setCnxtL (&winED);


  } else if(!strcmp(cp1, "GetFsiz")) {
    GUI_Ed_getEof (&winED);


  } else if(!strcmp(cp1, "RdAll")) {
    GUI_Ed_Read (&winED, UTF_FilBuf0, &UTF_FilBuf0Len);


  } else if(!strcmp(cp1, "RdChr")) {
    GUI_Ed_RdChr (&winED, -1);

  } else if(!strcmp(cp1, "Del")) {
    cpos1 = GUI_Ed_getCpos (&winED);
    cpos2 = cpos1 + 2;
    GUI_Ed_del (&winED, cpos1, cpos2);

  } else if(!strcmp(cp1, "SelWr")) {
    GUI_Ed_sel_wrf (&winED, "01");

  } else if(!strcmp(cp1, "SelRd")) {
    GUI_Ed_Ins_f (&winED, "01");

  } else if(!strcmp(cp1, "SelLn")) {
    i1 = GUI_Ed_sel_ln (&winED, cpos);
    if(i1 < 0) cpos = 0;
    else ++cpos;

  } else if(!strcmp(cp1, "Foc")) {

  } else printf("UI_work1 Error E001 |%s|\n",cp1);


  GUI_Ed_Focus (&winED);


  return 0;
}



/*===================================================================== */
  int UI_noPan (GtkWidget *parent, void *data) {
/*============
Fr Mainfunktionen, die kein eigenes Panel haben.
*/


  char *cp1;


  printf("UI_noPan,  /%s/\n",(char*)data);


  /* printf("  Widget-type =%d\n",gtk_type_is_a (gtk_menu_item_get_type ()); */
  /* printf("  Widget-type =%d\n",GTK_IS_MENU_ITEM (parent)); */


  /* wenn NICHT Menu-Item: skip disactivate */
  if (GTK_IS_MENU_ITEM (parent) == 0) {
    if ((GTK_TOGGLE_BUTTON (parent)->active) == 0) goto Fertig;
  }


  /* work ..  */
  cp1 = (char*)data;




  if(!strcmp(cp1, "new")) {
    // Clear Memory u. Editfenster
    GUI_Ed_Write (&winED, NULL, NULL, 0);


  } else if(!strcmp(cp1, "open")) {
    GUI_File_select ("./", (void*)UI_open);



  } else if(!strcmp(cp1, "save")) {
    UI_save (NULL, (void*)"save");



  } else if(!strcmp(cp1, "saveAs")) {
    GUI_File_select ("./", (void*)UI_save);



  }







  Fertig:
  /* Reset focus to glarea widget */
  /* UI_GR_setKeyFocus (); */

  return 0;
}






/*=============================================== */
  int UI_win_main (GtkWidget *parent, void *data) {
/*================
*/

  static GtkWidget *winID, *box0, *box1, *menu_bar, *menu;
  static GtkWidget *hpaned;
  static GtkWidget *xxxx;


  int i1;


  /* -------------------------------------------------- */
  printf("UI_win1 %d\n",(int)data);

  i1 = (int)data;


  switch (i1) {


    /* Init Panel -------------------------- */
    case UI_FuncInit:

      /* Create Mainwindow */
      winID = GUI_Window ("Test", UI_win_main, (void*)UI_FuncKill, 0);


      /* Eine vbox bers gesamte Window */
      box0 = GUI_Vbox (winID, 10);

      /* Create a menu-bar to hold the menus and add it to our main window*/
      menu_bar = GUI_MenuBar (box0);


      /* ----------- Menubar --------------------------------------- */
      menu = GUI_Menu (menu_bar, "File ", 0);
      GUI_MenuEntry (menu, "New",     UI_noPan,   (void*)"new");
      GUI_MenuEntry (menu, "Open",    UI_noPan,   (void*)"open");
      GUI_MenuEntry (menu, "Save",    UI_noPan,   (void*)"save");
      GUI_MenuEntry (menu, "Save as", UI_noPan,   (void*)"saveAs");
      // geht nicht GUI_Hsep      (menu, 2);
      GUI_MenuEntry (menu, "Exit",    UI_win_main,(void*)UI_FuncKill);



      // ein paar testbuttons
      box1 = GUI_Hbox (box0, 0);
      GUI_Butt (box1, "GetCpos", UI_work1, (void*)"GetCpos", 0);
      GUI_Butt (box1, "SetCpos", UI_work1, (void*)"SetCpos", 0);
      GUI_Butt (box1, "Sel",     UI_work1, (void*)"select", 0);
      GUI_Butt (box1, "DelSel",  UI_work1, (void*)"DelSel", 0);
      GUI_Butt (box1, "NxtLin",  UI_work1, (void*)"NxtLin", 0);
      box1 = GUI_Hbox (box0, 0);
      GUI_Butt (box1, "Unsel", UI_work1, (void*)"unselect", 0);
      GUI_Butt (box1, "InsTx", UI_work1, (void*)"InsTx", 0);
      GUI_Butt (box1, "InsLn", UI_work1, (void*)"InsLn", 0);
      GUI_Butt (box1, "GetActLn", UI_work1, (void*)"GetActLn", 0);
      GUI_Butt (box1, "GetStat", UI_work1, (void*)"GetStat", 0);
      box1 = GUI_Hbox (box0, 0);
      GUI_Butt (box1, "GetFsiz", UI_work1, (void*)"GetFsiz", 0);
      GUI_Butt (box1, "RdAll", UI_work1, (void*)"RdAll", 0);
      GUI_Butt (box1, "RdChr", UI_work1, (void*)"RdChr", 0);
      GUI_Butt (box1, "Foc", UI_work1,   (void*)"Foc", 0);
      GUI_Butt (box1, "Del", UI_work1,   (void*)"Del", 0);
      box1 = GUI_Hbox (box0, 0);
      GUI_Butt (box1, "SelWr", UI_work1, (void*)"SelWr", 0);
      GUI_Butt (box1, "SelRd", UI_work1, (void*)"SelRd", 0);
      GUI_Butt (box1, "SelLn", UI_work1, (void*)"SelLn", 0);




      //das Edit-Fenster und das Grafik-fenster nebeneinander
      hpaned = gtk_hpaned_new ();
      gtk_container_add (GTK_CONTAINER(box0), hpaned);
      gtk_widget_show (hpaned);



      GUI_Ed_Init (&winED, NULL, 1);
      gtk_paned_add1 (GTK_PANED(hpaned), winED.win);
      gtk_widget_show (winED.win);

/*
      // Widgets zufuegen ins 2. Fenster (rechte od untere) mit:
      // xxxx = GUI_Ed_Init (&gWin, NULL);
      xxxx = GUI_Ed_Init (&gWin, NULL, 1);
      gtk_paned_add2 (GTK_PANED(hpaned), xxxx);
      gtk_widget_show (xxxx);
*/


      /* -------- Display Win ---------------- */
      gtk_widget_show (GTK_WIDGET(winID));
      gtk_widget_set_uposition (winID, 0, 0);


      // Init Textfensterparameter
      // GUI_Ed_Init1 (winED);    // hier war wText !!!!


      break;




    case UI_FuncKill:
      gtk_widget_destroy (winID);
      winID = NULL;
      /* gtk_exit (1); */
      exit(0);
      break;


  }



  return 0;
}




/*================================================================*/
  int main () {
/*================
*/

  printf("+++++++++++++Start t1\n");

  // Read Colours und Fonts
  // GUI_Init ("gcad.rc");
  GUI_Init ("");

  // Init Win
  UI_win_main (NULL, (void*)UI_FuncInit);

  UTF_add_file ("00"); // Datei ins Memory einlesen

  // Memory > Editfenster
  GUI_Ed_Write (&winED, UTF_FilBuf0, &UTF_FilBuf0Len, UTF_FilBuf0Siz);

  // Enter gtk-Mainloop
  gtk_main();

  return 0;

}



/* ====================== EOF =========================== */
