/*  tst_gtk1.c

Testprogramm fuer die gtk-Utilityfunktionen in ut_gtk.c

Compile & run:
Linux:
make -f tst_gtk1.mak && tst1.exe
Windows:
nmake -f tst_gtk1.nmak


-----------------------------------------------------------
Offen:

Beispiele ev. im Internet http://sunsite.unc.edu//gtk/


-----------------------------------------------------------

*/




#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#include <gtk/gtk.h>

#include "ut_gtk.h"
#include "../gr/ut_UI.h"



const double UT_VAL_MAX  =  9999999999999.999;   // ut_geo.c




static GtkWidget *cb1, *cb2, *tb1, *w_opt;


#define mem_cbuf1_SIZ 250
char mem_cbuf1[mem_cbuf1_SIZ];



// prototypes:
  int RadButts (GtkWidget *parent, void *data);
  int OptMen_CB (GtkWidget *parent, void *data);
  int chg_CB (GtkWidget *parent, void *data);
  int UI_CB     (GtkWidget *parent, void *data);
  int UI_WinDxfImp (GtkWidget *parent, void *data);





/*=============================================== */
  int main (int argc, char *argv[]) {
/*============= */

  GtkWidget *window, *box0,
            *menu_bar, *men_fil, *men_imp, *men_hlp;
  GtkWidget *box1h, *box1h1v, *box1h1v1h, *box1h1v2h;
           


  char *optLst[]={"Jaenner","Februar","Maerz",NULL};




  /* Read Colours und Fonts */
  GUI_Init ("tst1_gtk.rc");

  /* Create Mainwindow */
  window = GUI_Window ("TW1", UI_CB, (void*)"exit", 0);
  gtk_widget_set_uposition (window, 800, 600);  // Pos of mainwin


  /* --------- Create the boxes --------- */
  /* Eine vbox, in die oben der MenuBar kommt. */
  box0 = GUI_Vbox (window, 0);


      /* Create a menu-bar to hold the menus and add it to our main window*/
      menu_bar = GUI_MenuBar (box0);


      // ----------- Menubar --------------------------------------- 
      men_fil = GUI_Menu (menu_bar, "File ", 0);
      men_hlp = GUI_Menu (menu_bar, "Help ", 'r');



      // Entries von "File"
      GUI_MenuEntry   (men_fil, "New",     UI_CB,   (void*)"new");
      GUI_MenuEntry   (men_fil, "Open",    UI_CB,   (void*)"open");
      GUI_MenuEntry   (men_fil, "---",     NULL,    NULL);
      men_imp=GUI_Menu(men_fil, "Import", 's');
      GUI_MenuEntry   (men_fil, "Export", UI_CB,   (void*)"saveAs");
      GUI_MenuEntry   (men_fil, "---",     NULL,    NULL);
      GUI_MenuEntry   (men_fil, "Exit",    UI_CB,   (void*)"exit");

      // Submenu File/Import
      GUI_MenuEntry (men_imp, "DXF",   UI_CB,   (void*)"dxf");
      GUI_MenuEntry (men_imp, "IGES",  UI_CB,   (void*)"func4");


      // Entries von "Help"
      GUI_MenuEntry   (men_hlp, "Doku",     UI_CB,   (void*)"doc");
      // gtk_menu_item_right_justify(GTK_MENU_ITEM(men_hlp));



      //--------------------------------------------------------

      // Buttons in einem Toolbar
      tb1 = GUI_Toolbox (box0);
      box1h = GUI_Hbox (tb1, 0); // 
      box1h1v = GUI_Vbox (box1h, 1); // 
      box1h1v1h = GUI_Hbox (box1h1v, 1);

      GUI_Butt (box1h1v1h, "WinDxfImp",UI_CB, (void*)"dxf", 2);
      GUI_Tip  ("DXF importieren");
      GUI_Butt (box1h1v1h, "Step", UI_CB, (void*)"func2", 2);
      GUI_Butt (box1h1v1h, "End ", UI_CB, (void*)"func3", 2);

      box1h1v2h = GUI_Hbox (box1h1v, 1);
      GUI_Butt (box1h1v2h, "Clear", UI_CB, (void*)"func4", 2);
      GUI_Butt (box1h1v2h, " Zoom", UI_CB, (void*)"func5", 2);





  //===========================================================
  // Checkboxen
  cb1=GUI_CkButt (box0, "ckb 1", TRUE, NULL, NULL, 0);
  cb2=GUI_CkButt (box0, "ckb 2", FALSE, NULL, NULL, 0);



  // some Radiobuttons ..
  RadButts (box0, NULL);


  // OptionMenu
  w_opt=GUI_OptMen  (box0, optLst, OptMen_CB, 0);
  GUI_OptMenActivate (w_opt, 1);

  GUI_Butt (box0, " Change ", chg_CB, NULL, 5);


  // ein (Hintergrund-) Bild
  GUI_Pix (box0, "test2.xpm", 10);



  GUI_Butt (box0, " C L O S E ", gtk_exit, NULL, 5);



  //===========================================================
  /* Display MainWin und enter the GTK main processing loop */
  gtk_widget_show (window);
  gtk_main ();

  return 0;
}






/*===================================================================== */
  int RadButts (GtkWidget *parent, void *data) {
/*=============
*/

  GtkWidget *frm1, *box1;

  printf("RadButts\n");

  frm1 = GUI_Frame (parent, "Line", 10);
  box1 = GUI_Vbox (frm1, 0);

  /* GUI_Label (box1, "Line  ", 0); */

  GUI_RadButt    (box1, "X-Parl", NULL, NULL, 0);
  GUI_RadButtAdd (box1, "Y-Parl", NULL, NULL, 0);
  GUI_RadButtAdd (box1, "Z-Parl", NULL, NULL, 0);
  GUI_Hsep       (box1, 5);
  GUI_RadButtAdd (box1, "Ang / Parl", NULL, NULL, 0);

  GUI_RadButtSet (2);
  return 0;
}






//=====================================================================
  int chg_CB (GtkWidget *parent, void *data) {
//=====================================================================

  char *optLst1[]={"April","Mai","Juni",NULL};
  char *optLst2[]={"Juli","August","September",NULL};

  static char ind=1;

  printf("chg_CB \n");

  if(ind > 0) {
    GUI_OptMenChg (w_opt, optLst1, OptMen_CB);
    ind = -1;
  } else {
    GUI_OptMenChg (w_opt, optLst2, OptMen_CB);
    ind = 1;
  }


  return 0;

}



//=====================================================================
  int OptMen_CB (GtkWidget *parent, void *data) {
//=====================================================================


  printf("OptMen_CB |%d|\n",(int)data);
  return 0;

}



/*===================================================================== */
  int UI_CB (GtkWidget *parent, void *data) {
/*=============
*/

  int   i1;
  char  *cp1;
  // GtkWidget *frm1, *box1;

  printf("UI_CB,  /%s/\n",(char*)data);


  /* work ..  */
  cp1 = (char*)data;

  
  // printf("UI_CB %d %d\n",(int)data,GTK_TOGGLE_BUTTON (parent)->active);


  if(!strcmp(cp1, "func2")) {

    i1 = GTK_TOGGLE_BUTTON (cb1)->active;
    printf("cb1 = %d\n",i1);


  } else if(!strcmp(cp1, "func3")) {
    gtk_widget_hide(tb1);


  } else if(!strcmp(cp1, "func4")) {
    gtk_widget_show(tb1);




  } else if(!strcmp(cp1, "dxf")) {
    UI_WinDxfImp (NULL, (void*)UI_FuncInit);



  } else if(!strcmp(cp1, "exit")) {
      gtk_widget_destroy (parent);
      /* gtk_exit (1); */
      exit(0);
  }

  return 0;
}


//=====================================================================
  int UI_WinDxfImp (GtkWidget *parent, void *data) {
//=====================================================================
// complete unit (create, manipulate, destroy)



  int    i1;
  // double dx, dy;
  char   *txt;
  static GtkWidget *winSW=NULL, *box0, *cb1, *offset;




  printf("UI_WinDxfImp %d\n",(int)data);

  i1 = (int)data;


  switch (i1) {


    //---------------------------------------------------------
    case UI_FuncInit:

      if(winSW != NULL) {           // Win schon vorhanden ?
        gtk_widget_destroy (winSW);
      }

      winSW = GUI_Window ("Import DXF-File",UI_WinDxfImp,(void*)UI_FuncKill,0);
      gtk_widget_set_uposition (winSW, 800, 600);  // Pos of mainwin

      box0 = GUI_Vbox (winSW, 0);

      cb1=GUI_CkButt (box0, "3D-Mode", TRUE, NULL, NULL, 0);
      GUI_Tip  ("als 2D oder 3D-Elemente einlesen");

      // X/Y-Offset
      offset = GUI_Entry (box0, " Offset: ","0,0",NULL, -100);
      GUI_Tip  ("die gesamte DXF-Geometrie um den angegebenen "
                "X/Y-Wert verschieben");


      GUI_Hsep (box0, 0);
      GUI_Butt (box0, "OK", UI_WinDxfImp, (void*)UI_FuncWork, 2);

      gtk_widget_show (winSW);

      break;




    //---------------------------------------------------------
    case UI_FuncWork:
      printf("DxfImp work\n");

      // work ..
      i1 = GTK_TOGGLE_BUTTON (cb1)->active;
      txt = (char*)gtk_entry_get_text (GTK_ENTRY (offset));
      printf("AP_DxfImp; CheckBox/Text war %d |%s|\n",i1,txt);




    //---------------------------------------------------------
    case UI_FuncKill:
      printf("DxfImp exit\n");

      // EXIT
      gtk_widget_destroy (winSW);
      winSW = NULL;
  }

  return 0;

}



/* --------------- eof ------------------------- */
