/*  tst_gtk3.c

Testprogramm fuer gtk-Tree

Compile, Link:
Linux:
make -f tst_gtk3.mak&&./tst3.exe
Windows:
nmake -f tst_gtk3.nmak



-----------------------------------------------------------
*/

#ifdef _MSC_VER
#define _CRT_SECURE_NO_DEPRECATE
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#include <gtk/gtk.h>

#include "ut_gtk.h"



const double UT_VAL_MAX  =  9999999999999.999;   // ut_geo.c



#define mem_cbuf1_SIZ 250
char mem_cbuf1[mem_cbuf1_SIZ];



// Global:
GtkWidget *AP_root;
GtkWidget *AP_node;



/*  prototypes: */
  int UI_CB     (GtkWidget *parent, void *data);
  GtkWidget* tree_populate ();
  GtkWidget* ctree_populate ();



//========================================================================
  GtkWidget* ctree_populate () {
//========================================================================
// populate tree:

  // int       i1, oNr;
  // char      lnam[80], *p1;
  char      *titles[3]= {"    SNR","Pos","Bezeichnung"};
  char      *n1txt[3]= {"81.12345.6086","001","Fuehrerhaus"};
  char      *n2txt[3]= {"81.12346.6086","001","Rahmen"};
  char      *n3txt[3]= {"81.12346.6086","001","Motor (nicht selektierbar)"};
  char      *n4txt[3]= {"81.12346.6086","001","Hinterachse"};
  GtkWidget *tree = NULL, *n1, *n2, *n3, *s1, *s2;
  // GtkCTreeNode *parent;
  // GtkStyle  *styl1, *styl2;
  GdkColor  colbg;



  tree = gtk_ctree_new_with_titles(3, 0, titles);
  gtk_widget_show (tree);


  // Abstand einruecken Subtrees; def = 20
  gtk_ctree_set_indent((GtkCTree*)tree, 30);


  // Spaltenbreiten
  gtk_clist_set_column_width((GtkCList*)tree, 0, 200); // SNR


  // Damit sind die symbol. Linien rechts !!
  // gtk_clist_set_column_justification(tree, 0, GTK_JUSTIFY_RIGHT);


  // gtk_ctree_insert_nodes (
  // tree      (immer der oberste)
  // parent (NULL wenn ganz oben)
  // sibling 
  // text (f. alle Spalten)
  // spacing  (nur Abstand zu Pixmap !)
  // pixmap closed, bitmask closed,
  // pixmap open,   bitmask open,
  // is_leaf   TRUE: hat selber keine Kinder; FALSE: hat selbst Kinder.
  // expanded  TRUE=ja, expand it.




  n1 =gtk_ctree_insert_node((GtkCTree*)tree, NULL, NULL, n1txt, 0,
                   NULL, NULL, NULL, NULL, FALSE, TRUE);


  // Spaltenoffset (tree, node, Spa(GtkCTree*)lte#, vertAbst, horAbst)
  // aber nur relativ !
  // gtk_ctree_node_set_shift(tree, n1, 0, 0, 50);



  // childs zu n1
  n2 =gtk_ctree_insert_node((GtkCTree*)tree, (GtkCTreeNode*)n1,   NULL, n2txt, 0,
                   NULL, NULL, NULL, NULL, TRUE,  TRUE);


  n3 =gtk_ctree_insert_node((GtkCTree*)tree, (GtkCTreeNode*)n1,   NULL, n2txt, 0,
                   NULL, NULL, NULL, NULL, FALSE,  TRUE);



  // childs zu n3
  s1 =gtk_ctree_insert_node((GtkCTree*)tree, (GtkCTreeNode*)n3,  NULL, n2txt, 0,
                   NULL, NULL, NULL, NULL, TRUE,  TRUE);

  // vorselektiert
  gtk_ctree_select((GtkCTree*)tree, (GtkCTreeNode*)s1);   


  s2 =gtk_ctree_insert_node((GtkCTree*)tree, (GtkCTreeNode*)n3,  NULL, n2txt, 0,
                   NULL, NULL, NULL, NULL, TRUE,  TRUE);




  // 3. roottree
  n1 =gtk_ctree_insert_node((GtkCTree*)tree, NULL, NULL, n3txt, 0,
                   NULL, NULL, NULL, NULL, FALSE, TRUE);


  // unselektierbar (gtk_widget_set_sensitive geht ned !)
  gtk_ctree_node_set_selectable((GtkCTree*)tree, (GtkCTreeNode*)n1, FALSE);
  colbg.red   =0xc000;
  colbg.green =0xc000;
  colbg.blue  =0xc000;
  gtk_ctree_node_set_background((GtkCTree*)tree, (GtkCTreeNode*)n1, &colbg);
  


  // Fontaendern: (Logan:662)
  // styl1 = gtk_ctree_node_get_row_style(tree, n1);
  // styl2 = gtk_style_copy(styl1);
  // gtk_ctree_node_set_row_style(tree, n1, styl2);


  // 4. roottree
  n1 =gtk_ctree_insert_node((GtkCTree*)tree, NULL, NULL, n4txt, 0,
                   NULL, NULL, NULL, NULL, FALSE, TRUE);



  AP_root = tree;

  return tree;

}


//========================================================================
  GtkWidget* tree_populate () {
//========================================================================
// populate tree:

  int       i1;
  char      lnam[80];
  GtkWidget *tree = NULL, *n1, *n2, *s1;


  tree = gtk_tree_new();
  gtk_widget_show (tree);


  // roottree 1
  n1 = gtk_tree_item_new_with_label("label1");
  // gtk_tree_append(GTK_TREE(tree), n1);
  gtk_tree_append(tree, n1);
  gtk_widget_show (n1);






  // roottree 2
  n2 = gtk_tree_item_new_with_label("label2");
  // gtk_tree_append(GTK_TREE(tree), n2);
  gtk_tree_append(tree, n2);
  gtk_widget_show (n2);


  // subtree an obj n2
  s1 = gtk_tree_new();
  gtk_widget_show (s1);
  // gtk_tree_item_set_subtree(GTK_TREE_ITEM(n2), s1);
  gtk_tree_item_set_subtree(n2, s1);

  for(i1=0; i1<30; ++i1) {
    sprintf(lnam, "slabel%d",i1),
    n1 = gtk_tree_item_new_with_label(lnam);
    // gtk_tree_append(GTK_TREE(s1), n1);
    gtk_tree_append(s1, n1);
    gtk_widget_show (n1);
  }

  // subtree an obj n1
  s1 = gtk_tree_new();
  gtk_widget_show (s1);
  // gtk_tree_item_set_subtree(GTK_TREE_ITEM(n1), s1);
  gtk_tree_item_set_subtree(n1, s1);

  for(i1=0; i1<30; ++i1) {
    sprintf(lnam, "slabel%d",i1),
    n1 = gtk_tree_item_new_with_label(lnam);
    // gtk_tree_append(GTK_TREE(s1), n1);
    gtk_tree_append(s1, n1);
    gtk_widget_show (n1);
  }


  return tree;

}


//========================================================================
  void UI_CB_sel (GtkCTree *tree, GList *node, gint col, void *data) {
//========================================================================

  char    *p1;


  printf("UI_CB_sel col=%d data=%d\n",col,(int*)data);

  AP_node = node;

  // Spaltentext lesen(parent,node,SpaltenNr, **text);
  gtk_ctree_node_get_text(tree, (GtkCTreeNode*)node, 2,  &p1),
  printf(" text=|%s|\n",p1);



  return;

}


/*===================================================================== */
  int UI_CB (GtkWidget *parent, void *data) {
/*=============
callback-routine of button
*/

  char       *cmd, *p1;
  GList      *sel;
  GtkWidget  *w1;


  cmd = (char*)data;

  printf("UI_CB  /%s/\n",(char*)data);


  if(!strcmp (cmd,"exit")) {
    gtk_exit(1);
    exit(0);



  //==================================================
  // alle aufblaettern
  } else if(!strcmp (cmd,"open")) {

    gtk_ctree_expand (AP_root, AP_node);

    return 0;


  //==================================================
  // alle zublaettern
  } else if(!strcmp (cmd,"close")) {

    gtk_ctree_collapse (AP_root, AP_node);

    return 0;

  }


  //==================================================
  printf("...........\n");
  // alle selektierten auslesen

  // gtk_clist_get_text
  sel = GTK_CLIST(AP_root)->selection;    // SAMS:445,340
  if(sel == NULL) goto L_done;

  L_next:
  w1 = (GtkWidget*) sel->data;

  // Spaltentext lesen(parent,node,SpaltenNr, **text);
  gtk_ctree_node_get_text((GtkCTree*)AP_root, (GtkCTreeNode*)w1, 2,  &p1),
  printf(" text=|%s|\n",p1);

  if(sel->next == NULL) goto L_done;
  sel = sel->next;
  goto L_next;



  //==================================================
  L_done:;
  return 0; 

}






/*=============================================== */
  int main (int argc, char *argv[]) {
/*============= */

  GtkWidget *window, *box0;
  GtkWidget *box2, *tree;
  GtkWidget *scrolled_win;



  // GUI_Init ("tst1_gtk.rc");
  GUI_Init ("");



  // Create Mainwindow
  window = GUI_Window ("Test", gtk_exit, NULL, 0);


  // vertical box
  box0 = GUI_Vbox (window, 0);


  // Backgroundtext
  GUI_Label (box0, "Test CTree fr MOAVIS", 0);


  // button
  GUI_Butt (box0, " L e s e n ", UI_CB, (void*)"read", -10);
  GUI_Butt (box0, "   Open ", UI_CB, (void*)"open", -10);
  GUI_Butt (box0, "   Close", UI_CB, (void*)"close", -10);
  GUI_Butt (box0, " E x i t  ", UI_CB, (void*)"exit", -10);




  //========================================================
  // populate tree:
  // tree = tree_populate ();
  // gtk_tree_set_selection_mode(GTK_TREE(tree), GTK_SELECTION_MULTIPLE);




  tree = ctree_populate ();
  // gtk_clist_set_selection_mode(GTK_CTREE(tree), GTK_SELECTION_MULTIPLE);
  gtk_clist_set_selection_mode((GtkCList*)tree, GTK_SELECTION_MULTIPLE);









  //========================================================
  // Tree-Window scrollbar
  box2 = GUI_Hbox (box0, 0);
  scrolled_win = gtk_scrolled_window_new (NULL, NULL);
  // nur vert. scrollen
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
                                  GTK_POLICY_AUTOMATIC,
                                  GTK_POLICY_ALWAYS);
  gtk_box_pack_start (GTK_BOX (box2), scrolled_win, TRUE, TRUE, 0);
  gtk_container_set_focus_vadjustment(GTK_CONTAINER(tree),
                     gtk_scrolled_window_get_vadjustment
                     (GTK_SCROLLED_WINDOW (scrolled_win)));
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolled_win),tree);
  gtk_widget_show_all (scrolled_win);
  gtk_widget_set_usize (box2, 500, 150);


  gtk_signal_connect (GTK_OBJECT (tree),
                      "tree_select_row",
                      (GtkSignalFunc) UI_CB_sel, (void*)1);
  gtk_signal_connect (GTK_OBJECT (tree),
                      "tree_unselect_row",
                      (GtkSignalFunc) UI_CB_sel, (void*)2);



  //===========================================================
  /* Display MainWin und enter the GTK main processing loop */
  // gtk_widget_set_usize (window, 500, 150);
  gtk_widget_show (window);

  gtk_main ();

  return 0;
}



/* --------------- eof ------------------------- */
