/*  tst_gtk0.c

Testprogramm fuer die gtk-Utilityfunktionen in ut_gtk.c

Compile & run:
Linux:
make -f tst_gtk0.mak && ./tst0.exe
Windows:
nmake -f tst_gtk0.nmak


-----------------------------------------------------------

*/

#ifdef _MSC_VER
#define _CRT_SECURE_NO_DEPRECATE
#endif


#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#include <gtk/gtk.h>

#include "ut_gtk.h"



const double UT_VAL_MAX  =  9999999999999.999;   // ut_geo.c




// prototypes:
  int UI_CB     (GtkWidget *parent, void *data);

#define mem_cbuf1_SIZ 250
char mem_cbuf1[mem_cbuf1_SIZ];







/*===================================================================== */
  int UI_exit (GtkWidget *parent, void *data) { 
/*===================================================================== */
// exit

  printf("UI_exit\n");

  // gtk_exit(1);

  exit(0);
  return 0;

}


//================================================================
  int UI_pop_CB1 (GtkWidget *widget, GdkEventAny *event, gpointer data) {
//================================================================

static int isel = -1, iprev = -1;

  printf("UI_pop_CB2\n");


  // Unix-GTK2:
  //   GDK_BUTTON_RELEASE  GDK_ENTER_NOTIFY GDK_UNMAP bei select
  //   GDK_BUTTON_RELEASE  GDK_UNMAP                  bei cancel
  //   Bei MS-Win kommt kein UNMAP !!!
  if(event->type == GDK_BUTTON_RELEASE) {  // kein data ..
    printf(" GDK_BUTTON_RELEASE\n");
    if(iprev < 0) return 0;                // exit mit cursor outside popup
    isel = iprev;
    printf("***************** %d sel ***********\n",isel);
    // ... work ...


  } else if (event->type == GDK_ENTER_NOTIFY) {
    // nach dem BUTTON_RELEASE kommt nochmal ENTER und LEAVE mit isel. Skip.
    iprev = (int)data;
    if(iprev == isel) return 0; // already selected ...
    printf(" GDK_ENTER_NOTIFY %d\n",iprev);


  } else if (event->type == GDK_LEAVE_NOTIFY) {
    // skip leaving previewed & selected
    if((int)data == isel) {isel = -1; iprev = -1; return 0;}
    printf(" GDK_LEAVE_NOTIFY\n");
    iprev = -1;
    isel = -1;



  } else if (event->type == GDK_UNMAP) {
    printf(" GDK_UNMAP\n");


  } else printf(" unknown event\n");

  

  return 0;

}


/*===================================================================== */
  int UI_CB (GtkWidget *parent, void *data) {
/*=============
callback-routine of button
*/


  char *pTab[]={"abc","def","yxz",""};

  printf("UI_CB  /%s/\n",(char*)data);

  if(!strcmp((char*)data, "pop")) {
    printf("GUI_Popup \n");
    GUI_Popup (pTab, UI_pop_CB1, UI_pop_CB1);
    return 0;
  }

  UI_exit (NULL, NULL);

}


/*=============================================== */
  int main (int argc, char *argv[]) {
/*============= */

  GtkWidget *window, *box0;

  GUI_Init ("");

  printf(" XXXXXXXXXXXXX %f\n",12.34);


  // Create Mainwindow
  window = GUI_Window ("Hallo", UI_exit, NULL, 0);


  // vertical box
  box0 = GUI_Vbox (window, 0);


  // buttons
  GUI_Butt (box0, " Popup ", UI_CB, (void*)"pop", 5);
  GUI_Butt (box0, " CLOSE ", UI_CB, (void*)"ex", 5);


// 
  //===========================================================
  /* Display MainWin und enter the GTK main processing loop */
  gtk_widget_show (window);
  gtk_main ();

  return 0;
}




/* --------------- eof ------------------------- */
