/*   ut_gtk.c

Utilities for GTK-2. (nicht in GTK1: gtk_disable_setlocale ..)


Offen:
  Die Funktionen sollten ein GUI_obj zurueckgeben; eine struct in der der typ
    und alle notwendigen Objekte enthalten sind. Am wichtigsten f. GUI_Ed_Init.



Korr:
2008-01-24 GUI_Slider, GUI_GetxText, GUI_del_widged. RF.
2007-04-29 GUI_Notebook_ new. RF.
2007-04-12 GUI_HList_.. new RF.
2005-10-17 GUI_GetText_CB Cancel korr. RF.
2005-01-07 Port -> GTK2. RF.
2003-11-14 GUI_WinUp komplett geaendert. RF.
2001-11-07 GUI_CB_WinDel neu. RF.
2001-11-06 GUI_SetActW neu. RF.
2001-10-25 Tooltips f. OptMens. RF.
2001-10-23 GUI_DialogY u. GUI_DialogYN neu. RF.
2001-10-22 GUI_OptMenChg u. GUI_GetText neu zu. RF.
2001-10-19 GUI_List korr. RF.
2001-07-20 GUI_OptMen u GUI_Combo neu. RF.
2001-06-17 GUI_File_selGet neu. RF.
2001-06-16 GUI_Toolbox zu. RF.
2001-06-14 GUI_Tip neu. RF.
2001-06-13 GUI_Menu: parameter mode zu. RF.
2001-06-08 GUI_Xbox: parameter expand zu. GUI_Butt_Att zu. RF.


*/
#ifdef globTag
 void GUI(){}
#endif
/*
---------------------------------------------------------------------------
Liste_Funktionen_Beginn:

GUI_Init
GUI_Window
GUI_Hbox
GUI_Vbox
GUI_VSpace                make a vertical (free) space
GUI_Frame                 Rahmen um ein Feld
GUI_Label                 BackgroundText (Label)
GUI_Label_mod             modify label
GUI_Hsep                  horiz. Trennlinie
GUI_Butt
GUI_Butt_Att
GUI_Tip                   Tooltip (Zusatzinfo zu Widget)
GUI_CkButt                Checkbox
GUI_CkButt_get            returns state of checkbox; 0=not sel, 1=selected.
GUI_ButtPix
GUI_Entry                 Eingabefeld (+ Infotext)
GUI_Entry_set             set text in entryField
GUI_Entry_get             get text from entryField - gives back a Pointer
GUI_Menu
GUI_MenuSub
GUI_MenuCkBox
GUI_MenuEntry
GUI_MenuBar
GUI_MenuRadButt
GUI_RadButt
GUI_RadButtAdd
GUI_RadButtSet
GUI_OptMen
GUI_OptMenActivate
GUI_OptMenChg
GUI_Combo
GUI_Pix
GUI_Popup              disp. popup-Liste; callbacks f. mouseOver & select
GUI_Slider__           Slider = AdjustmentControl
GUI_Slider_get         query slider-value
GUI_Slider_set         change slider-value

GUI_List
GUI_List_add
GUI_List_clear
GUI_List_remove
GUI_List_select
GUI_List2              Liste mit Filter; Listinhalt via Datei.
GUI_save__             get filename for SAVE.
GUI_HList__            make hierarchical SelectList. Mit Filter.

GUI_Notebook__
GUI_Notebook_add       add a page to a notebook

GUI_ColSel             ColorselectionDilaog
GUI_Dialog             Ausgabetext mit einem OK-Button zum Beenden
GUI_GetText            Text vom User holen
GUI_GetText_CB         callback of GUI_GetText
GUI_GetxText           Query text from user extended
GUI_GetxText_get       get userInput from GUI_GetxText
GUI_DialogYN
GUI_DialogY
GUI_File_selGet
GUI_File_select
GUI_File_selext

GUI_SetActW
GUI_GetActW
GUI_GetWidgetPos
GUI_GetWinPos
GUI_SetWinpos
GUI_Toolbox
GUI_CB_WinDel
GUI_WinUp              window always on top ..
GUI_update__           update pending events ..
GUI_del_events         kill all pending events
GUI_Idle               register a idle-function
GUI_del_widged         delete widget



Liste_Funktionen_Ende:
=====================================================


------------------------------------
Fehler von gtk am PC:
gdk_window_set_cursor
gtk_signal_connect (GTK_OBJECT(wText), "key_release_event",   geht ned



------------------------------------
Offen:
======
GUI_Tip: es sollte fuer jedes neue Window (zB PP-Win) eine eigenes NewTip geben
Oder mit dem GUI_Window mitgeben ?
Oder nach dem GUI_Window als GUI_TipInit liefern?


GUI_Entry - text nach rechts ausrichten (Zahlen) ???
  gtk_entry_get_text macht Mist; g_free -> Absturz. Durch gtk_text ersetzen ?


GUI_Label akzeptiert noch keine Tooltips ! Frame ebenfalls nicht.
  Eventuell Textfeld machen ?
  Gibts ein explizites Textausgabefeld ?

GUI_Label: wie kann man einen Frame rundherum machen (damit man
  die Feldlnge erkennen kann ?
  Feldlaenge ebenso wie bei _Entry machen !


GUI_Label: border noch nicht aktiv. Testen in grossem Panel.


Noch kein GtkOptionMenu: S.470.




------------------------------------
Beispiele:
vi /usr/include/gtk/gtkwidget.h
vi /p2/devel/gtk/exa/ex1/testgtk.c
vi /p2/devel/gtk/mygtk/gtk1.c
vi /usr/src/RPM/SOURCES/gftp-2.0.6a/gftp.c
vi /p2/devel/gtk/gtk_tutorial.20000721/txt/gtk_tut.txt

 if (!GTK_WIDGET_VISIBLE (window))
    gtk_widget_show (window);

??
      GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
      gtk_widget_grab_default (button);



------------------------------------
  gtk_alignment_new laesst Widgets gleich gross, der Platz aussen
  rum aber wird trotzdem groesser.

      // MenuBar soll in Y-Richtung nicht groesser werden S.533
      // align1 = gtk_alignment_new(0., 0., 1., 0.);
      // gtk_container_add (GTK_CONTAINER (box0), align1);
      // gtk_widget_show (align1);

------------------------------------
Probleme gtk:


------------------------------------
Allgemeiner Aufbau:

  GtkWidget *window, *box0, *menu_bar, *menu;

  GUI_Init ("gtk1.rc");
  window = GUI_Window ("TW1", exitFunc, exitData, 0);
  box0 = GUI_Vbox (window, 0);

  ..

  gtk_widget_show (window);
  gtk_main ();



------------------------------------
 Andere wichtige:

  gtk_widget_set_usize (window, 150, 300);

  gtk_widget_set_uposition (window, 150, pos);


	// Einen Button deaktivieren (dimmen);
  gtk_widget_set_sensitive (blst, FALSE);
	// TRUE setzt wieder auf aktiv.

  gtk_entry_set_text ((GtkEntry*) (entry),
           gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));


  // ein widget ausblenden (gtk_widget_unrealize, gtk_widget_unmap ??)
  gtk_widget_hide (tb1);
  // wieder einblenden
  gtk_widget_show (tb1);


	// Ein Widget ganz lschen.
  gtk_widget_destroy (wnam);

	// Eine Taste druecken
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (button), TRUE);


  wid=gtk_widget_get_ancestor(wid *child, gtk_window_get_type());





-----------------------------------------------------
Cursortypen:
------------
  gdk_window_set_cursor (window->window, gdk_cursor_new (GDK_HAND1));




-----------------------------------------------------
Inhalt einer struct GtkWidget:
-----------------------------------------------------
  widget->allocation.width,widget->allocation.heigh
    Liefert die volle Size des Window.
  widget->allocation.x,widget->allocation.y sollte die Posi. sein.




------------------------------------------------------------
Der Status der Modifier-Keys, der Mausbuttons und die Curpos:
-------------------------------------------------------------
Beim Signal Buttonpress od Release:

gint UI_ButtonRelease (GtkWidget *widget, GdkEventMotion *event) {

  int x, y;
  GdkModifierType state;

  if (event->is_hint) {
    gdk_window_get_pointer (event->window, &x, &y, &state);
  }

  if(state & GDK_BUTTON1_MASK) {
    //MB1 ist ON
  }
}

state erhaelt den akt. Status; nicht welcher Key veraendert wurde !

vi /usr/include/gdk/gdktypes.h   // siehe GdkModifierType







======================================================================
Compile Linux:
cc -c `gtk-config --cflags` ut_gtk.c

Compile MS-Win:
cl -c /I ..\include ut_gtk.c



======================================================================
*/

#include "../xa/MS_Def0.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// #include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>         // f. GDK_Return

#include "../ut/ut_txt.h"         // fnam_del

#include "../gtk/ut_gtk.h"


#include "../gr/ut_UI.h"







GtkWidget *WinAct, *ButtKett, *ButtKettArr[25];
int       ButtKettAnz;
int       UI_fontsizX, UI_fontsizY;


static int butt_expand = TRUE;

static GtkWidget *UI_List3l, *UI_List3w=NULL;

static GtkWidget *UI_DialogYWin=NULL;

static GtkWidget *UI_DialogYNWin=NULL;
static void      (*UI_DialogYNFunc)();

static GtkWidget *UI_GetTextWin=NULL, *UI_GetTextEnt;
static void      (*UI_GetTextFunc)();



static GtkWidget *UI_act_wi;
static GtkWidget *UI_act_FileSelBox;


static GtkStyle *UI_style_act;
static GtkTooltips *UI_tip;


static int UI_WinposX=0, UI_WinposY=0;



// Prototypes:
void GUI_Notebook_CB (GtkNotebook*, GtkNotebookPage*, guint, void*);




///=====================================================================
  void GUI_Init (char *wtit) {
///=====================================================================
/// Muss der erste Call sein.
/// wtit = Resourcedatei fnam.rc
/// 
///   GUI_Init ("");
///   GUI_Init ("gtk1.rc");
/// 
// 
// Debug-options:
// --g-fatal-warnings      stop on warnings.


  int       i1;

  // char      *argv[]={"gCAD3D","--g-fatal-warnings",NULL};
  // char      **p1;


  printf("GUI_init |%s| %d\n",wtit,strlen(wtit));


#ifdef GTK2
  // gtk_set_locale ();
  gtk_disable_setlocale ();  // sonst Beistrich statt Decimalpunkt !! (LC_ALL)
#endif


  // i1 = 0;
  // while(argv[i1]) {printf(" %d |%s|\n",i1,argv[i1]); ++i1;}



  /* gtk_init (&argc, &argv); */
  i1 = 0;
  gtk_init (&i1, NULL);
  // i1 = 2; p1 = argv; gtk_init (&i1, &p1);  // geht so ned ..


  // Die Styles (Farben, Fonts, Pixmaps ..) aus rc-Datei einlesen
  if (strlen(wtit) > 0) {
    gtk_rc_parse (wtit);
  }


  UI_tip = gtk_tooltips_new();

  // printf("ex GUI_init\n");
  return;
}


///=========================================================================
  void GUI_GetWinPos (int *x, int *y, GtkWidget *w1) {
///=========================================================================
/// ACHTUNG: geht nicht bei MS-Win!!!


  int       x1,y1,sx,sy;
  // GdkWindow *wp;

  printf("GUI_GetWinPos\n");


  // wp = gtk_widget_get_parent_window (GTK_WIDGET(w1));
  // L.148
  //  gtk_widget_get_ancestor ?
  // printf(" get_parent_window OK\n");



  // if(wp) {
    // gdk_window_get_geometry(wp, &x1,&y1,&sx,&sy,&i1);  // L.791
    gdk_window_get_geometry(w1->window, &x1,&y1,&sx,&sy,NULL);  // L.791
    // gdk_window_get_geometry (w1, &x1,&y1,&sx,&sy,NULL);  // L.791
    *x = x1;
    *y = y1;
    // printf("wp=%d,%d\n",x1,y1);
  // }

  printf("ex GUI_GetWinPos=%d,%d\n",*x,*y);

}




///=========================================================================
  void GUI_GetWidgetPos (int *x, int *y, GtkWidget *w1) {
///=========================================================================
///  liefert leider nur die relative Position im Window od Toolbar.
/// 
///     GUI_GetWinPos(&x1, &y1, wcGeo_tb);
///     GUI_GetWidgetPos(&x2, &y2, wcGeo_tb); // rel. Posi des Toolbar
///     x1 += x2;  y1 += y2;
///     GUI_GetWidgetPos(&x2, &y2, parent);
///     x1 += x2;  y1 += y2;
///     GUI_SetWinpos (x1, y1);



  // int       x1,y1,sx,sy,i1;
  // GtkWidget  *win1;
  // GdkWindow *wp;

  // printf("GUI_GetWidgetPos\n");

  *x = GTK_WIDGET(w1)->allocation.x;
  *y = GTK_WIDGET(w1)->allocation.y;

/*
  wp=gtk_widget_get_parent_window (GTK_WIDGET(w1));


  if(wp) {
    gdk_window_get_geometry(wp, &x1,&y1,&sx,&sy,&i1);
    // *x=GTK_WIDGET(wp)->allocation.x;
    // *y=GTK_WIDGET(wp)->allocation.y;
    *x += x1;
    *y += y1;
    printf("wp=%d,%d\n",x1,y1);
  }
*/

  // win1 = gtk_widget_get_toplevel (w1);
  // win1 = gtk_widget_get_ancestor(w1, GTK_TYPE_WINDOW);
  // GUI_GetWinPos (x, y, win1);

  // kann in MS-Win Windowpos nicht lesen; daher absolute Pointerpos holen
  gdk_window_get_pointer (NULL, x, y, NULL);


  // printf("ex GUI_GetWidgetPos=%d,%d\n",*x,*y);

}


///=========================================================================
  void GUI_SetWinpos   (int xpos, int ypos) {
///=========================================================================
/// position only for auxiliary windows !!

  UI_WinposX = xpos;
  UI_WinposY = ypos;

}



///=========================================================================
  int GUI_CB_WinDel (GtkWidget *parent, GdkEvent *event,void(*data)()) {
///=========================================================================

  // printf("GUI_CB_WinDel\n");

  (*data)(NULL, (void*)UI_FuncKill); 

  return TRUE;

}

///=========================================================================
  int GUI_WinTit (GtkWidget *window, char *wtit) {
///=========================================================================

  printf("GUI_WinTit |%s|\n",wtit);

  gtk_window_set_title (GTK_WINDOW (window), wtit);

  return 0;

}


///=========================================================================
  GtkWidget* GUI_Window (char *wtit, void *funcnam, void* data, int border) {
///=========================================================================
/// 
/// wtit:		WindowTitle.
/// funcnam:	wird bei DestroyWindow (mit zugehrigem data) gerufen !
/// border:		wieviel Platz innen (rundum) frei bleiben soll.
/// 
/// winID = GUI_Window ("Line", NULL, NULL, 0);
/// winID = GUI_Window ("Liste", UI_Typ_Ltyp, (void*)UI_FuncKill, 0);
/// 
/// Die Size; normal unnutz.
///   gtk_widget_set_usize (window, 550, 60);
/// 
/// Position setzen:
///   // auf fixe Pos.:
///   gtk_widget_set_uposition (window, 100, 400);
///   // oder auf aktuelle maouspos:
///   gtk_window_set_position (window, GTK_WIN_POS_MOUSE);
/// 
/// Windowtitle nachtraeglich nochmal korrigieren:
///   gtk_window_set_title (GTK_WINDOW (winID), "neuer titel");
/// 
/// Achtung: derzeit kann mit "destroy" und delete_event kein data mitgegeben
///   werden, daher muss eigene Funktion gemacht werden.
/// 
/// allow_grow und allow_shrink in gtk_window_set_policy.


// vi /usr/include/gtk/gtkwindow.h
// vi /usr/include/gtk/gtkmain.h


  GtkWidget *window;

  GdkFont   *wFont;


  printf("GUI_Window |%s|%d|\n",wtit,(int)data);


  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  GUI_WinTit (window, wtit);


  if (border > 0) {
    gtk_container_border_width (GTK_CONTAINER (window), border);
  }


  /* printf("connect exit\n"); */
  if (funcnam) {

    gtk_signal_connect (GTK_OBJECT(window), "destroy",
                     (GtkSignalFunc) funcnam, data);

/*
    // komplett umleiten
    gtk_signal_connect (GTK_OBJECT(window), "delete-event",
                     (GtkSignalFunc) GUI_CB_WinDel, funcnam);
*/
  }

  /* gdk_window_set_cursor (window->window, gdk_cursor_new (GDK_HAND1)); */

  /* gtk_quit_add_destroy (0, GTK_OBJECT(window)); */


  /* Die Size; normal unnutz. */
  /* gtk_widget_set_usize (window, 550, 60); */

  /* welche Position ? */
  // gtk_widget_set_uposition (window, 100, 400);


  /* Ohne eine Box geht nix; */
  /* box0 = GUI_Vbox (window, 0); */




  // geht das auch mit GTK1 ?
  // Style hat farben, Font GdkFont *font, BackgrndPixmap usw
  UI_style_act = gtk_widget_get_style (window);


#ifdef GTK1

  // Breite/Hoehe eines einzelnen Char einlesen. = 7,21
  UI_fontsizX = gdk_char_width (UI_style_act->font, '0');
  UI_fontsizY = gdk_char_height (UI_style_act->font, '0');

#else

  wFont = gtk_style_get_font (UI_style_act);

  // Breite/Hoehe eines einzelnen Char einlesen. = 7,21
  UI_fontsizX = gdk_char_width (wFont, '0');
  UI_fontsizY = gdk_char_height (wFont, '0');

#endif

    // printf("UI_fontsizX/Y=%d,%d\n",UI_fontsizX,UI_fontsizY);
    // printf("fontAsc=%d\n",UI_style_act->font->ascent);
    // exit(0);



  /* return window; */
  WinAct = window;

  // 2007-04-20
  // wird ein window geloescht, werden wahrscheinlich auch einige zum
  // tooltip gehoerige Pointer geloescht; daher:
  UI_tip = gtk_tooltips_new();

  return window;

}



///=====================================================================
  GtkWidget* GUI_Toolbox (GtkWidget *parent) {
//=====================================================================
/// /* vi /usr/include/gtk/gtkhandlebox.h
/// gtk_handle_box_set_handle_position
/// gtk_handle_box_set_snap_edge


  GtkWidget *box1;


  box1 = gtk_handle_box_new ();
  gtk_box_pack_start (GTK_BOX (parent), box1, FALSE, FALSE, 0);
  gtk_widget_show (box1);


  return box1;

}



///=====================================================================
  GtkWidget* GUI_Hbox (GtkWidget *parent, int border) {
///=====================================================================
/// border >= 0: wieviel Platz innen (rundum) frei bleiben soll.
/// border = -1: expand widgets in box; box aber fixed size.
/// 
/// Fr jedes primre Window ist eine primre box notwendig.
/// In Hboxen werden Widgets nebeneinander (Vboxen untereinander) geschlichtet.
/// Wenn mehrere Widgets in einen frame sollen, Box notwendig.
/// 
/// Den Level Vertikal mit Ziffern,  horiz. mit Buchstaben bezeichen.
/// Also abwechselnd Ziffer - Buchstabe.
/// 
/// border: wieviel Platz innen (rundum) frei bleiben soll.
/// 
///   GtkWidget *boxneu;
/// 
///   boxneu = GUI_Hbox (parentbox, 0);

  
  GtkWidget *box1;

  // printf("GUI_Hbox %d\n",border);


  // box1 = gtk_hbox_new (expand, 0);
  // expand: TRUE=anpassen; FALSE=keep size (S.73)
  if(border < 0) {
    box1 = gtk_hbox_new (FALSE, 1);
    gtk_box_pack_start (GTK_BOX (parent),box1, FALSE, FALSE, 0);
    // if(border < -1) {
      // printf("..............resize\n");
      // gtk_widget_set_usize (box1, 500, 0);
    // }
  } else {
    box1 = gtk_hbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (parent), box1);
  }


  

  if (border > 0) {
    gtk_container_border_width (GTK_CONTAINER (box1), border);
  }

  gtk_widget_show (box1);

  return box1;

}



///=====================================================================
  GtkWidget* GUI_Frame (GtkWidget *parent, char* ltxt, int border) {
///=====================================================================
/// Wenn mehrere Widgets in einen frame sollen, Box notwendig!
/// 
/// border: wieviel Platz innen (rundum) frei bleiben soll.
/// 
///   w1 = GUI_Hbox (box0, -1);
///   w2 = GUI_Frame (w1, "FrameTitel", 0);
///   w3 = GUI_Hbox (w2, 1);
///   w_info = GUI_Label (w3, "text", 0);
/// 
/// Optional:
///   gtk_widget_set_usize (frm1, 100, 75);


  GtkWidget *frm1;

  frm1 = gtk_frame_new (ltxt);

  if (border > 0) {
    gtk_container_border_width (GTK_CONTAINER (frm1), border);

  } else if(border < 0) {
    gtk_box_pack_start (GTK_BOX (parent),frm1, TRUE, TRUE, 0);

  } else {
    gtk_container_add (GTK_CONTAINER (parent), frm1);
  }

  gtk_widget_show (frm1);

  UI_act_wi = frm1;
  return frm1;

}



///=====================================================================
  GtkWidget* GUI_Vbox (GtkWidget *parent, int border) {
///=====================================================================
/// border >= 0: wieviel Platz innen (rundum) frei bleiben soll.
/// border = -1: expand widgets in box


  GtkWidget *box1;

  // expand: TRUE=anpassen; FALSE=keep size (S.73)
  // box1 = gtk_vbox_new (expand, 0);
  if(border < 0) {
    box1 = gtk_vbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (parent),box1, FALSE, FALSE, 0);
  } else {
    box1 = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (parent), box1);
  }




  if (border > 0) {
    gtk_container_border_width (GTK_CONTAINER (box1), border);
  }
  gtk_widget_show (box1);


  if(border < -1) {
    gtk_widget_set_usize (box1, -border, -1);
  }

  return box1;

}


///================================================================
  int GUI_VSpace (GtkWidget *parent) {
///================================================================

  GtkWidget  *box0;

  box0 = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (parent),box0, FALSE, FALSE, 10);
  gtk_widget_show (box0);

  return 0;

}

 
///=====================================================================
  GtkWidget* GUI_Hsep (GtkWidget *parent, int border) {
///=====================================================================
/// Hor. Trennlinie.
/// Border: Abstand ober- und unterhalb der Trennlinie.


  GtkWidget *w1;

  w1 = gtk_hseparator_new ();

  // gtk_box_pack_start (GTK_BOX (parent), w1, TRUE, TRUE, border);
  gtk_box_pack_start (GTK_BOX (parent), w1, FALSE, TRUE, border);
  // gtk_box_pack_start (GTK_CONTAINER (parent), w1, FALSE, TRUE, border);
  gtk_widget_show (w1);

  return w1;

}



///=====================================================================
  int GUI_Label_mod (GtkWidget *wlb, char* txt) {
///=====================================================================
/// modify label

  gtk_label_set_text ((GtkLabel*)wlb, txt);

  return 0;

}


///=====================================================================
  GtkWidget* GUI_Label (GtkWidget *parent, char* ltxt, int border) {
///=====================================================================
/// border:  >0:  wieviel Platz innen (rundum) frei bleiben soll.
///          <0:  absoluter Platzbedarf; - fixed size.
/// 
/// Mehrzeilig mit \n im Text.
/// 
/// Text spaeter aendern: GUI_Label_mod
///   gtk_label_set_text ((GtkLabel*) (w_nam), "Neuer Text");
/// 
/// Lable nach links ausrichten: ( , xalign, yalign)
///   gtk_misc_set_alignment (GTK_MISC (label), 0.2, 0.5);
/// 
/// ??
/// gtk_misc_set_padding (GTK_MISC (label), 10, 10);
/// 
/// gtk_widget_set_usize(button, 250, 40);
/// 
/// gtk_label_set_text((GtkLabel*)(lbl), GTK_JUSTIFY_LEFT);
/// // geht ned ?
///   // GTK_JUSTIFY_RIGHT od GTK_JUSTIFY_CENTER
/// 
/// gtk_label_set_text((GtkLabel*)(lbl), GTK_JUSTIFY_FILL);
/// 
/// ??
/// gtk_box_pack_start_defaults(GTK_BOX(vbox), lbl);
/// 
/// gtk_label_set_text ((GtkLabel*) (label), FALSE); //


  int       i1;
  GtkWidget *w1;

  w1 = gtk_label_new (ltxt);

  // expand,fill (S.74/75) 
  // expand: True=fill gesamten Space in box;
  // fill: nur bei expand=TRUE: TRUE=file space by Button, else by space around
  if(border > 0) {
    i1=border;
  } else {
    i1=0;
  }
  // gtk_box_pack_start (GTK_BOX (parent), w1, FALSE, TRUE, i1);
  gtk_box_pack_start (GTK_BOX (parent), w1, FALSE, FALSE, i1);

  // gtk_container_add (GTK_CONTAINER (parent), w1);

  gtk_widget_show (w1);

  // gtk_widget_set_usize (w1, strlen(ltxt)*3, 0);

  if(border < 0) {
    gtk_widget_set_usize (w1, -border, 0);
  }

  UI_act_wi = w1;
  return w1;

}


///================================================================
  int GUI_CkButt_get (GtkWidget *cb) {
///================================================================
/// returns state of checkbox; 0=not sel, 1=selected.
 
  return GTK_TOGGLE_BUTTON (cb)->active;

}


///=====================================================================
  GtkWidget* GUI_CkButt (GtkWidget *parent, char* ltxt, int state,
				void *funcnam, void *data, int border) {
///=====================================================================
/// Checkbox.
/// state: Vorbelegeung - int, 0=not checked; TRUE od FALSE.
/// 
/// ---------------------------
/// Beispiel nur auslesen, kein callback:
/// 
///   int istate;
///   GtkWidget  *cb1;
///   cb1 = GUI_CkButt (box0, "ckb 1", TRUE, NULL, NULL, 0);
///   istate = GUI_CkButt_get (cb1)        // 0=not sel, 1=selected.
/// 
/// 
/// ---------------------------
/// Beispiel mit callback:
/// 
///   w1=GUI_CkButt (box0, "ckb 1", w1s, f_ckbutt, NULL, 0);
/// 
/// int f_ckbutt (GtkWidget *parent, void *data) {
/// 
///   if (GTK_TOGGLE_BUTTON (parent)->active) goto L_activate;
///   printf("f_ckbutt disactivate\n");
///   ..
///   L_activate:
///   ..
/// }
/// 
/// ---------------------------
/// Optional:
/// 
/// Drcken mit:
///   gtk_toggle_button_toggled (ckb1);
///   gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (ckb1), TRUE);



  int i1;


  UI_act_wi = gtk_check_button_new_with_label (ltxt);

  // if (state == TRUE) {
    gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (UI_act_wi), state);
  // }

  if (funcnam) {
    gtk_signal_connect (GTK_OBJECT (UI_act_wi), "clicked",
                      (GtkSignalFunc) funcnam, data);
  }

  gtk_container_add (GTK_CONTAINER (parent), UI_act_wi);
  // NICHT mit gtk_box_pack_start !

  // gtk_misc_set_alignment geht nicht ..
  
  gtk_widget_show (UI_act_wi);

  return UI_act_wi;

}


///======================================================================
  GtkWidget* GUI_MenuRadButt    (GtkWidget *parent, char* ltxt) {
///======================================================================

  GtkWidget *w1;



  w1 = gtk_radio_menu_item_new_with_label (NULL, ltxt);

/*
  if (funcnam) {
    gtk_signal_connect (GTK_OBJECT (w1), "activate",
                      (GtkSignalFunc) funcnam, data);
  }
*/


  gtk_menu_append (GTK_MENU(parent), w1);
  gtk_widget_show (w1);


  UI_act_wi = w1;
  return w1;

}


///======================================================================
	GtkWidget* GUI_MenuRadButtAdd (GtkWidget *parent, char* ltxt) {
///======================================================================


  GtkWidget *w1;



  w1 = gtk_radio_menu_item_new_with_label (
                      gtk_radio_menu_item_group(
                      GTK_RADIO_MENU_ITEM(UI_act_wi)),
                      ltxt);

/*
  if (funcnam) {
    gtk_signal_connect (GTK_OBJECT (w1), "activate",
                      (GtkSignalFunc) funcnam, data);
  }
*/


  gtk_menu_append (GTK_MENU(parent), w1);
  gtk_widget_show (w1);


  UI_act_wi = w1;
  return w1;

}


///=====================================================================
  GtkWidget* GUI_RadButt (GtkWidget *parent, char* ltxt,
				void *funcnam, void *data, int border) {
///=====================================================================
/// Radiobuttons:
/// get state:
///   printf("ckb1 = %d\n", GTK_TOGGLE_BUTTON (ckb1)->active);  // 1=ON;0=OFF
/// 
/// activate:
///   gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON  (bA), TRUE);
///   // skip disactivation ..
///   if(GTK_TOGGLE_BUTTON (parent)->active == 0) return 0;  // 1=ON;0=OFF
///   oder
///   if(GTK_TOGGLE_BUTTON (ckb1)->active == 0) return 0;  // 1=ON;0=OFF



  /* int       i1; */
  GtkWidget *w1;
  /* GSList    *g1; */

  /* printf("GUI_RadButt\n"); */

  w1 = gtk_radio_button_new_with_label (NULL, ltxt);

  if (funcnam) {
    gtk_signal_connect (GTK_OBJECT (w1), "clicked",
                      (GtkSignalFunc) funcnam, data);
  }

  // gtk_container_add (GTK_CONTAINER (parent), w1);
  gtk_box_pack_start (GTK_BOX (parent), w1, FALSE,FALSE,0);
  // gtk_box_pack_start (GTK_BOX (parent), w1, TRUE, TRUE, border);

  if(border < 0) {
     gtk_widget_set_usize (w1, -border, 0);  // size in pixel x,y.
  }

  gtk_widget_show (w1);

  ButtKett = w1;

  ButtKettAnz = 0;
  ButtKettArr[ButtKettAnz] = w1;

  UI_act_wi = w1;
  return w1;

}


///=====================================================================
  GtkWidget* GUI_RadButtAdd (GtkWidget *parent, char* ltxt,
				void *funcnam, void *data, int border) {
///=====================================================================
// Radiobuttons.
///   GUI_RadButt    (box0, "button1",f_radbutt,(void*)0,0);
///   GUI_RadButtAdd (box0, "button2",f_radbutt,(void*)1,0);
///   GUI_RadButtAdd (box0, "button3",f_radbutt,(void*)2,0);
/// 
///   int f_radbutt (GtkWidget *parent, void *data) {
///     if ((GTK_TOGGLE_BUTTON (parent)->active) == 0) {
///       printf("skip pt disactivation\n");
///       goto Fertig;
///     }
///     ..........
///   }
/// 
/// activate:    (deaktiviert den momentan aktiven Button):
///   gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (w2), TRUE);
/// oder
///   GUI_RadButtSet
/// Auslesen mit (liefert nur 0 oder 1):
///   printf("ckb1 = %d\n", GTK_TOGGLE_BUTTON (parent)->active);   // 1=ON;0=OFF
/// 
/// Ruft funcnam eigentlich 2-mal; einmal deactive voher aktiven Button, dann
/// 	activate new Buttton.


  /* int       i1; */
  GtkWidget  *w2;
  /* GSList    *g1; */

  /* printf("GUI_RadButtAdd\n"); */

  w2 = gtk_radio_button_new_with_label
         (gtk_radio_button_group (GTK_RADIO_BUTTON (ButtKett)), ltxt); 

  if (funcnam) {
    gtk_signal_connect (GTK_OBJECT (w2), "clicked",
                      (GtkSignalFunc) funcnam, data);
  }

  /* gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (w2), FALSE); */

  // gtk_container_add (GTK_CONTAINER (parent), w2);
  gtk_box_pack_start (GTK_BOX (parent), w2, FALSE,FALSE,0);
  // gtk_box_pack_start (GTK_BOX (parent), w2, TRUE, TRUE, border);

  if(border < 0) {
     gtk_widget_set_usize (w2, -border, 0);  // size in pixel x,y.
  }

  gtk_widget_show (w2);

  ButtKettAnz++;
  ButtKettArr[ButtKettAnz] = w2;
  ButtKett = w2;

  // printf("GUI_RadButtAdd %d %d\n",ButtKettAnz,ButtKettArr[ButtKettAnz]);

  UI_act_wi = w2;
  return w2;

}


///=====================================================================
  void GUI_RadButtSet (int ind) {
///=====================================================================


  // printf("GUI_RadButtSet %d %d\n",ind,ButtKettArr[ind]);
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (ButtKettArr[ind]), TRUE);

}




///=====================================================================
  void GUI_OptMenActivate (GtkWidget *w1, int ind) {
///=====================================================================


  // set startindex; 0=erster, 2=dritter ...
  gtk_option_menu_set_history (GTK_OPTION_MENU (w1), ind);


}



///=====================================================================
  void GUI_OptMenChg (GtkWidget *parent, char *optLst[], void* funcnam) {
///=====================================================================
/// 
/// Change the menu of existing OptionMenu.
/// 
/// gtk_option_menu_remove_menu ??
/// 
/// Windows: vor dem beladen aktivieren, sonst immer inaktiv !!
/// 
///   char *optLst[]={"A1","A2",""};
/// 
/// vi /usr/include/gtk/gtkoptionmenu.h
/// vi /usr/include/gtk/gtkmenu.h
/// vi /usr/include/gtk/gtkmenuitem.h
/// vi /usr/include/gtk/gtkitem.h


  int    i1;
  GtkWidget *menu=NULL, *item;



/*
gtk_object_destroy ()
gtk_object_destroy(
gtk_type_free().
*/

  // printf("GUI_OptMenChg\n");



  menu = GTK_OPTION_MENU (parent)->menu;
  item = GTK_OPTION_MENU (parent)->menu_item;


  // delete previous List
  if(menu != NULL) {
    gtk_option_menu_remove_menu (GTK_OPTION_MENU(parent));
    // gtk_object_destroy (GTK_OBJECT (menu)); // od gtk_widget_destroy ?
    // gtk_object_destroy (GTK_OBJECT (item)); // od gtk_widget_destroy ?
  }


  // if(menu == NULL) {
    menu = gtk_menu_new();
    // gtk_widget_set_usize (menu, 100, 0);  // size in pixel x,y.
    // gtk_menu_detach(menu); // NEIN !!
  // }
  


  i1=0;


  // poulate list
  if(optLst) {
    while (optLst[i1]) {
      // printf(" optLst[%d]=|%s|\n",i1,optLst[i1]);
      if(strlen(optLst[i1]) < 1) break;
  
      item = gtk_menu_item_new_with_label (optLst[i1]);
      // gtk_widget_set_usize (item, 60, 0);  // size in pixel x,y.
  
      // clicked,selection_changed gehen nicht?
      gtk_signal_connect (GTK_OBJECT (item), "activate",
                        (GtkSignalFunc) funcnam, (void*)i1);
  
      gtk_menu_append (GTK_MENU (menu), item);
      gtk_widget_show (item);
  
      ++i1;
    }



  // } else {
    // printf(" init option_menu\n");
    // item = gtk_menu_item_new_with_label (" ");
    // gtk_widget_set_usize (item, 100, 0);  // size in pixel x,y.
    // gtk_menu_append (GTK_MENU (menu), item);
    // gtk_widget_show (item);

  }



  gtk_option_menu_set_menu (GTK_OPTION_MENU (parent), menu);

  return;

}


///=====================================================================
  GtkWidget* GUI_OptMen (GtkWidget *parent, char *optLst[], void* funcnam,
                         int border) {
///=====================================================================
/// OptionMenu ist eine Liste wie ComboBox, aber ohne Eingabemoeglichkeit.
/// funcnam wird mit dem Index der gewaehlten Zeile gerufen
/// Abfrage der aktiven Zeile nicht moeglich; nur via Callback funcnam.
///
/// parent     parentBox
/// optLst     a null-terminated list of words; NULL for empty List.
/// funcnam    callback-function
/// border     if negativ: width of list in pixels
///            pos:  fixed pos; 16 bit dx, 16 bit dy.  (dx + (dy << 16);)
/// 
/// AuxFunctions:
///   GUI_OptMenChg      Load/Modify list later ..
///   GUI_OptMenActivate     preselect a listEntry
/// 
/// Examples:
///   char *optLst[]={"Jaenner","Februar","Maerz",NULL};
/// 
///   GUI_OptMen  (box0, optLst, OptMen_CB, 0);
/// 
/// //=====================================================================
///   int OptMen_CB (GtkWidget *parent, void *data) {
/// //=====================================================================
/// 
///   printf("OptMen_CB sel. Line = |%d|\n",(int)data);
///   return 0;
/// 
/// }
/// ----------------------------------------------------------------------
// vi /usr/include/gtk/gtkoptionmenu.h
// gtk_option_menu_new S.469



typedef union {long i4; short i2[2];} uni_i4i2;

  static GtkWidget *w1, *box1;
  uni_i4i2  i2;
  int       iy;


  // printf("OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO \n");
  // printf("GUI_OptMen %d\n",border);


  w1 = gtk_option_menu_new ();

  GUI_OptMenChg (w1, optLst, funcnam);


  if(border > 0) {
    // horizPosition geht mit h/vbox nicht;
    box1 = gtk_fixed_new ();
    gtk_container_add (GTK_CONTAINER (parent), box1);
    gtk_widget_show (box1);
    if(border > 65535) {
      iy = border >> 16;
      border = border & 65535;
      // printf(" dx=%d dy=%d\n",border, iy);
    } else {
      iy = 0;
    }
    gtk_fixed_put (GTK_FIXED (box1), w1, border, iy);
    // gtk_widget_show (box1);


  } else if(border == 0) {
    
    gtk_box_pack_start (GTK_BOX (parent), w1, FALSE, FALSE, 0);


  } else if(border < 0) {
     // gtk_box_pack_start (GTK_BOX (parent), w1, FALSE, FALSE, 0);
     gtk_widget_set_usize (w1, -border, 0);  // size in pixel x,y.
     gtk_box_pack_start (GTK_BOX (parent), w1, TRUE, TRUE, 0);
  }



  // gtk_widget_set_usize (w1, 100, 0);
  gtk_widget_show (w1);


  UI_act_wi = w1;

  return w1;

}



///=====================================================================
  GtkWidget* GUI_Combo (GtkWidget *parent, void *funcnam, int border) {
///=====================================================================
/// ONLY FOR DEMONSTRATION PURPOSES !!!
/// 
///   // Auslesen der aktiven Zeile:
///   char *txt;
///   txt = gtk_entry_get_text ((GtkEntry*) (GTK_COMBO (cm1)->entry));
/// 
///   // Listindex scheinbar nicht in der COMBO-struct.
///   // gehen NICHT:
///   // printf("    ind= %d\n",GTK_COMBO (cm1)->list_change_id);
///   //ind = gtk_list_child_position(GTK_LIST(GTK_COMBO(cm1)->list),
///   //      GTK_WIDGET(GTK_LIST(GTK_COMBO(cm1)->list)->last_focus_child));
///   // printf("    ind= %d\n",ind);
///   // printf("    ind= %d\n",GTK_LIST(GTK_COMBO(cm1)->list)->vtimer);
/// 
/// 
/// vi /usr/include/gtk/gtkcombo.h
/// vi /usr/include/glib-1.2/glib.h   //g_list...



  // GtkWidget *list;

  static GtkWidget *w1;

  GList *entLst = NULL;



  // create doubly linked list /usr/include/glib./glib.h
  // vi /usr/include/gtk/gtklist*
  entLst = g_list_append (entLst, "Point");
  entLst = g_list_append (entLst, "Line");
  entLst = g_list_append (entLst, "Circ");



  // list = gtk_list_new ();


  w1 = gtk_combo_new ();

  gtk_combo_set_popdown_strings (GTK_COMBO(w1), entLst);


  // clicked gibts fuer ?? nicht.
  // "selection_changed",   gibts fuer ?? nicht.
  // "activate", kommt nur mit CR
  // Koennte man einen Event ais das List-click setzen ?
  // gtk_signal_connect (GTK_OBJECT (GTK_COMBO (w1)->entry),
  gtk_signal_connect (GTK_OBJECT (GTK_COMBO (w1)->entry),
                      "activate", // kommt nur mit CR
                      GTK_SIGNAL_FUNC (funcnam), NULL);


  // nur damit kommt jedes CR als Event !!
  gtk_combo_disable_activate (GTK_COMBO (w1));


  // Zeile # 3 vorwaehlen ..
  // gtk_list_select_item (GTK_LIST (GTK_COMBO (w1)->list), 2);


  // geht nur einmal
  // gtk_entry_set_text ((GtkEntry*) (GTK_COMBO (w1)->entry), "def");

  gtk_box_pack_start (GTK_BOX (parent), w1, FALSE, FALSE, border);
  gtk_widget_show (w1);


  // gtk_widget_set_sensitive (w1, (gint)0);

  g_list_free (entLst);

  // gtk_combo_set_value_in_list(w1, 2, TRUE); // ????

  return w1;
}


///================================================================
  int GUI_Entry_set (GtkWidget* entry, char* text) {
///================================================================
/// set text in entryField

  gtk_entry_set_text ((GtkEntry*)entry, text);

  return 0;

}


///================================================================
  char* GUI_Entry_get (GtkWidget* entry) {
///================================================================
/// get text from entryField - gives back a Pointer !

  return gtk_entry_get_text((GtkEntry*)entry);

}

 
///=====================================================================
  GtkWidget* GUI_Entry (GtkWidget *parent, char* ltxt, char* etxt,
				void *funcnam, int border) {
///=====================================================================
/// 
/// ltxt: Labeltext; NULL oder "": keiner.
/// etxt: Text im Entryfeld; NULL oder "": keiner.
/// funcnam: liefert alle Keypress & FocusIn-Events (Keiner: NULL)
/// border < 0: entSiz direkt, sonst via len von etxt
/// 
/// 
/// Per Programm setzen (kann man scheinbar nur einmal, mehrmals geht nicht!)
///   GUI_Entry_set (GtkWidget* entry, char* text);
///   (gtk_entry_set_text ((GtkEntry*) (w_nam), "newText");)
/// 
/// Auslesen mit:
///   char* text = GUI_Entry_get (GtkWidget* entry);
///   (char* gtxt = gtk_entry_get_text ((GtkEntry*) (w_nam));  // KEIN free !!)
/// 
/// Callbackroutine ca.:
/// 
/// //=====================================================================
///   int IE_cad_Ent1_CB (GtkWidget *parent, GdkEventAny *event) {
/// //=====================================================================
/// 
/// #include <gdk/gdkkeysyms.h>         // f. GDK_Return
/// 
///   char     *txt;
/// 
///   // if(event->type == GDK_FOCUS_CHANGE) return;
///   if(event->type != GDK_KEY_PRESS) return;
/// 
///   switch (((GdkEventKey*)event)->keyval) {
/// 
///     case GDK_Return:
///     case GDK_Tab:
///       txt = gtk_entry_get_text ((GtkEntry*) (parent));
///       // g_free (txt);  // damit Absturz !!
///       break;
///   }
/// 
///   return FALSE;  // do defaultOperations (set focus to this field)
///   // return TRUE;  // do no defaultOperations
/// 
/// }
/// 
/// vi /usr/include/gtk/gtkentry.h


  int    i1;
  static GtkWidget *w1, *w2, *box1;


  if (ltxt) {
    /* printf("Labelext /%s/\n",ltxt); */
    box1 = GUI_Hbox (parent, -1);
    w2 = gtk_label_new (ltxt);
    gtk_container_add (GTK_CONTAINER (box1), w2);
    // gtk_box_pack_start (GTK_BOX (parent), w2, TRUE, TRUE, 0);
    gtk_widget_show (w2);
  } else {
    box1 = parent;
  }


  w1 = gtk_entry_new (); 


  if (funcnam) {

    // gtk_widget_set_events (GTK_WIDGET(w1),
                        // GDK_KEY_PRESS_MASK);

    // gtk_signal_connect (GTK_OBJECT (w1),
                        // "key_press_event",
                        // (GtkSignalFunc) funcnam, NULL);

    g_signal_connect (G_OBJECT (w1),
                        "key-press-event",
                        G_CALLBACK (funcnam), NULL);

    g_signal_connect (G_OBJECT (w1),
                        "focus-in-event",
                        G_CALLBACK (funcnam), NULL);

                        // "focus-out-event",
                        // "leave-notify-event",
                        // "populate-popup",  ??

  }


  // preset Text
  i1 = 0;
  if(etxt) i1 = strlen(etxt);
  if(i1 > 0) {
    /* printf("preset Text /%s/\n",etxt); */
    gtk_entry_set_text ((GtkEntry*) (w1), etxt);
  }


  // gtk_box_pack_start (GTK_BOX (box1), w1, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (box1), w1, FALSE, TRUE, 0);

  gtk_widget_show (w1);

/*
  // Macht einen Absturz !!!
  // Achtung; geht erst nach gtk_widget_show!
  if(i1 > 0) {
    // printf("len %d\n",i1);
    // i2 = i1 * UI_fontsizX;
    UI_style_act = gtk_widget_get_style (w1);
    UI_fontsizX = gdk_char_width (UI_style_act->font, '0');
    i2 = gdk_string_width (UI_style_act->font, etxt) + UI_fontsizX;
    gtk_widget_set_usize (w1, i2, 0);  // size in pixel x,y.
  }
*/


  // (wid, x, y); y=0automat; bei x geht das nicht
  if(border < 0) {
    gtk_widget_set_usize (w1, -border, 0);
  } else {
    // gtk_widget_set_usize (w1, (i1*6)+5, 0);            // GTK1 !?
    gtk_widget_set_usize (w1, (i1*UI_fontsizX)+5, 0);
  }

  // Text nach links ausrichten: gtk_misc_set_alignment geht nicht! (nur label


  UI_act_wi = w1;
  return w1;

}




///=====================================================================
  int GUI_DialogYN_CB (GtkWidget *parent, void *data) {
///=====================================================================

  int idat;

  // printf("GUI_DialogYN_CB %d\n",(int)data);

  idat = (int)data;


/*
  if ((GTK_TOGGLE_BUTTON (parent)->active) == 0) {
    printf("skip disactivation\n");
    return 0;
  }
*/


      gtk_widget_destroy (UI_DialogYNWin);
      UI_DialogYNWin=NULL;

  GUI_update__(); // update pending events ..

  switch(idat) {

    case UI_FuncOK:
      (*UI_DialogYNFunc) (NULL, (void*)idat);
      // (*UI_DialogYNFunc) (NULL, data);
      break;

    case UI_FuncCancel:
      (*UI_DialogYNFunc) (NULL, (void*)idat);
      // (*UI_DialogYNFunc) (NULL, data);
      break;
    default:;
  }


      // gtk_widget_destroy (UI_DialogYNWin);
      // UI_DialogYNWin=NULL;

  return 0;
} 




///=====================================================================
  void GUI_DialogYN (char* text, void *funcnam ) {
///=====================================================================
/// Ein Textausgabefenster mit einem OK-Button und einem Cancel-Butten.
/// The callbackfunction is called with int-value UI_FuncOK or UI_FuncCancel.
/// 
/// Mehrzeilig mit \n im Text.
/// 
/// Beispiel:
///   GUI_DialogYN ("OK to save file xy", f_CB_save);
/// 
/// 
/// //=====================================================================
///   int f_CB_save (GtkWidget *parent, void *data) {
/// //=====================================================================
/// 
///   int idat;
/// 
///   printf("f_CB_save %d\n",(int)data);
/// 
///   idat = (int)data;
/// 
///   switch(idat) {
/// 
///     case UI_FuncOK:
///       // save ...
///       break;
/// 
///     case UI_FuncCancel:
///       // skip saving ...
///       break;
///   }
/// 
///   return 0;
/// 
/// }


  static GtkWidget *box0, *box1;


  // printf("UI_DialogYN |%s|\n",text);


  if(UI_DialogYNWin != NULL) {
    GUI_DialogYN_CB (NULL, (void*)UI_FuncKill);
  }


      UI_DialogYNWin=GUI_Window("Info-Window",NULL,NULL,0);

      // UI_DialogYNWin=GUI_Window("Info-Window",GUI_DialogYN_CB,
                               // (void*)UI_FuncKill,0);

      // gtk_widget_set_uposition (UI_DialogYNWin, UI_WinposX, UI_WinposY);
      // gtk_window_set_position (GTK_WINDOW(UI_DialogYNWin), GTK_WIN_POS_MOUSE);
      gtk_window_set_position (UI_DialogYNWin, GTK_WIN_POS_MOUSE);


      box0 = GUI_Vbox (UI_DialogYNWin, 0);

      GUI_Label (box0, text, 10);
      GUI_Hsep (box0, 0);


      box1 = GUI_Hbox (box0, 0);
      GUI_Butt (box1, "OK",    GUI_DialogYN_CB, (void*)UI_FuncOK, 5);
      GUI_Butt (box1, "Cancel",GUI_DialogYN_CB, (void*)UI_FuncCancel, 5);

      UI_DialogYNFunc=funcnam;
      gtk_widget_show (UI_DialogYNWin);



  return;

}


///=====================================================================
  int GUI_DialogY_CB (GtkWidget *parent, void *data) {
///=====================================================================

  gtk_widget_destroy (UI_DialogYWin);
  UI_DialogYWin=NULL;

  return 0;
}



///=====================================================================
  void GUI_DialogY (char* text) {
///=====================================================================
/// Ein einfaches Textausgabefenster mit einem OK-Button zum Beenden.
/// 
/// Beispiel:
///   GUI_DialogY (" - Directory does not exist");


  static GtkWidget *box0;



  if(UI_DialogYWin != NULL) {
    GUI_DialogY_CB (NULL, (void*)UI_FuncKill);
  }


      UI_DialogYWin=GUI_Window("Info-Window",GUI_DialogY_CB,
                               (void*)UI_FuncKill,0);


      box0 = GUI_Vbox (UI_DialogYWin, 0);

      GUI_Label (box0, text, 0);

      GUI_Butt (box0, "OK",    GUI_DialogY_CB, (void*)UI_FuncWork, 5);

      gtk_widget_set_uposition (UI_DialogYWin, UI_WinposX, UI_WinposY);
      gtk_widget_show (UI_DialogYWin);
      // break;


  return;


}



///=====================================================================
  void GUI_Dialog (GtkWidget *widget, char* dialogtext) {
///=====================================================================
/// Ein einfaches Textausgabefenster mit einem OK-Button zum Beenden.
/// DOES NOT WAIT
/// 
/// Beispiel:
///   GUI_Dialog (NULL, " - Directory does not exist");
///   GUI_Butt (box2,"DialogWindow",GUI_Dialog,"Hugo, mach was",0);


  GtkWidget *window, *label, *bw1;

  window = gtk_dialog_new ();

  // an die momentane Mausposi
  // gtk_window_set_position (GTK_WINDOW(window), GTK_WIN_POS_MOUSE);
  gtk_window_set_position (window, GTK_WIN_POS_MOUSE);

  bw1 = gtk_button_new_with_label ("OK");
  gtk_signal_connect_object (
             GTK_OBJECT (bw1),
             "clicked", (GtkSignalFunc) gtk_widget_destroy,
             GTK_OBJECT (window));
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (window)->action_area), bw1,
                         TRUE, TRUE, 0);
  gtk_widget_show (bw1);


  label = gtk_label_new (dialogtext);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (window)->vbox), label, TRUE,
                      TRUE, 0);
  gtk_widget_show (label);

  gtk_window_set_title (GTK_WINDOW (window), "Info");

  gtk_widget_show (window);

}


///================================================================
  int GUI_ColSel (void *parent, void *mode) {
///================================================================
/// mode muss eine Callback-Function sein; zB:
/// GUI_Butt (box0, " colDialog ", GUI_ColSel, col_CB, -5);
///  int col_CB (ColRGB *cSel) {
///    printf("col_CB %d %d %d\n",cSel->cr,cSel->cg,cSel->cb);
///    return 0;
///  }



// Typ_Color
typedef struct {unsigned cr:8, cg:8, cb:8, typ:8;}                  ColRGB;


  static GtkWidget  *colSel;
  static void       (*cb_func)(ColRGB*);

  GtkColorSelection *col1;
  double   da[4];
  ColRGB   cSel;


  printf("GUI_ColSel %d\n",(int)mode);


  if((int)mode == 1) {      // OK-clicked

    col1=GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(colSel)->colorsel);

    gtk_color_selection_get_color (col1, da);

    // printf(" %f %f %f\n",da[0],da[1],da[2],da[3]);
    cSel.cr = da[0] * 255;
    cSel.cg = da[1] * 255;
    cSel.cb = da[2] * 255;
    printf(" %d %d %d\n",cSel.cr,cSel.cg,cSel.cb);
    cb_func (&cSel);
    gtk_widget_destroy (colSel);
    return 0;

  }


  if((int)mode == 2) {               // Cancel clicked
    gtk_widget_destroy (colSel);
    return 0;
  }

  // Init ...

  colSel = gtk_color_selection_dialog_new (" select Modelcolor");

  gtk_signal_connect(
    GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(colSel)->ok_button),
    "clicked", (GtkSignalFunc)GUI_ColSel, (void*)1);

  gtk_signal_connect(
    GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(colSel)->cancel_button),
    "clicked", (GtkSignalFunc)GUI_ColSel, (void*)2);

  gtk_widget_show_all(colSel);

  cb_func = mode; // die callback-func

  return 0;

}


///=====================================================================
  int GUI_GetxText_get (char *txout) {
///=====================================================================


  char   *txt;

  // work ..
  txt = (char*)gtk_entry_get_text ((GtkEntry*) (UI_GetTextEnt));
  // printf("   |%s|\n",txt);
  strcpy(txout, txt);


  gtk_widget_destroy (UI_GetTextWin);
  UI_GetTextWin=NULL;

    printf("ex GUI_GetxText_get |%s|\n",txout);


  return 0;

}


///=====================================================================
  int GUI_GetxText_CB (GtkWidget *parent, void *data) {
///=====================================================================

  int    i1;
  char   *txt;


  printf("GUI_GetxText_CB %d\n",(int)data);

  i1 = (int)data;



  switch (i1) {



    //---------------------------------------------------------
    // Kill win.  ES MUSS tx FERTIG KOPIERT SEIN !!!
    case UI_FuncKill:
      if(UI_GetTextWin != NULL)
      gtk_widget_destroy (UI_GetTextWin);
      UI_GetTextWin=NULL;
      return 0;

/*
    //---------------------------------------------------------
    // cancel - button
    case UI_FuncCancel:
      txt = NULL;
      (*UI_GetTextFunc) (parent, (void*)txt);
      break;
*/

    default:
      return 0;

  }


  return 0;

}


///============================================================================
  int GUI_GetxText (char *label,char *text,int wSiz,void* funcnam,void* data) {
///============================================================================
/// Query text from user.
/// label = text left of entryfield.
/// text  = predefined text in entryfield.
/// wsiz  = size of entryfield
/// funcnam = callbackfunction if OK clicked; Cancel: NO callback !
///
/// Example:
///
///   // ask for input
///   GUI_GetxText("keyIn","text", -200, my_CB, (void*)UI_FuncUCB1);
///   ...
/// }
///
/// //=================================================================
///   int my_CB (GtkWidget *parent, void *data) {
/// //=================================================================
/// // the callback if OK selected.
///   char cbuf[256];
///
///
///   if(data == NULL) return; // Cancel ?
///
///   printf("my_CB |%s|\n",(int*)data);
///
///   if ((int)(int*)data == UI_FuncUCB1) {
///     // get keyIn & kill Window
///     GUI_GetxText_get (cbuf);
///   }
///
///   return 0;
///
/// }

 static GtkWidget *box0, *box1;


  printf("GUI_GetxText \n");


  if(UI_GetTextWin != NULL) {
    // gtk_widget_destroy (UI_GetTextWin);
    GUI_GetxText_CB (NULL, (void*)UI_FuncKill);
  }


      UI_GetTextWin = GUI_Window("Text Input", NULL, NULL, 0);
      // UI_GetTextWin=GUI_Window("Text Input",GUI_GetText_CB,
                               // (void*)UI_FuncKill,0);
                               // gtk_widget_destroy, 0);
                               // NULL, 0);


      box0 = GUI_Vbox (UI_GetTextWin, 0);

      UI_GetTextEnt = GUI_Entry (box0,label,text,NULL, wSiz);

      GUI_Hsep (box0, 0);

      box1 = GUI_Hbox (box0, 0);

      GUI_Butt (box1, "OK",    funcnam, data, 5);
      GUI_Butt (box1, "Cancel",GUI_GetxText_CB, (void*)UI_FuncKill, 5);

      // an momentane Mauspos (GTK2: call before show)
      gtk_widget_set_uposition (UI_GetTextWin, UI_WinposX, UI_WinposY);
      // gtk_window_set_position (GTK_WINDOW(UI_GetTextWin), GTK_WIN_POS_MOUSE);
      // gtk_window_set_position (UI_GetTextWin, GTK_WIN_POS_MOUSE);

      gtk_widget_show (UI_GetTextWin);
      // break;



  gtk_widget_grab_focus (UI_GetTextEnt);
  // GUI_WinUp


  return 0;

}


///=====================================================================
  int GUI_GetText_CB (GtkWidget *parent, void *data) {
///=====================================================================

  int    i1;
  char   *txt;


  printf("GUI_GetText_CB %d\n",(int)data);

  i1 = (int)data;



  switch (i1) {



    //---------------------------------------------------------
    case UI_FuncWork:
      // printf("GUI_GetText_CB work\n");

      // work ..
      txt = (char*)gtk_entry_get_text ((GtkEntry*) (UI_GetTextEnt));
      // printf("   |%s|\n",txt);

      (*UI_GetTextFunc) (parent, (void*)txt);
      break;


    //---------------------------------------------------------
    // Kill win.  ES MUSS tx FERTIG KOPIERT SEIN !!!
    case UI_FuncKill:
      if(UI_GetTextWin != NULL)
      gtk_widget_destroy (UI_GetTextWin);
      UI_GetTextWin=NULL;
      return 0;


    //---------------------------------------------------------
    // cancel - button
    case UI_FuncCancel:
      txt = NULL;
      (*UI_GetTextFunc) (parent, (void*)txt);
      break;
  

    default:
      return 0;

  }


  return 0;

}




///=====================================================================
  int GUI_GetText (char *label, char *text, int wSiz, void* funcnam) {
///=====================================================================
/// Query text from user.
/// label = text left of entryfield.
/// text  = predefined text in entryfield.
/// wsiz  = size of entryfield
/// funcnam = callbackfunction if OK clicked; Cancel: NO callback !
/// 
/// Example:
/// 
///   // ask for input
///   GUI_GetText(" Name of Program: ","Nowprog", -200, f_GetText_CB);
///   ...
/// }
/// 
/// //=================================================================
///   int f_GetText_CB (GtkWidget *parent, void *data) {
/// //=================================================================
/// // the callback if OK selected.
/// 
///   if(data == NULL) return; // Cancel ?
/// 
///   printf("f_GetText_CB |%s|\n",(char*)data);
/// 
///   // kill Window; muss explizit geschehen !
///   GUI_GetText_CB (NULL, (void*)UI_FuncKill);
/// 
///   return 0;
///     
/// }   
    


  static GtkWidget *box0, *box1;



  if(UI_GetTextWin != NULL) {
    // gtk_widget_destroy (UI_GetTextWin);
    GUI_GetText_CB (NULL, (void*)UI_FuncKill);
    UI_GetTextWin = NULL;
    // GUI_del_events ();
  }


      UI_GetTextWin=GUI_Window("Text Input", NULL, NULL, 0);
      // UI_GetTextWin=GUI_Window("Text Input",GUI_GetText_CB,
                               // (void*)UI_FuncKill,0);
                               // gtk_widget_destroy, 0);
                               // NULL, 0);


      box0 = GUI_Vbox (UI_GetTextWin, 0);
      box1 = GUI_Hbox (box0, 0);

      UI_GetTextEnt=GUI_Entry (box1,label,text,NULL, wSiz);
      GUI_Hsep (box0, 0);

      box1 = GUI_Hbox (box0, 0);
      GUI_Butt (box1, "OK",    GUI_GetText_CB, (void*)UI_FuncWork, 5);
      GUI_Butt (box1, "Cancel",GUI_GetText_CB, (void*)UI_FuncCancel, 5);

      UI_GetTextFunc=funcnam;

      // an momentane Mauspos (GTK2: call before show)
      // gtk_widget_set_uposition (UI_GetTextWin, UI_WinposX, UI_WinposY);
      // gtk_window_set_position (GTK_WINDOW(UI_GetTextWin), GTK_WIN_POS_MOUSE);
      gtk_window_set_position (UI_GetTextWin, GTK_WIN_POS_MOUSE);

      gtk_widget_show (UI_GetTextWin);
      // break;



  gtk_widget_grab_focus (UI_GetTextEnt);



  return 0;

}



///=====================================================================
  GtkWidget* GUI_Pix (GtkWidget *parent, char* filnam, int border) {
///=====================================================================
/// Pixmap als Hintergrundbild
/// .xpm oder (zumindest Linux) .jpg.


  GtkWidget *pixmapwid;
  GdkPixmap *pixmap;

/*
  GdkBitmap *mask;
  GtkStyle *style;
*/

  GdkBitmap *transparent;



  /* ------------------------------------------ */
  printf("GUI_Pix %s\n",filnam);



/*
  // style = gtk_widget_get_style (parent);
  style = gtk_widget_get_style (WinAct);

  // pixmap = gdk_pixmap_create_from_xpm (parent->window, &mask,
  pixmap = gdk_pixmap_create_from_xpm (WinAct->window, &mask,
                &style->bg[GTK_STATE_NORMAL], filnam);


  pixmapwid = gtk_pixmap_new (pixmap, mask);
*/


  // Methode 2:
  if(OS_checkFilExist(filnam, 0) == 0) {
    return NULL;
  }


  pixmap = gdk_pixmap_colormap_create_from_xpm (NULL,
               gdk_colormap_get_system(),
               &transparent,
               NULL,
               filnam);


  pixmapwid = gtk_pixmap_new (pixmap, transparent);

  gtk_box_pack_start (GTK_BOX (parent), pixmapwid, FALSE, FALSE, border);

  gtk_widget_show (pixmapwid);

  gdk_pixmap_unref (pixmap);

  return pixmapwid;

}


///=====================================================================
  void GUI_Butt_Att (int mode) {
///=====================================================================
/// TRUE: mehrere Buttons sollen die gesamte Breite ihrer Box benutzen.


  butt_expand = mode;

  return;

}


///=====================================================================
  GtkWidget* GUI_Butt (GtkWidget *parent, char* ltext,
                            void *funcnam, void *data, int border) {
///=====================================================================
/// Button.
/// ltext    Beschriftung Button
/// funcnam  wird beim drcken mit data gerufen = callbackfunktion.
/// border   > 0:  freier Raum rund um Button.
///          < 0:  absolut size of Button
/// 
/// GUI_Butt (box0, "TestButton", UI_func1, NULL, 10);
/// 
/// int UI_func1 (GtkWidget *parent, void *data) {
///   ..
/// }
/// 
///   Dzt braucht man (Linux u MS) keine Parameter anzugeben! 
///   Es geht also auch "int UI_func1 () { ..};"
/// 
/// 
/// Disactivate:
/// gtk_widget_set_sensitive (ckb1, (gint)1); //1=activ, 0=inaktiv.
/// 
/// change text:
///   gtk_button_set_label (wButt1, " newText ");



  UI_act_wi = gtk_button_new_with_label (ltext);
  /* gtk_widget_set_name (UI_act_wi, "Style1"); */


  gtk_signal_connect (GTK_OBJECT (UI_act_wi), "clicked",
                      (GtkSignalFunc) funcnam, data);

  // expand,fill (S.74/75) 
  // expand: True=fill gesamten Space in box;
  // fill: nur bei expand=TRUE: TRUE=file space by Button, else by space around
  if(border < 0) {
    // gtk_box_pack_start (GTK_BOX (parent), UI_act_wi, butt_expand, FALSE, 0);
    gtk_box_pack_start (GTK_BOX (parent), UI_act_wi, FALSE, FALSE, 0);
    gtk_widget_set_usize (UI_act_wi, -border, 0);  // size in pixel x,y.
  } else {
    // gtk_box_pack_start (GTK_BOX (parent), UI_act_wi, FALSE, TRUE, border);
    // gtk_fixed_put (GTK_BOX (parent), UI_act_wi, 0,0);
    gtk_container_add (GTK_CONTAINER (parent), UI_act_wi);
    if(border > 0) gtk_container_border_width(GTK_CONTAINER(UI_act_wi), border);
  }
  // gtk_box_pack_start (GTK_BOX (parent), UI_act_wi, FALSE, TRUE, border);

  gtk_widget_show (UI_act_wi);

  return UI_act_wi;

}


///=====================================================================
  void       GUI_Tip         (char* txt) {
///=====================================================================
/// Tooltips fuer das zuletzt erzeugte Objekt UI_act_wi.
/// Zeilentrennung besser automatisch; mit \n gibts eine Leerzeile 
/// \r tut nix \r\n auch nicht.
/// Zum spaeteren Aendern use GUI_SetActW
// Buch S.111


  // GtkTooltips *UI_tip;

  // printf("GUI_Tip |%s|\n",txt);

  // tip = gtk_tooltips_new();

  gtk_tooltips_set_tip (UI_tip, UI_act_wi, txt, NULL);

}


///=====================================================================
  GtkWidget* GUI_GetActW () {
///=====================================================================

  return UI_act_wi;

}


///=====================================================================
  void       GUI_SetActW         (GtkWidget *newAct) {
///=====================================================================
/// ein Widget als aktives Widget setzen;
/// useful for changing GUI_Tip's
/// retrieve w. GUI_GetActW

  UI_act_wi = newAct;

}


///=====================================================================
  void GUI_ButtPix (GtkWidget *parent, char* labeltext, char* filnam,
                      void *funcnam, void *data) {
///=====================================================================
/// Button mit Pixmap und Text erzeugen.


  GtkWidget *box1, *bw1;
  /* GdkPixmap *pixmap; */
  /* GdkBitmap *mask; */
  /* GtkStyle *style; */


  /* ------------------------------------------ */
  bw1 = gtk_button_new ();
  // bw1 = gtk_button_new_with_label ("a");

  gtk_signal_connect (GTK_OBJECT (bw1),
             "clicked", (GtkSignalFunc) funcnam, data);

  gtk_box_pack_start (GTK_BOX (parent), bw1, butt_expand, TRUE, 0);
  // gtk_container_add (GTK_CONTAINER (parent), bw1);

  gtk_widget_show (bw1);



  // Box mit Bild + Text (label) ber od. unter dem Bild
  box1 = GUI_Vbox (bw1, 0);

  GUI_Pix (box1, filnam, 0);

  GUI_Label (box1, labeltext, 0);


}



///===================================================================
  int GUI_File_selGet (char *filnam, void *buttID) {
///===================================================================
/// Den (selektierten) Dateinnamen (samt Pfad!) einlesen)
/// In in data: die WidgetID der FileSelBox.


  GtkWidget *fsb;
  char      *t1;


  // aus buttID die FileSelectionBoxID holen
  // fsb = GTK_BUTTON (buttID)->parent;
  // fsb = GTK_BIN (buttID)->child;
  fsb = UI_act_FileSelBox;


  // den filename (incl. Pfad) holen.
  t1 = (char*)gtk_file_selection_get_filename (GTK_FILE_SELECTION (fsb));
  strcpy(filnam, t1);
  printf("Sel.fn = %s\n",filnam);

  gtk_widget_destroy ((GtkWidget*) fsb);
  
  return 0;

}



///===================================================================
  GtkWidget* GUI_File_select (char *ltxt, void *funcnam) {
//===================================================================
/// Komplett eigenes Fenster zum Selektieren eines Files.
/// Wird nach Fileselekt gelscht.
/// Der gelieferte Filename ist inclusive Dir.
/// 
/// ltxt:  damit kann das Dir. eingestellt werden (soll mit "/" enden).
/// 
///   GUI_File_select ("", UI_open);
/// 
/// 
/// //=============================================
///   int UI_open (GtkWidget *parent, void *data) {
/// //===========
/// 
///   char      *t1, buf[80];
/// 
///   printf("UI_open %d\n", (int)data);
/// 
///   // den filename (incl. Pfad) nach WC_modnam holen.
///   GUI_File_selGet (WC_modnam , parent);
/// 
///   return 0;
/// 
/// }


   GtkWidget *w1;

  printf("GUI_File_select %s}\n",ltxt);

  /* Create a new file selection widget */
  /* Hat automat 3 Buttons; ok_button, cancel_button und help_button */
  w1 = gtk_file_selection_new ("File selection");


  /* Connect the ok_button to file_ok_sel function */
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (w1)->ok_button),
                      "clicked", (GtkSignalFunc) funcnam, w1);

  /* Geht nicht mit normalem gtk_signal_connect; damit kann man nur den */
  /* Cancel-Button lschen. */
  gtk_signal_connect_object (
             GTK_OBJECT (GTK_FILE_SELECTION (w1)->cancel_button),
             "clicked", (GtkSignalFunc) gtk_widget_destroy,
             GTK_OBJECT (w1));


  /* Lets set the filename, as if this were a save dialog, and we are giving
   a default filename */
  if (strlen(ltxt) > 0) {
    gtk_file_selection_set_filename (GTK_FILE_SELECTION(w1), ltxt);
  }

  gtk_widget_set_uposition (w1, UI_WinposX, UI_WinposY);
  gtk_widget_show (w1);


  UI_act_FileSelBox = w1;
  
  return w1;
}


///===================================================================
  int GUI_Popup (char *optLst[], void *funcnam1, void* funcnam2) {
///===================================================================
/// callback funcnam2 if preselect (Cursor over Listentry).  Can be NULL.
/// callback funcnam1 if select (mousebutton)
/// ACHTUNG: funcnam1 unused; 
/// 
/// nach dem GDK_BUTTON_RELEASE kommt nur mehr ein GDK_ENTER_NOTIFY
/// vor dem GDK_UNMAP !!
/// int pop_CB (GtkWidget *widget, GdkEventAny *event, gpointer data) {
///   if(event->type == GDK_BUTTON_RELEASE) { ...
/// 
/// char  *optLst[]={"abc","def","\0"};
/// void funcnam1 (GtkWidget *widget, gpointer data) { }


  int            i1;
  GtkWidget      *wact, *menu;
  // void (*pfc)();

  menu = gtk_menu_new();

  i1=0;


  while (optLst[i1]) {
    // printf(" optLst[%d]=|%s|\n",i1,optLst[i1]);
    if(strlen(optLst[i1]) < 1) break;

    wact = gtk_menu_item_new_with_label (optLst[i1]);

    // GTK1:
    // select-func
    // gtk_signal_connect (GTK_OBJECT (wact), "activate",
                     // (GtkSignalFunc) funcnam1, (void*)i1);

    // preview
    if(funcnam2)
      // // GTK1:
      gtk_signal_connect (GTK_OBJECT (wact), "enter_notify_event",
                     (GtkSignalFunc) funcnam2, (void*)i1);
      // GTK2:
      gtk_signal_connect (GTK_OBJECT(wact), "leave_notify_event",
                     (GtkSignalFunc) funcnam2, (void*)i1);
      // g_signal_connect_swapped (GTK_OBJECT (wact), "enter_notify_event",
                     // G_CALLBACK (funcnam2), GTK_OBJECT (menu));

    gtk_menu_append (GTK_MENU (menu), wact);
    gtk_widget_show (wact);

    ++i1;
  }



  // kommt nie: destroy,delete-event
  if(funcnam2) {
    // i1 = -1;
    // pfc = funcnam2;
    // (*pfc) (NULL, NULL, (void*)i1);   // init funcnam2

    gtk_signal_connect (GTK_OBJECT(menu), "button_release_event",
                     (GtkSignalFunc) funcnam2, NULL);
  }


  //gtk_menu_popup (GTK_MENU(menu), NULL,NULL,NULL,NULL,NULL,NULL);
  gtk_menu_popup (GTK_MENU(menu), NULL,NULL,NULL,NULL,0,0);
  gtk_widget_show (menu);



  return 0;

}


///===================================================================
  double GUI_Slider_get (GtkWidget* wsl1) {
///===================================================================
/// query slider-value

  double  d1;

  d1 = gtk_adjustment_get_value  ((GtkAdjustment*)wsl1);

  // d1 = ((GtkAdjustment*)wsl1)->value;
  return d1;

}


///===================================================================
  void GUI_Slider_set (GtkWidget* wsl1, double newVal) {
///===================================================================
/// change slider-value


  gtk_adjustment_set_value  ((GtkAdjustment*)wsl1, newVal);


/*
  ((GtkAdjustment*)wsl1)->value = newVal;
  // update Slider
  gtk_adjustment_value_changed ((GtkAdjustment*)wsl1);
*/

  return;

}


///===================================================================
  GtkWidget* GUI_Slider__ (GtkWidget *parent, int typ, void *funcnam,
                           double valMin, double valMax, double valStart) {
///===================================================================
/// Input:
///   typ       0=horizontal, 1=vertical.
///   funcnam   callBack-function for moving the slider; NULL = no callback.
/// RetCod:

/// Example without callback:
/// wsl1 = GUI_Slider__ (box1, 0, NULL, 0., 1., 0.5);
/// // query slider-value
/// printf(" sliVal=%f\n",GUI_Slider_get(wsl1));
/// // change slider-value
/// GUI_Slider_set (wsl1, 0.75);

/// Example with callback:
/// wsl1 = GUI_Slider__ (box1, 0, sl_CB, 0., 1., 0.5);
/// int sl_CB (GtkAdjustment *adj1, void *data) {
///   printf("sl_CB %f\n",gtk_adjustment_get_value(adj1));
/// }


  GtkObject     *adj1;
  GtkWidget     *wsc1;

  double        d1;


  // Adjustment (StartVal minVal maxVal incr pageIncr pageSize)
  d1 = (valMax - valMin ) / 100.;
  adj1 = gtk_adjustment_new (valStart, valMin, valMax, d1, 0., 0.);


  // callback for moving the control
  if(funcnam) {
    gtk_signal_connect (GTK_OBJECT(adj1), "value_changed",
                       GTK_SIGNAL_FUNC(funcnam), NULL);
                       // (GtkSignalFunc)gtk_exit, NULL);
  }

  wsc1 = gtk_hscale_new (GTK_ADJUSTMENT(adj1));

  // do not display actual value
  gtk_scale_set_draw_value (GTK_SCALE(wsc1), FALSE);

  gtk_container_add (GTK_CONTAINER(parent), wsc1);
  gtk_widget_show (wsc1);


  return (void*)adj1;

}


///===================================================================
  GtkWidget* GUI_File_selext(char *wtit,char *ltxt,void *funcnam,void* data){
///===================================================================
/// Komplett eigenes Fenster zum Selektieren eines Files.
/// Wird nach Fileselekt geloescht.
/// Der gelieferte Filename ist inclusive Dir.
/// 
/// ltxt:  damit kann das Dir. voreingestellt werden (soll mit "/" enden).
/// 
/// 
///   GUI_File_selext ("WinTit","*.dat", UI_openCB,(void*)"open");
/// 
/// 
/// //===============================================
///   int UI_openCB (GtkWidget *parent, void *data) {
/// //=============
/// 
///   char      *cp1;
/// 
///   cp1 = (char*)data;
/// 
///   // selekt. Dateinamen einlesen
///   GUI_File_selGet (xa_auxbuf1 , parent);
/// 
///   if(!strcmp(cp1, "open")) {
///     ..



   GtkWidget *w1;

  printf("GUI_File_selext |%s|\n",ltxt);


  /* Create a new file selection widget */
  /* Hat automat 3 Buttons; ok_button, cancel_button und help_button */
  w1 = gtk_file_selection_new (wtit);


  /* Connect the ok_button to file_ok_sel function */
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (w1)->ok_button),
                      "clicked", (GtkSignalFunc) funcnam, data);

  /* Geht nicht mit normalem gtk_signal_connect; damit kann man nur den */
  /* Cancel-Button loeschen. */
  gtk_signal_connect_object (
             GTK_OBJECT (GTK_FILE_SELECTION (w1)->cancel_button),
             "clicked", (GtkSignalFunc) gtk_widget_destroy,
             GTK_OBJECT (w1));


  /* Lets set the filename, as if this were a save dialog, and we are giving
   a default filename */
  if (strlen(ltxt) > 0) {
    gtk_file_selection_set_filename (GTK_FILE_SELECTION(w1), ltxt);
  }

  // an momentane Mauspos (GTK2: call before show)
  // geht scheinbar immer in die Screenmitte ..
  // gtk_widget_set_uposition (w1, UI_WinposX, UI_WinposY);
  // gtk_window_set_position (GTK_WINDOW(w1), GTK_WIN_POS_MOUSE);
  gtk_window_set_position (w1, GTK_WIN_POS_MOUSE);

  gtk_widget_show (w1);

  UI_act_FileSelBox = w1;

  return w1;
}


///=====================================================================
  void GUI_List_add (GtkWidget *list, char* item) {
///=====================================================================
/// /usr/include/gtk/gtkscrolledwindow.h


  /* int       i1; */
  GtkWidget *list_item;


  // printf("GUI_List_add |%s|\n",item);


  /* for (i1=0; i1 < 999; i1++) { */
    /* if (!strcmp(item[i1],"\0")) break; */
    /* printf("GUI_List_add %s\n", item[i1]); */
    /* list_item = gtk_list_item_new_with_label (item[i1]); */
    list_item = gtk_list_item_new_with_label (item);

    /* list = g_list_prepend (list, list_item); */

    // gtk_list_append_items (GTK_LIST(list), list_item);
    // g_list_append ((GList*)list, list_item);

    gtk_container_add (GTK_CONTAINER (list), list_item);


    /* gtk_list_item_select (list_item); */

    /* gtk_widget_grab_default (list_item); */

    gtk_widget_show (list_item);

  /* } */

}


///=====================================================================
  void GUI_List_clear (GtkWidget *list, int ianf, int iend) {
///=====================================================================
/// alle loeschen: GUI_List_clear (w_list, 0, 9999);


  gint      i1, i2;
  /* GList     *dlist; */
  /* GtkWidget *list_item; */


  // printf("GUI_List_clear %d %d\n",ianf, iend);

  if (iend < 1) return;

  i1=ianf; i2=iend;
  gtk_list_clear_items (GTK_LIST (list), i1, i2);

}


///=====================================================================
  void GUI_List_remove (GtkWidget *widget, GtkList *list) {
///=====================================================================


  GList *clear_list;


  // printf("GUI_List_remove\n");

  clear_list = GTK_LIST (list)->selection;
  gtk_list_remove_items (GTK_LIST (list), clear_list);

}


///=====================================================================
  int GUI_List_select (GtkWidget *list, int mode) {
///=====================================================================
/// mode = 0: normal, Line bleibt nach Selektion selektiert
/// mode = 1: line wird sofort unselektiert
/// mode = 2: init selection (i1=99999)
/// 
/// Retcodes: -1 = deselect Line
///           >0 = line selected


  static gint      i1;
  GList     *dlist;
  GtkWidget *list_item;


  /* --------------------------------------------- */
  // printf("GUI_List_select\n");


  // if(mode == 2) {i1 = 999999; return 0;}


  dlist = GTK_LIST(list)->selection;

  if (dlist) {
    list_item = dlist->data;
    i1 = gtk_list_child_position (GTK_LIST(list), list_item) + 1;
    // printf("pos = %d\n", i1);
    if (mode == 1) {
      gtk_list_unselect_child (GTK_LIST(list), list_item);
    // } else {
      // gtk_list_select_item (GTK_LIST(list), i1);
    }

  } else {
    // printf("unselect\n");
    if(i1 > 0) i1 = -i1;
  }

  // printf("ex GUI_List_select %d\n",i1);

  return i1;

}


/*
//================================================================
  gint GUI_List_CB (GtkWidget *widget, GdkEventButton *event) {
//================================================================
// nach M3 in Liste soll File geloescht werden - kann aktiven ZeilenIndex
// nicht eruieren ...

  int i1;
  GList     *dlist;
  GtkWidget *list_item;

  printf("GUI_List_CB  %d\n",event->button);


  // if (event->button == 1) {
    dlist = widget;
    list_item = dlist->data;
    i1 = gtk_list_child_position (GTK_LIST(UI_act_FileSelBox), list_item) + 1;
    printf("pos = %d\n", i1);

  // GUI_List_select (widget, 1);


  Fertig:
  // printf("ex UI_GR_ButtonPress %d %d %d\n",x, y, state);
  // return FALSE;
  return TRUE;
}
*/

///=====================================================================
 GtkWidget* GUI_List (GtkWidget *parent, void *funcnam, void *data) {
///=====================================================================
///   GUI_Butt(box0,"List", UI_List3, (void*)UI_FuncInit, 10);
/// 
/// int UI_List3 (GtkWidget *parent, void *data) {
/// 
///   static GtkWidget *winID, *box1;
///   static GtkList   *list;
///   long             i1, selInd;
/// 
///   static char *list_items[] = {"hello     ", "world     ", "\0"};
/// 
///   i1 = (int)data;
/// 
///   switch (i1) {
/// 
///     case UI_FuncInit:
/// 
///       if (winID) { return 0; }
/// 
///       // Create Mainwindow
///       winID = GUI_Window ("Undo", UI_undo, (void*)UI_FuncKill, 0);
/// 
///       // damit Zeilenlnge setzen !
///       gtk_widget_set_usize (winID, 200, 100);
/// 
///       box1 = GUI_Vbox (winID, 0);
/// 
///       // create Liste
///       list = GUI_List (box1, UI_undo, (void*)0);
/// 
///       // Liste befllen
///       for (i1 = 0; i1<10; i1++) {
///         if (!strcmp(list_items[i1],"\0")) break;
///         GUI_List_add (list, list_items[i1]);
///       }
/// 
///       GUI_Butt (box1, "done",  UI_undo, (void*)UI_FuncKill, 0);
///       gtk_widget_show (winID);
///       break;
/// 
///     case 0:
///       selInd = GUI_List_select (list);
///       printf("list1_sel %d\n",selInd);
///       break;
/// 
///     case UI_FuncKill:
///       if (winID) {
///         gtk_widget_destroy (winID);
///         winID = NULL;
///         goto Fertig;
///       }
///   }
/// }
/// 
/// Problem:  beim Callback (von funcnam) wird data nicht mitgeliefert !
/// Nachteil: man kann den Text nicht auslesen !
/// ------------------------------------
/// add. Features:
/// gtk_list_set_selection_mode(GTK_LIST(wLst),GTK_SELECTION_MULTIPLE);
 


  GtkWidget *list;
  GtkWidget *box2;
  GtkWidget *scrolled_win;
  // GtkList   *gl1=NULL;


  /* --------------------------------------------------------- */
  box2 = gtk_vbox_new (TRUE, 4);
  gtk_container_border_width (GTK_CONTAINER (box2), 4);
  gtk_box_pack_start (GTK_BOX (parent), box2, TRUE, TRUE, 0);
  // gtk_box_pack_start (GTK_BOX (parent), box2, FALSE, FALSE, 0);
  gtk_widget_show (box2);


  scrolled_win = gtk_scrolled_window_new (NULL, NULL);

  /* gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win), */
                                  /* GTK_POLICY_AUTOMATIC, */
                                  /* GTK_POLICY_AUTOMATIC); */
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
                                  GTK_POLICY_AUTOMATIC,
                                  GTK_POLICY_ALWAYS);
  gtk_box_pack_start (GTK_BOX (box2), scrolled_win, TRUE, TRUE, 0);
  gtk_widget_show (scrolled_win);




  list = gtk_list_new ();

  gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scrolled_win),
                                         list);


  // Default ist SINGLE */
  // gtk_list_set_selection_mode(GTK_LIST (list),GTK_SELECTION_SINGLE); */
  // gtk_list_set_selection_mode(GTK_LIST (list),GTK_SELECTION_MULTIPLE);
  // gtk_list_set_selection_mode(GTK_LIST (list),GTK_SELECTION_BROWSE); */

  if (funcnam) {


    // gtk_signal_connect (GTK_OBJECT (list),
                        // "enter_notify_event",     // "button_press_event",
                        // (GtkSignalFunc) GUI_List_CB, NULL);
    gtk_signal_connect (GTK_OBJECT (list),
                        "select_child",
                        (GtkSignalFunc) funcnam, data);
    gtk_signal_connect (GTK_OBJECT (list),
                        "unselect_child",
                        (GtkSignalFunc) funcnam, NULL);
    // gtk_signal_connect (GTK_OBJECT (list),
                        // "selection_changed",
                        // (GtkSignalFunc) funcnam, data);
  }


  // gtk_container_add (GTK_CONTAINER (scrolled_win), list);
  gtk_container_set_focus_vadjustment(GTK_CONTAINER(list),
                     gtk_scrolled_window_get_vadjustment
                     (GTK_SCROLLED_WINDOW (scrolled_win)));


  gtk_widget_show (list);

  UI_act_FileSelBox = list;

  UI_act_wi = scrolled_win;
  // UI_act_wi = box2;

  return list;
  // return gl1;

}


///=====================================================================
  int GUI_unmap_act () {
///=====================================================================

  // gtk_widget_unrealize (UI_act_wi);
  gtk_widget_destroy (UI_act_wi);

  return 0;

}


///=====================================================================
  int GUI_List3_CBl (void *parent, void *data) {
///=====================================================================
// Inputfiles:
// tmp/lstd.dat = directories komplett
// tmp/lst0.dat = Liste datenfiles komplett
// tmp/lst1.dat = Liste sortiert, gefiltert

// UI_FuncUCB3 ?


static GtkWidget *w_l, *w_e, *w_3;
static int     (*cb_func)(char*,char*);
static char    dirNam[256];  // das gewahlte dir; wird am Ende ausgegeben
static int     lstMode,      // 0 = fileList active, 1 = dirList active.
               mode;         // 1,2 = load; 3=save.

  char  inpfilnam[256], filnamo[256], fnam[256], *p1;
  int   irc, i1;


  // printf("GUI_List3_CBl %d\n",(int*)data);


  if((int)(int*)data == UI_FuncCancel) {  // mode 3 - overwrite - no
    // printf("UI_FuncCancel\n");
    return 0;


  } else if((int)(int*)data == UI_FuncKill) {  // mode 3 - overwrite - no
    // printf("UI_FuncKill\n");
    (*cb_func)(NULL,NULL);                     // call user
    goto L_fertig;


  } else if ((int)(int*)data == UI_FuncOK) {  // mode 3 - overwrite - yes
    strcpy(inpfilnam, gtk_entry_get_text ((GtkEntry*) (w_3)));
    // printf("UI_FuncOK\n");
    goto L_3fertig;


  //----------------------------------------------------------------
  } else if ((int)(int*)data == UI_FuncUCB9) {  // select new directory-1
    // GUI_File_selext("WinTit","/mnt/serv1/Devel/dev/gCAD3D/dat/",cb_func,NULL);
    // get inputDirectory ..
    if(mode < 3) strcpy(fnam, "Model open");
    else         strcpy(fnam, "Model save");
    GUI_File_selext (fnam, dirNam, GUI_List3_CBl, (void*)UI_FuncUCB10);
    goto L_fertig;



  } else if ((int)(int*)data == UI_FuncUCB10) {  // select new directory-2
    GUI_File_selGet (inpfilnam , parent); // selekt. Dateinamen einlesen
    printf("GUI_List3_CBl-10 |%s|\n",inpfilnam);
    // separate directory-filename
    irc = AP_decode_fnam (inpfilnam, dirNam, inpfilnam);

    if(irc >= 0) {
      (*cb_func)(inpfilnam, dirNam);

    } else {
      AP_get_dir_open(fnam);         // AP_dir_open
      sprintf(inpfilnam,"Give symbolic pathname for dir. %s ",fnam);
      strcpy(fnam, "DIR_1");
      GUI_GetxText(inpfilnam, fnam, -200, GUI_List3_CBl, (void*)UI_FuncUCB11);
    }
    goto L_exit;



  } else if ((int)(int*)data == UI_FuncUCB11) {  // select new directory-3
    GUI_GetxText_get (fnam);
    // AP_get_dir_open (dirNam);    // AP_dir_open
    Mod_symOpen_add (fnam);         // add symbol to file dir.lst
    AP_get_modnam (inpfilnam);      // WC_modnam
    (*cb_func)(inpfilnam, dirNam);
    goto L_exit;



  //----------------------------------------------------------------
  } else if ((int)(int*)data == UI_FuncUCB1) {  // funcAddr merken
    cb_func = (void*)parent;
    lstMode = 0;  // init
    return 0;


  } else if ((int)(int*)data == UI_FuncUCB2) {  // LabelID merken
    w_l = parent; 
    return 0;


  } else if ((int)(int*)data == UI_FuncUCB5) {  // EntryID merken
    // w_e = parent; 
    strcpy(dirNam, (char*)parent);  // den Pfad merken
    return 0;


  } else if ((int)(int*)data == UI_FuncUCB6) {  // mode merken; 1 2 od 3
    mode = *((int*)parent);
    // printf(" save mode %d\n",mode);
    return 0;


  } else if ((int)(int*)data == UI_FuncUCB7) {  // FilenamEntryID merken
    w_3 = parent;
    return 0;


  } else if ((int)(int*)data == UI_FuncUCB8) {
    // Entry w_3 lesen
    strcpy(inpfilnam, gtk_entry_get_text ((GtkEntry*) (w_3)));

    if(strlen(inpfilnam) < 1) {
      GUI_Dialog (NULL, "  select or key filename  ");
      return 0;
    }
    // check if file exists
    sprintf(filnamo, "%s%s", dirNam,inpfilnam);
    printf(" new fn=|%s|\n",filnamo);
/*
    if(OS_checkFilExist(filnamo,1) == 1) {
      sprintf(inpfilnam,"  overwrite file %s ?  ",filnamo);
      GUI_DialogYN (inpfilnam, GUI_List3_CBl);
      return 0;
    }
*/
    goto L_3fertig;



  //-------- UI_FuncUCB3 ----------------------------------------
  // Liste neu generieren und ausgeben.; kann auch Dirlist sein !
  } else if ((int)(int*)data == UI_FuncUCB3) {
    // tmp/lst0.dat die ungefilterten daten; 
    // tmp/lst1.dat die gefilterten daten; werden angezeigt

    // test if Outputdirectoy exists
    sprintf(filnamo, "%stmp", OS_get_bas_dir());
    if(OS_checkDirExist(filnamo) == 0) {
      TX_Error("GUI_List3 E001 directory %s",filnamo);
      return 0;
    }

    // create outfilename
    sprintf(inpfilnam, "%stmp%clst0.dat", OS_get_bas_dir(),fnam_del);
    sprintf(filnamo, "%stmp%clst1.dat", OS_get_bas_dir(),fnam_del);

    // gesamte Liste (Datei) sortieren u. filtern;
    // Die InputDatei muss aber erhalten bleiben !
    i1 = OS_filterff (filnamo, inpfilnam, (char*)parent);
    if(i1 < 0) return 0;

    // display Liste
    GUI_List_clear (UI_List3l, 0, 9999);
    i1 = GUI_List_file (UI_List3l, filnamo);
    if(i1 < 0)
      TX_Error("****** Listenueberlauf; bitte Filtertext eingeben ..");

    // preselect Entry
    // gtk_widget_grab_focus (w_e);

    return 0;



  //---------- UI_FuncUCB4 --------------------------------------
  // <<-- Button-CallBack; display directories.
  } else if ((int)(int*)data == UI_FuncUCB4) {

    // tmp/lstd.dat die ungefilterten Direcorydaten;
    // tmp/lst0.dat die ungefilterten daten; 

    lstMode = 1;

    // disact. dirSel-Butt
    GUI_List3 (4, 0, 0, 0, 0, 0);

    // create filename
    sprintf(filnamo, "%stmp%clstd.dat", OS_get_bas_dir(),fnam_del);
    sprintf(inpfilnam, "%stmp%clst0.dat", OS_get_bas_dir(),fnam_del);
    OS_file_copy (filnamo, inpfilnam);   

    GUI_List_clear (UI_List3l, 0, 9999);
    i1 = GUI_List_file (UI_List3l, filnamo);
    if(i1 < 0)
      TX_Error("****** Listenueberlauf; bitte Filtertext eingeben ..");
    return 0;

    // preselect Entry
    // gtk_widget_grab_focus (w_e);

    // printf("display directories\n");
    return 0;


  }



  //-------------------------------------------------------------
  // selection reported ..
  i1 = GUI_List_select (parent, 0);
  if(i1 <= 0) return 0;  // skip unselect

    printf("GUI_List3_CBl %d lstMode=%d mode=%d\n",i1,lstMode,mode);

  // reselect button <<--
  GUI_List3 (5, 0, 0, 0, 0, 0);



  //------------ directory selected ---------------------
  if(lstMode == 1) {


    lstMode = 0;

    sprintf(dirNam, "%stmp/lstd.dat", OS_get_bas_dir ());


    // Zeile Nr i1 aus Datei filnamo lesen
    UTX_fgetLine (filnamo, dirNam, i1);




    // path ausfiltern und -> dirNam kopieren
    p1 = strchr(filnamo, ' '); // first blank after symbolname
    if(p1 == NULL) {
      TX_Error("GUI_List3_CBl E001- no blank after symbol");
      return 0;
    }
    *p1 = '\0';


    ++p1;
    p1 = UTX_pos_1n(p1); // skip blanks
    if(p1 == NULL) {
      TX_Error("GUI_List3_CBl E001- no path");
      return 0;
    }


    strcpy(dirNam, p1);
      printf(" path sel |%s| mode=%d\n",dirNam,mode);
    gtk_label_set_text ((GtkLabel*) (w_l), dirNam);


    // filnamo =  symbolic pathname > AP_sym_open
    // dirNam = path > AP_dir_open
    if(mode < 3) Mod_symOpen_set (filnamo, dirNam);



    // create outfilename
    sprintf(inpfilnam, "%stmp%clst0.dat", OS_get_bas_dir(),fnam_del);
    // list dir > lst0.dat
    if(UTX_dir_listf (inpfilnam, dirNam, NULL) < 0) {
      TX_Error("GUI_List3_CBl E002- directory does not exist");
      return 0;
    }


    // gesamte Liste (Datei) sortieren u. filtern;
    // Die InputDatei muss aber erhalten bleiben !
    sprintf(filnamo, "%stmp%clst1.dat", OS_get_bas_dir(),fnam_del);
    OS_filterff (filnamo, inpfilnam, "");

    GUI_List_clear (UI_List3l, 0, 9999);
    i1 = GUI_List_file (UI_List3l, filnamo);
    if(i1 < 0)
      TX_Error("****** Listenueberlauf; bitte Filtertext eingeben ..");
    return 0;

  }




  //-------------------------------------------------------------
  // filename selected ..

  // Zeile Nr i1 aus Datei tmp/lst1.dat lesen
  sprintf(filnamo, "%stmp/lst1.dat", OS_get_bas_dir ());
  UTX_fgetLine (inpfilnam, filnamo, i1);
    // printf(" sel:|%s|\n",inpfilnam);


  // mode 3: ins entryfeld ausgeben
  if(mode == 3) {
    // cut off fileTyp
    UTX_ftyp_cut (inpfilnam);
    gtk_entry_set_text ((GtkEntry*) (w_3), inpfilnam);
    return 0;
  }

  // fertig
  L_3fertig:
    // vorher weg (userFunc kann laenger dauern ..) ?
    // call user
    i1 = (*cb_func)(inpfilnam,dirNam);
    if(i1 >= 0) {
      gtk_widget_destroy (UI_List3w);
      UI_List3w = NULL;
    }
    // return 0;
    return 1;




  //-------------------------------------------------------------
  L_fertig:
    gtk_widget_destroy (UI_List3w);
    UI_List3w = NULL;
  // return 0;

  L_exit:
  return 1;

}


///=====================================================================
  int GUI_List3_CBe (GtkWidget *parent, GdkEventAny *event) {
///=====================================================================
/// CB von Eingabe in das Feld Filtertext der Liste1.
/// den Listeninhalt filtern und wieder ausgeben.
/// Input: Filename und WindowID.


  int  i1;
  GdkEventKey *ev_k;
  char *txt;


  // printf("GUI_List3_CBe\n");


  // if(event->type == GDK_FOCUS_CHANGE) return;
  if(event->type != GDK_KEY_PRESS) return 0;

  ev_k = (GdkEventKey*) event;

  switch (ev_k->keyval) {

    case GDK_Return:
    case GDK_Tab:

      txt = (char*)gtk_entry_get_text ((GtkEntry*) (parent));
      // printf(" Filtertext=|%s|\n",txt);

      // die Liste neu erzeugen
      GUI_List3_CBl ((void*)txt, (void*)UI_FuncUCB3);

  }

  return 0;
}


///=====================================================================
  int GUI_List1 (char *lTxt,char *filNam,void (*funcNam)()) {
///=====================================================================
/// Auswahl einer zeile einer datei
/// lTxt     Text am Titlebar
/// filNam = eine Datei; deren Inhalt wird als Liste angezeigt.
/// funcNam  callbackFunction; wird bei Selection einer datei gerufen.
///
/// GUI_List1 ("select Submodel", listNam, (void(*)())sel_CB);
///
/// Callbackfunction
///  int sel_CB (char *txt_sel, char *dir_sel) {
///    //   dir_sel ist immer leer.
///    if(txt_sel == NULL) ..   // Cancel selected !
///    return -1;  // Fehlbedienung; Liste wird NICHT gekillt; Cancel or ReSelect
///-----------------
/// Braucht ein tempdir (<basedir>/tmp) !!!

  // printf("GUI_List1 |%s|%s|\n",lTxt,filNam);

  GUI_List3 (1, lTxt, filNam, NULL, NULL, funcNam);

  return 0;

}


///=====================================================================
  int GUI_List2 (char *lTxt,char *filNam,char *dirLst,void (*funcNam)()) {
///=====================================================================
/// Dateiauswahl UND Verzeichnisauswahl
/// lTxt     Text am Titlebar
/// filNam = Pfadname des activeDirectory; von diesem Dir Dateiliste anzeigen
/// dirLst = Datei mit Liste der directories (xa/dir.lst)
/// funcNam  callbackFunction; wird bei Selection einer datei gerufen.
///-----------------
/// Callbackfunction
///  int funcNam (char *txt_sel, char *dir_sel) {
///    if(txt_sel == NULL)   // Cancel selected !
///  }
///-----------------
/// Braucht ein tempdir (<basedir>/tmp) !!!

  // printf("GUI_List2 |%s|%s|%s|\n",lTxt,filNam,dirLst);

  GUI_List3 (2, lTxt, filNam, dirLst, NULL, funcNam);

  return 0;

}

///================================================================
  int GUI_ListKill (GtkWidget *parent, void *data) {
///================================================================
 
  // printf("GUI_ListKill %d\n",(int)data);

  if(UI_List3w != NULL) {           // Win schon vorhanden ?
    // printf(" delete win ..\n");
    gtk_widget_destroy (UI_List3w);
    // gtk_widget_destroyed (UI_List3w, &UI_List3w);
    GUI_update__();
    UI_List3w = NULL;
    // GUI_List3 (mode,lTxt,filNam,dirLst,defNam,funcNam);
  }

  return 0;

}


///=====================================================================
  int GUI_List3 (int mode,char *lTxt,char *filNam,char *dirLst,
                 char *defNam,void (*funcNam)()) {
////=====================================================================
///----- mode = 1: nur Dateiauswahl ---------
/// filNam = eine Datei; deren Inhalt wird als Liste angezeigt.
/// dirLst = NULL
///----- mode = 2: Dateiauswahl UND Verzeichnisauswahl ---------
/// filNam = Pfadname des activeDirectory; von diesem Dir Dateiliste anzeigen
/// dirLst = Datei mit Liste der directories (xa/dir.lst)
/// Liste mit Filter; Listinhalt ein aus Datei filNam.
///----- mode = 3: save as ---------
/// filNam = Pfadname des activeDirectory; von diesem Dir Dateiliste anzeigen
/// dirLst = Datei mit Liste der directories (xa/dir.lst)
/// defNam = defaultFilename
/// Liste mit Filter; Listinhalt ein aus Datei filNam.
///----- mode = 4: disactivate butt DirSelect ---------
///-----------------
/// lTxt     Text am Titlebar
/// funcNam  callbackFunction; wird bei Selection einer datei gerufen.
///          Interface bei beiden Funktionen gleich,
///-----------------
/// Callbackfunction
///  int funcNam (char *txt_sel, char *dir_sel) {
///    //   dir_sel ist bei Funktion 1 immer leer.
///    if(txt_sel == NULL)   // Cancel selected !
///  }
///-----------------
/// Braucht ein tempdir (<basedir>/tmp) !!!

// FEHLER GUI_List3 lasst sich nicht in einem Callback von GUI_List3 nicht
//   nochmal rufen !


  int       i1;
  char      cbuf[256];
  GtkWidget *box1, *wact, *w_e, *w_l, *w_3;

static GtkWidget *w_b1, *w_b2;


  // printf("GUI_List3 %d |%s|%s|%s|\n",mode,lTxt,filNam,dirLst);



// --------- mode 4: disactivate butt DirSelect -------
  if(mode == 4) {
    gtk_widget_set_sensitive (w_b1, FALSE);
    return 0;

// --------- mode 5: reactivate butt DirSelect ----------
  } else if(mode == 5) {
    gtk_widget_set_sensitive (w_b1, TRUE);
    return 0;
  }


// --------- mode 1-3 ---------------
  // if(GTK_IS_WINDOW(UI_List3w)) {           // Win schon vorhanden ?
  // if(i1 == GTK_STATE_NORMAL) {
  if(UI_List3w != NULL) {           // Win schon vorhanden ?
    GUI_ListKill (NULL, NULL);
  }


  // UI_List3w = GUI_Window (lTxt, NULL, NULL, 10);
  UI_List3w = GUI_Window (lTxt, GUI_ListKill, (void*)UI_FuncKill, 10);


  box1 = GUI_Vbox (UI_List3w, 0);


  GUI_List3_CBl ((void*)&mode, (void*)UI_FuncUCB6);   // mode merken
  GUI_List3_CBl ((void*)funcNam, (void*)UI_FuncUCB1);   // UserfuncAddr merken

  // printf(" mode=%d\n",mode);


  if(mode == 1) {  // nur Liste
    // copy file filNam -> tmp/lst0.dat
    sprintf(cbuf, "%stmp%clst0.dat", OS_get_bas_dir(),fnam_del);
    OS_file_copy (filNam, cbuf);


  } else {    // mode 2 und 3

    // save dirList -> tmp/lstd.dat
    sprintf(cbuf, "%stmp%clstd.dat", OS_get_bas_dir(),fnam_del);
    OS_file_copy (dirLst, cbuf);

    // display active dir oben
    w_l = GUI_Label (box1, filNam, 0);
    GUI_List3_CBl ((void*)w_l,    (void*)UI_FuncUCB2);   // WidgetID merken
    GUI_List3_CBl ((void*)filNam, (void*)UI_FuncUCB5);   // Pfad merken

    // Filelist of dir filNam -> tmp/lst0.dat
    sprintf(cbuf, "%stmp%clst0.dat", OS_get_bas_dir(),fnam_del);
    UTX_dir_listf (cbuf, filNam, NULL);

  }


  // create FileListe
  UI_List3l = GUI_List (box1, GUI_List3_CBl, NULL);


  // liste generieren, filtern anzeigen
  GUI_List3_CBl ((void*)"", (void*)UI_FuncUCB3);


  wact = GUI_Hbox (box1, -1);

  w_e = GUI_Entry (wact, "Filtertext:","",GUI_List3_CBe, -160);
  // GUI_List3_CBl (w_e,  UI_FuncUCB5);   // WidgetID merken


  // Open mit dirSelect
  // if(mode == 2) {
  if(mode > 1) {
    w_b2 = GUI_Butt (wact, "DIR-NEW", GUI_List3_CBl, (void*)UI_FuncUCB9, 0);
    GUI_Tip ("select new directory (no symbol exists)");
    w_b1 = GUI_Butt (wact, "DIR-SYM", GUI_List3_CBl, (void*)UI_FuncUCB4, 0);
    GUI_Tip ("select symbolic directory (from existing symbol)");
  }


  // Save as 
  if(mode == 3) {
    wact = GUI_Hbox (box1, -1);
    w_3 = GUI_Entry (wact, "","",NULL, -200);         // entry Filename
    GUI_List3_CBl ((void*)w_3, (void*)UI_FuncUCB7);   // WidgetID merken
    // w_b1 = GUI_Butt (wact, "<<---",  GUI_List3_CBl,  (void*)UI_FuncUCB4, 0);
  }


  GUI_Butt (wact, "Cancel",  GUI_List3_CBl, (void*)UI_FuncKill, 0);
  

  if(mode == 3) {
    // GUI_Tip ("change directory");
    GUI_Butt (wact, " SAVE ",  GUI_List3_CBl,  (void*)UI_FuncUCB8, 0);
    // gtk_misc_set_alignment(w_3, 0.4, 0);

    // defaultFilename vorbelegen
    gtk_entry_set_text ((GtkEntry*) (w_3), defNam);
  }




  // an momentane Mauspos (GTK2: call before show)
  // gtk_widget_set_uposition (UI_List3w, 0, 0);
  // gtk_window_set_position (GTK_WINDOW(UI_List3w), GTK_WIN_POS_MOUSE);
  gtk_window_set_position (UI_List3w, GTK_WIN_POS_MOUSE);

  gtk_widget_show_all (UI_List3w);

  gtk_widget_set_usize (UI_List3w, 0, 500);



  // preselect Entry
  gtk_widget_grab_focus (w_e);

  // printf(" ex GUI_List3\n");

  return 0;

}



///=====================================================================
  int GUI_save__ (char *lTxt,char *dirNam,char *dirLst,char *filNam,
                  void (*funcNam)()) {
///=====================================================================
/// get filename for SAVE.
/// lTxt      Text am Titlebar
/// dirNam  = default directory
/// dirLst  = Datei mit Liste der directories (xa/dir.lst)
/// filNam  = defaultFilename
/// funcNam   callbackFunction; wird bei definition des filname gerufen.
///-----------------
/// Callbackfunction
///  int funcNam (char *txt_sel, char *dir_sel) {
///    if(txt_sel == NULL)           // Cancel selected !
///            return 0;             // Ok, exit FileDialog !
///    L_err:  return -1;            // do not exit FileDialog !
///  }
///-----------------
/// Braucht ein tempdir (<basedir>/tmp) !!!



  // printf("GUI_save__ |%s|%s|%s|\n",lTxt,dirNam,dirLst);

  GUI_List3 (3, lTxt, dirNam, dirLst, filNam, funcNam);

  return 0;

}


///=====================================================================
  int GUI_List_file (GtkWidget *list, char* fnam) {
///=====================================================================
/// add all Lines of File fnam to Lit.
/// /usr/include/gtk/gtkscrolledwindow.h


  int       i1, irc;
  char      cbuf[250];
  GtkWidget *list_item;
  GList     *item_list;
  FILE      *fpi;


  // printf("GUI_List_file |%s|\n",fnam);



  if ((fpi = fopen (fnam, "r")) == NULL) {
    return -1;
  }

  item_list = NULL;
  i1 = 0;
  irc = 0;

  while (!feof (fpi)) {
    ++i1;
    if(i1 > 2000) {
      fclose(fpi);
      irc = -1;
      break;
    }

    if (fgets (cbuf, 256, fpi) == NULL) break;
    UTX_CleanCR (cbuf);
    // GUI_List_add (w_list, cbuf);
    // printf(" list add |%s|\n",cbuf);

    list_item = gtk_list_item_new_with_label (cbuf);
    gtk_widget_show (list_item);
    // gtk_container_add (GTK_CONTAINER (list), list_item);

    item_list = g_list_append (item_list, list_item);

  }

  fclose(fpi);


  gtk_list_insert_items (GTK_LIST(list), item_list, 0);


  return 0;

}


///================================================================
  int GUI_HList_CBl (void *parent, void *data) {
///=====================================================================
// Inputfiles:
// tmp/lstd.dat = ParentList komplett
// tmp/lst0.dat = ChildList komplett
// tmp/lst1.dat = ChildList sortiert, gefiltert

// see GUI_List3_CBl


static GtkWidget *w_l, *w_b, *w_e;
static int     (*cb_func)(char*,char*);
static char    actPar[128];  // das gewahlte parent; wird am Ende ausgegeben
static char    titP[128];    // title for select parent ..
static char    titC[128];    // title for select child ..
static int     lstMode,      // 0=fileList active, 1=dirList active.
               mode;         // 1,2 = load; 3=save.

  char  inpfilnam[256], filnamo[256], fnam[256], *p1;
  int   i1;


  printf("GUI_HList_CBl %d\n",(int*)data);
  printf("   lstMode=%d\n",lstMode);


  if((int)(int*)data == UI_FuncCancel) {  // mode 3 - overwrite - no
    // printf("UI_FuncCancel\n");
    return 0;


  } else if((int)(int*)data == UI_FuncKill) {  // mode 3 - overwrite - no
    // printf("UI_FuncKill\n");
    (*cb_func)(NULL,NULL);                     // Cancel: call user
    goto L_fertig;


/*
  } else if ((int)(int*)data == UI_FuncOK) {  // mode 3 - overwrite - yes
    strcpy(inpfilnam, gtk_entry_get_text ((GtkEntry*) (w_3)));
    // printf("UI_FuncOK\n");
    goto L_3fertig;
*/


  } else if ((int)(int*)data == UI_FuncUCB1) {  // funcAddr merken
    cb_func = (void*)parent;
    lstMode = 0;  // init
    return 0;


  } else if ((int)(int*)data == UI_FuncUCB2) {  // LabelID merken
    w_l = parent;
    return 0;



  //-------- UI_FuncUCB3 ----------------------------------------
  // Liste neu generieren und ausgeben.; kann auch Dirlist sein !
  } else if ((int)(int*)data == UI_FuncUCB3) {
    // tmp/lst0.dat die ungefilterten daten;
    // tmp/lst1.dat die gefilterten daten; werden angezeigt

    // test if Outputdirectoy exists
    sprintf(filnamo, "%stmp", OS_get_bas_dir());
    if(OS_checkDirExist(filnamo) == 0) {
      TX_Error("GUI_List3 E001 directory %s",filnamo);
      return 0;
    }

    // create outfilename
    sprintf(inpfilnam, "%stmp%clst0.dat", OS_get_bas_dir(),fnam_del);
    sprintf(filnamo, "%stmp%clst1.dat", OS_get_bas_dir(),fnam_del);

    // gesamte Liste (Datei) sortieren u. filtern;
    // Die InputDatei muss aber erhalten bleiben !
      printf(" filterTexz=|%s|\n",(char*)parent);
    i1 = OS_filterff (filnamo, inpfilnam, (char*)parent);
    if(i1 < 0) return 0;

    // display Liste
    GUI_List_clear (UI_List3l, 0, 9999);
    i1 = GUI_List_file (UI_List3l, filnamo);
    if(i1 < 0)
      TX_Error("****** Listenueberlauf; bitte Filtertext eingeben ..");

    // preselect Entry
    printf(" ex UCB3\n");

    return 0;




  //---------- UI_FuncUCB4 --------------------------------------
  // <<-- Button-CallBack; display directories.
  } else if ((int)(int*)data == UI_FuncUCB4) {

    // tmp/lstd.dat die ungefilterten Direcorydaten;
    // tmp/lst0.dat die ungefilterten daten;

    // disactivate Button <<---
    gtk_widget_set_sensitive (w_b, FALSE);


    lstMode = 1;

    // change title -> titP
    GUI_WinTit (UI_List3w, titP);


    // create filename
    sprintf(filnamo, "%stmp%clstd.dat", OS_get_bas_dir(),fnam_del);
    sprintf(inpfilnam, "%stmp%clst0.dat", OS_get_bas_dir(),fnam_del);
    OS_file_copy (filnamo, inpfilnam);

    GUI_List_clear (UI_List3l, 0, 9999);
    // display List tmp/lst0.dat
    i1 = GUI_List_file (UI_List3l, filnamo);
    if(i1 < 0)
      TX_Error("****** Listenueberlauf; bitte Filtertext eingeben ..");
    return 0;

    // preselect Entry

    // printf("display directories\n");
    return 0;


  //----------------------------------------------------------------
  } else if ((int)(int*)data == UI_FuncUCB5) {  // EntryID merken
    if(strlen((char*)parent) > 125) {
      strncpy(actPar, (char*)parent, 125);  // den Pfad merken
      actPar[125] = '\0';
    } else {
      strcpy(actPar, (char*)parent);  // den Pfad merken
    }
    return 0;


  //----------------------------------------------------------------
  } else if ((int)(int*)data == UI_FuncUCB6) {  // mode merken; 1 2 od 3
    mode = *((int*)parent);
    // printf(" save mode %d\n",mode);
    return 0;


  //----------------------------------------------------------------
  } else if ((int)(int*)data == UI_FuncUCB7) {  // save title f parentSelect
    if(strlen((char*)parent) > 125) {
      strncpy(titP, (char*)parent, 125);
      titP[125] = '\0';
    } else {
      strcpy(titP, (char*)parent);
    }
    return 0;


  //----------------------------------------------------------------
  } else if ((int)(int*)data == UI_FuncUCB8) {  // save title f childSelect
    if(strlen((char*)parent) > 125) {
      strncpy(titC, (char*)parent, 125);
      titP[125] = '\0';
    } else {
      strcpy(titC, (char*)parent);
    }
    return 0;



  //----------------------------------------------------------------
  } else if ((int)(int*)data == UI_FuncUCB9) {  // <<-- ButtonID merken
    w_b = parent;
    return 0;


  }


  //==============================================================
  // selection reported ..
  i1 = GUI_List_select (parent, 0);
    printf("GUI_List3_CBl %d lstMode=%d\n",i1,lstMode);

  // Fehler von GUI_List_select: leifert oft negativ - Falsch !
  // if(i1 < 0) i1 = -i1;

  if(i1 <= 0) return 0;  // skip unselect


  if(lstMode == 1) {        // directory selected


    //-------------------------------------------------------------
    // DirName selected ..

    // reactivate button <<--
    gtk_widget_set_sensitive (w_b, TRUE);

    // change title -> titC
    GUI_WinTit (UI_List3w, titC);

    lstMode = 0;

    sprintf(filnamo, "%stmp/lstd.dat", OS_get_bas_dir ());


    // Zeile Nr i1 aus Datei filnamo lesen
    UTX_fgetLine (actPar, filnamo, i1);
      printf(" dir sel=|%s|\n",actPar);


    // mit der userFunc eine neue ChildList erzeugen
    i1 = (*cb_func)(actPar, NULL);


    // printf(" path sel |%s|\n",actPar);
    gtk_label_set_text ((GtkLabel*) (w_l), filnamo);

    // cp catParts.dat lstd.dat
    sprintf(inpfilnam, "%stmp%ccatParts.lst", OS_get_bas_dir(),fnam_del);
    // OS_file_copy (inpfilnam, actPar);
    sprintf(filnamo, "%stmp%clst0.dat", OS_get_bas_dir(),fnam_del);
    OS_file_copy (inpfilnam, filnamo);
    // cp lst0 lst1
    sprintf(inpfilnam, "%stmp%clst1.dat", OS_get_bas_dir(),fnam_del);
    OS_file_copy (filnamo, inpfilnam);



    // ChildList anzeigen
    GUI_List_clear (UI_List3l, 0, 9999);
    i1 = GUI_List_file (UI_List3l, inpfilnam);
    if(i1 < 0)
      TX_Error("****** Listenueberlauf; bitte Filtertext eingeben ..");
    return 0;

  }



  //-------------------------------------------------------------
  // filename selected ..

  // Zeile Nr i1 aus Datei tmp/lst1.dat lesen
  sprintf(filnamo, "%stmp/lst1.dat", OS_get_bas_dir ());
  UTX_fgetLine (inpfilnam, filnamo, i1);
    printf(" sel:|%s|\n",inpfilnam);

  // actPar = aktueller Katalogname setzen. Woher ?

  // fertig
  L_3fertig:
    // vorher weg (userFunc kann laenger dauern ..) ?
    // call user
    i1 = (*cb_func)(actPar, inpfilnam);
    if(i1 == 0) return 0;




  //-------------------------------------------------------------
  L_fertig:
    gtk_widget_destroy (UI_List3w);
    UI_List3w = NULL;
  // return 0;
  return 1;

}


///================================================================
  int GUI_HList_CBe (GtkWidget *parent, GdkEventAny *event) {
///=====================================================================
/// CB von Eingabe in das Feld Filtertext der Liste1.
/// den Listeninhalt filtern und wieder ausgeben.
/// Input: Filename und WindowID.
/// 
/// see GUI_List3_CBe

  int  i1;
  GdkEventKey *ev_k;
  char *txt;


  printf("GUI_List3_CBe\n");


  // if(event->type == GDK_FOCUS_CHANGE) return;
  if(event->type != GDK_KEY_PRESS) return 0;

  ev_k = (GdkEventKey*) event;

  switch (ev_k->keyval) {

    case GDK_Return:
    case GDK_Tab:

      txt = (char*)gtk_entry_get_text ((GtkEntry*) (parent));
      // printf(" Filtertext=|%s|\n",txt);

      // die Liste neu erzeugen
      GUI_HList_CBl ((void*)txt, (void*)UI_FuncUCB3);
  }

  return 0;
}


///================================================================
  int GUI_HList__ (char *lTxtP, char *lTxtC,
                   char *fnamP, char *fnamC,
                   char *parent, void (*funcNam)()) {
///================================================================
/// make hierarchical SelectList. Select childObject or 
///   select "Parents" with "<<--" -Button.
/// 
/// lTxtP:   titletext for selection of parent
/// lTxtC:   titletext for selection of child
/// fnamP:   Name of file, in dem die uebergeordneten Auswahlobjekte liegen
/// fnamC:   Name of File, in dem die aktuellen Auswahlobjekte liegen
/// parent:  Name of Parent, zu dem die aktuelle ChildListe gehoert
/// funcNam: Name of CallbackFunktion. RetCod of CallbackFunktion:
///          1 - destroy HList;
///          0 - keep HList.
/// 
/// Cancel-Button selected:
///   Aufruf <funcNam>(NULL, NULL);
/// childObject-selected:
///   Aufruf <funcNam>(childNam, parentNam)
/// parentObject-selected:  (Selektion eines uebergeordnetenAuswahlobjekts)
///   Aufruf <funcNam>(NULL, parentNam)
///    <funcNam> must provide a new childList in <fnamC> !!
///    (eine Datei mit den korrigierten aktuellenAuswahlobjekten erstellen)
/// 
/// see also GUI_List2 GUI_List3


  int       i1;
  char      cbuf[256];
  GtkWidget *box1, *wact, *w_e, *w_l, *w_3;

static GtkWidget *w_b1;


  printf("GUI_HList__ |%s|\n",lTxtC);
  printf("   |%s|%s|%s|\n",fnamP,fnamC,parent);



  if(UI_List3w != NULL) {           // Win schon vorhanden ?
    GUI_ListKill (NULL, NULL);
  }


  UI_List3w = GUI_Window (lTxtC, GUI_ListKill, (void*)UI_FuncKill, 10);


  box1 = GUI_Vbox (UI_List3w, 0);


  // GUI_HList_CBl ((void*)&mode, (void*)UI_FuncUCB6);   // mode merken
  GUI_HList_CBl ((void*)funcNam, (void*)UI_FuncUCB1);   // UserfuncAddr merken


  // display active dir oben
  w_l = GUI_Label (box1, fnamC, 0);
  GUI_HList_CBl ((void*)w_l,    (void*)UI_FuncUCB2); // WidgetID des Label merken
  // GUI_HList_CBl ((void*)filNam, (void*)UI_FuncUCB5);   // Pfad merken

  GUI_HList_CBl ((void*)parent, (void*)UI_FuncUCB5);   // parent merken
  GUI_HList_CBl ((void*)lTxtP, (void*)UI_FuncUCB7);    // titleP merken
  GUI_HList_CBl ((void*)lTxtC, (void*)UI_FuncUCB8);    // titleP merken

  // create Widget FileListe
  UI_List3l = GUI_List (box1, (void*)GUI_HList_CBl, NULL);


  // cp File lst0.dat
  sprintf(cbuf, "%stmp%clst0.dat", OS_get_bas_dir(),fnam_del);
  OS_file_copy (fnamC, cbuf);
  // cp lst0.dat lst1.dat
  sprintf(cbuf, "%stmp%clst1.dat", OS_get_bas_dir(),fnam_del);
  OS_file_copy (fnamC, cbuf);


  // liste anzeigen
  // GUI_HList_CBl ((void*)"", (void*)UI_FuncUCB3);
  // GUI_List_clear (UI_List3l, 0, 9999);
  i1 = GUI_List_file (UI_List3l, fnamC);
  if(i1 < 0)
    TX_Error("****** Listenueberlauf; bitte Filtertext eingeben ..");
  GUI_List_select (UI_List3l, 2); // init


  wact = GUI_Hbox (box1, -1);

  w_e = GUI_Entry (wact, "Filtertext:","",GUI_HList_CBe, -160);
  // GUI_List3_CBl (w_e,  UI_FuncUCB5);   // WidgetID merken


  // copy uebergeordnetenAuswahlobjekt -> File tmp/lstd.dat
  sprintf(cbuf, "%stmp%clstd.dat", OS_get_bas_dir(),fnam_del);
  OS_file_copy (fnamP, cbuf);


  // Create Button <<---
  w_b1 = GUI_Butt (wact, "<<---", GUI_HList_CBl, (void*)UI_FuncUCB4, 0);
  // GUI_Tip ("change directory");
  GUI_HList_CBl ((void*)w_b1, (void*)UI_FuncUCB9); // WidgetID des Butt merken


  // Create Button "Cancel"
  GUI_Butt (wact, "Cancel",  GUI_HList_CBl, (void*)UI_FuncKill, 0);
    printf(" n.Canc-Butt\n");



  // an momentane Mauspos (GTK2: call before show)
  gtk_window_set_position (UI_List3w, GTK_WIN_POS_MOUSE);
  // gtk_window_set_position (GTK_WINDOW(UI_List3w), GTK_WIN_POS_MOUSE); CRASHT !!!
  // gtk_widget_set_uposition (UI_List3w, 0, 0);
  gtk_widget_show_all (UI_List3w);
  gtk_widget_set_usize (UI_List3w, 0, 500);


  // preselect Entry
  gtk_widget_grab_focus (w_e);

  printf(" ex GUI_HList\n");


  return 0;

}


///================================================================
  GtkWidget* GUI_Notebook__ (GtkWidget *parent, void *funcnam) {
///================================================================
/// Create a new Notebook.
/// Add Pages with GUI_Notebook_add.
/// Example see tst_gtk6.c.
/// parent should be a window;
/// funcnam is called when noteBook-pages change; first Page has Nr 0.
///   int my_Notebook_CB (int pgNr) {printf("_CB %d\n",pgNr); return;}


  UI_act_wi = gtk_notebook_new ();

  if (funcnam)
    gtk_signal_connect (GTK_OBJECT(UI_act_wi), "switch-page",
                       (GtkSignalFunc)GUI_Notebook_CB, NULL);
                        // GTK_SIGNAL_FUNC(GUI_Notebook_CB), (gpointer)wnb);


  gtk_container_add(GTK_CONTAINER(parent), UI_act_wi);

  gtk_widget_show (UI_act_wi);

  GUI_Notebook_CB (NULL, NULL, 0, funcnam);  // save pointer to func

  return UI_act_wi;

}


///======================================================================
  GtkWidget* GUI_Notebook_add (GtkWidget *wnb, char *title) {
///======================================================================
/// returns a VBOX in the new Notebook-Page.


  GtkWidget   *wtmp1, *child;

  wtmp1 = gtk_label_new (title);    // label for notebook-page

  child = gtk_vbox_new (FALSE, 0);

  gtk_widget_show (child);

  gtk_notebook_append_page (GTK_NOTEBOOK(wnb), child, wtmp1);

  return child;

}


///================================================================
void GUI_Notebook_CB (GtkNotebook *ntb, GtkNotebookPage *nbp,
                   guint pgNr, void* data) {
///================================================================
/// callback of switch-notebook-page

static void      (*userFunc)();

  // printf("GUI_Notebook_CB %d\n",pgNr);

  if(ntb == NULL) {
    userFunc = data;
    return;
  }

  (*userFunc) ((int)pgNr);

  return;

}


///=====================================================================
  int UI_test11 (GtkWidget *parent, void *data) {
///=====================================================================


  printf("UI_test11,  /%s/\n",(char*)data);

  return 0;
}


///=====================================================================
  GtkWidget* GUI_MenuCkBox (GtkWidget *parent, char* ltxt,
                            void *funcnam, void *data) {
///=====================================================================
/// abfragen mit GUI_get_CkBox
///  i1 = ((GtkCheckMenuItem*)parent)->active;   // 0=ON; else=Off.
/// setzen mit:
///   gtk_check_menu_item_set_active (parent, FALSE);
///   gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM(parent), TRUE);

  GtkWidget *w1;

  w1 = gtk_check_menu_item_new_with_label (ltxt);

  /* ...and add it to the menu. */
  gtk_menu_append (GTK_MENU (parent), w1);

  if (funcnam) {
    gtk_signal_connect (GTK_OBJECT(w1), "activate",
                     (GtkSignalFunc) funcnam, data);
  }


  /* Show the widget */
  gtk_widget_show (w1);


  UI_act_wi = w1;
  return w1;

}




///=====================================================================
  GtkWidget* GUI_MenuEntry (GtkWidget *parent, char* ltxt,
                              void *funcnam, void *data) {
///=====================================================================
/// Menupunkt oder MenuSeparator (wenn ltxt == "---")
/// 
/// Offen:
/// gtk_menu_item_set_submenu S.87,103
/// 
///   GUI_MenuEntry (menu, "Save as", UI_CB,   (void*)"saveAs");
///   GUI_MenuEntry (menu, "---",     NULL,    NULL);   // Separator



  GtkWidget *menu_item;

 /* kein ltxt: einen Separator */
  if (!strcmp(ltxt, "---")) {
    menu_item = gtk_menu_item_new ();



  } else {
    /* Create a new menu-item with a name... */
    menu_item = gtk_menu_item_new_with_label (ltxt);

    gtk_signal_connect (GTK_OBJECT (menu_item), "activate",
                      (GtkSignalFunc) funcnam, data);

  }


  /* ...and add it to the menu. */
  gtk_menu_append (GTK_MENU (parent), menu_item);

  /* Show the widget */
  gtk_widget_show (menu_item);


  UI_act_wi = menu_item; // Fuer Tooltips

  return menu_item;

}

///=====================================================================
  GtkWidget* GUI_MenuBar (GtkWidget *parent) {
///=====================================================================
/// 
/// Zuerst eine vbox, dann den MenuBar.
/// 
/// GtkWidget *menu_bar, *menu;
/// 
/// box0 = GUI_Vbox (window, 0);
/// menu_bar = GUI_MenuBar (box0);
/// 
/// menu = GUI_Menu (menu_bar, "File  ");
///   GUI_MenuEntry (menu, "New", MF_Menu, (void*)"new");



  GtkWidget *menu_bar;

  /* Create a menu-bar to hold the menus and add it to our main window*/
  menu_bar = gtk_menu_bar_new ();

  gtk_box_pack_start (GTK_BOX (parent), menu_bar, FALSE, FALSE, 0);

  gtk_widget_show (menu_bar);

  return menu_bar;

}

///=====================================================================
  GtkWidget* GUI_Menu (GtkWidget *menu_bar, char *ltxt, int mode) {
///=====================================================================
/// Generiert ein neues Menu oder Submenu.
/// mode: 0  = normal
///       'r'= right-justified
///       's'= Submenu.
/// 
/// GtkWidget *menu_bar, *menu, *men_imp;
/// GtkWidget *fil_men;
/// 
/// menu_bar = GUI_MenuBar (box0);                      // create Menubar
/// 
/// men_fil = GUI_Menu (menu_bar, "File ", 0);          // first Menu on Menubar
/// 
/// men_hlp = GUI_Menu (menu_bar, "Help ", 'r');        // Menu rechts
/// fil_men = GUI_GetActW();   // get RootWindow of menu for disactivate
///                            // muss sofort nach GUI_Menu sein !
/// 
/// GUI_MenuEntry   (men_fil,"New",UI_CB,(void*)"new"); // add entry to Menu
/// men_imp=GUI_Menu(men_fil,"Import", 's');            // Menuentry mit Submenu
/// 
/// // disactivate menu:
/// gtk_widget_set_sensitive (fil_men, FALSE);



  GtkWidget *menu, *root_menu;


  /* Init the menu-widget, and never gtk_show_widget() the menu widget!! */
  menu = gtk_menu_new();

  /* This is the root menu, the label will be the menu name displayed on
   * the menu bar.  There won't be a signal handler attached, as it only
   * pops up the rest of the menu when pressed. */
  root_menu = gtk_menu_item_new_with_label (ltxt);

  if(mode == 'r') {
    gtk_menu_item_right_justify(GTK_MENU_ITEM(root_menu));
  }

  gtk_widget_show (root_menu);


  /* Now we specify that we want our newly created "menu" to be the menu
   *  for the "root menu" */
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (root_menu), menu);


  // And finally we append the menu-item to the menu-bar
  if(mode != 's') {
    gtk_menu_bar_append (GTK_MENU_BAR (menu_bar), root_menu);
  } else {
    gtk_menu_append (GTK_MENU (menu_bar), root_menu);
  }


  UI_act_wi = root_menu;

  return menu;

}


///=====================================================================
  GtkWidget* GUI_MenuSub (GtkWidget *item) {
///=====================================================================


  GtkWidget *submenu;


  submenu = gtk_menu_new ();

  gtk_menu_item_set_submenu (GTK_MENU_ITEM (item), submenu);

  return submenu;

}


///=====================================================================
  int GUI_WinUp (GtkWidget *parent) {
///=====================================================================
/// window always on top ..
/// muss vor gtk_widget_show gerufen werden !!!!
/// 
/// GUI_WinUpCB (win0, NULL, (void*)UI_FuncInit);


  // printf("GUI_WinUp \n");



  // init
  GUI_WinUpCB (parent, NULL, (void*)UI_FuncInit);


  // *w_act = parent;

  return 0;

}


///=====================================================================
  int GUI_WinUpCB (GtkWidget *parent,GdkEventVisibility *event,void *data) {
///=====================================================================
/// this win always up
/// UI_FuncInit muss vor gtk_widget_show gerufen werden !!!!
/// UI_FuncExit = hide window; damit kann anders (zB FileSelection)
///               druebergelegt werden; reset mit gtk_widget_show !!
/// jedoch nur das zuletzt aktivierte Raisen (sonst loop!)
/// 
/// GUI_WinUpCB (NULL,NULL,(void*)UI_FuncExit);  // NOT always on top

static GtkWidget *w_act = NULL;
static int       sid1, sid2;


  // printf("GUI_WinUpCB \n");



  // init ..
  if((int)(int*)data == UI_FuncInit) {
    // printf("GUI_WinUpCB init\n");
    w_act = parent;

// #ifdef _MSC_VER
    // focus_out_event kommt in MS-Win und in Debian; nicht in Mandrake !
    gtk_widget_set_events(parent, GDK_FOCUS_CHANGE_MASK);
    sid1=gtk_signal_connect(GTK_OBJECT(parent), "focus_out_event",
                         (GtkSignalFunc)GUI_WinUpCB, NULL);
// #else
    // nur Linux/Mandrake (nicht MS-Win, Debian)
    gtk_widget_set_events(parent, GDK_VISIBILITY_NOTIFY_MASK);
    sid2=gtk_signal_connect(GTK_OBJECT(parent), "visibility_notify_event",
                         (GtkSignalFunc)GUI_WinUpCB, NULL);
// #endif
    return 0;



  // diconnect; geht aber kein reconnect mehr moeglich (muss vor show sein ..)
  } else if((int)(int*)data == UI_FuncExit) {
    // printf("GUI_WinUpCB exit\n");
    // gtk_signal_disconnect(GTK_OBJECT(w_act), sid1);
    // gtk_signal_disconnect(GTK_OBJECT(w_act), sid2);
    gtk_widget_hide (w_act);
    GUI_update__ ();
    return 0;
  }


  if(parent == w_act)
    // printf("GUI_WinUpCB raise\n");
  gdk_window_raise (event->window);

 return 0;

}


///================================================================
  int GUI_update__ () {
///================================================================
/// update all windows

  // Display zwischendurch updaten
  while (gtk_events_pending()) {
    gtk_main_iteration();
  }

  return 0;

}


///================================================================
  int GUI_del_events () {
///================================================================
/// GUI_del_events         kill all pending events
/// 
/// Usage:
///  gtk_main_quit ();   // stop collecting events ...
///  .. langwierige work ..
///  GUI_del_events ();  // kill pending events ...
///  gtk_main ();        // resume collecting events ...


  GdkEvent  *evNtx;

  L_kill:
  evNtx =  gdk_event_get ();
  if(evNtx != NULL) {
    gdk_event_free (evNtx);
    goto L_kill;
  }

  gtk_main_iteration();

  return 0;

}


///================================================================
  int GUI_Idle (void *funcnam, void *data) {
///================================================================
/// GUI_Idle               register a idle-function
/// Example:
///  GUI_Idle (AP_Idle_CB, NULL);
///  int AP_Idle_CB (void *data) {
///    .. work ..
///    return 0; // removes idle-Call!
///    return 1; // keep idle-Call; call AP_Idle_CB again.
///  }

  gtk_idle_add ((GtkFunction)funcnam, data);


  return 0;

}


//================================================================
  int GUI_del_widged (GtkWidget *wdg1) {
//================================================================
// GUI_del_widged            delete widget

  gtk_widget_hide (wdg1);
  gtk_widget_unrealize (wdg1);

  return 0;

}

// EOF
