/* Textfenstertools fuer GTK2.    2005-01-07     RF



==================================================*/



#include "../xa/MS_Def0.h"

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../gtk/ut_gtk.h"

#include "../ut/ut_geo.h"                   // IMIN
#include "../ut/ut_txt.h"                   // UTX_CleanCR
#include "../ut/ut_TX.h"                    // TX_Print


static GtkTextBuffer *TxBuf;
static GtkWidget     *TxView = NULL;
static int           oldPos;





///================================================================
  GtkWidget* GUI_Tx_Win (void **wtext) {
///================================================================
/// Create ein Editfenster


  // GtkWidget *vpaned;
  GtkWidget *sw;
  GtkTextBuffer *buffer;



  printf("GUI_Tx_Win \n");




  //----------------------------------------------------------------
  TxView = gtk_text_view_new ();


  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (TxView));

  gtk_text_buffer_set_text (buffer, "", -1);


  //----------------------------------------------------------------
  // vpaned = gtk_vpaned_new ();
  // gtk_container_set_border_width (GTK_CONTAINER(vpaned), 5);
  // gtk_container_add (GTK_CONTAINER (*wtext), vpaned);
  sw = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (sw),
          GTK_POLICY_AUTOMATIC,
          GTK_POLICY_AUTOMATIC);
  // gtk_paned_add1 (GTK_PANED (vpaned), sw);
  // gtk_widget_show (sw);
  // gtk_widget_show (vpaned);
  gtk_container_add (GTK_CONTAINER (sw), TxView);
  gtk_widget_show (TxView);

  gtk_text_view_set_editable ((GtkTextView *)TxView, FALSE);
  gtk_text_view_set_cursor_visible ((GtkTextView *)TxView, FALSE);

  // gtk_editable_set_editable  ((GtkEditable*)buffer, FALSE);



  TxBuf = buffer;
  *wtext = buffer;

  // return vpaned;
  return sw;

}


///================================================================
  int GUI_Tx_fwri (char* txbuf) {
///================================================================
/// Datei txbuf ausgeben ...

  FILE *fp1;
  char cbuf[256];

  printf("GUI_Tx_fwri |%s|\n",txbuf);

  if((fp1=fopen(txbuf,"r")) == NULL) {
    TX_Print("GUI_Tx_fwri open Error %s",txbuf);
    return -1;
  }


  while (!feof (fp1)) {
    if (fgets (cbuf, 256, fp1) == NULL) break;
    UTX_CleanCR (cbuf);
    printf(" nxt: |%s|\n",cbuf);
    GUI_Tx_add (TxBuf, cbuf);
  }

  fclose (fp1);
  return 0;

}


///================================================================
  int GUI_Tx_wri (char* txbuf) {
///================================================================
/// Schreibt an das zuletzt mit GUI_Tx_Win generierte Window


  GUI_Tx_add (TxBuf, txbuf);

  return 0;

}


///================================================================
  int GUI_Tx_add (GtkTextBuffer *wTx, char* txbuf) {
///================================================================
/// eine Line im Textwin hintanfuegen

// extern int AP_sysStat;

static  char actBuf[128];

  int         i1, ilen;
  GtkTextIter iter, iVon, iBis;
  GtkTextMark *mark;


  // printf("GUI_Tx_add |%s|\n",txbuf);
  // printf("       actBuf |%s|\n",actBuf);


  // startup-Fehlermeldungen
  if(TxView == NULL) return 0;

  // if(AP_sysStat < 1) {
    // printf(">>> %s\n",txbuf);
    // return 0;
  // }


  ilen = strlen(txbuf);
  //if(ilen > 120) txbuf[ilen]='\0';

  // skip msg, if first 60 chars ident.
  if(ilen >= 60) {
    i1 = IMIN(60,ilen);
    if(!strncmp(actBuf, txbuf, i1)) return 0;
  } else {
    if(!strcmp(actBuf, txbuf)) return 0;
  }


  strcpy(actBuf, txbuf);

  ilen = strlen(actBuf);
  // printf("ilen=%d\n",ilen);



  // size tot ?
  oldPos = gtk_text_buffer_get_char_count (wTx);
  // printf(" oldPos=%d\n",oldPos);


  // Wenn Text > 5000 Char, die ersten 1000 raus
  if(oldPos > 5000) {

    gtk_text_buffer_get_iter_at_offset (wTx, &iVon, 0);
    gtk_text_buffer_get_iter_at_offset (wTx, &iBis, 1000);
    // i1 = gtk_text_iter_get_line (&iBis); //ask LineNr
    gtk_text_iter_forward_line (&iBis);
    gtk_text_buffer_delete (wTx, &iVon, &iBis);


    oldPos = gtk_text_buffer_get_char_count (wTx);
    // gtk_text_set_point ((GtkText*)text, oldPos);
  }



  // get endPos
  gtk_text_buffer_get_end_iter  (wTx, &iter);
  // insert at iterPos
  strcat(actBuf, "\n");
  gtk_text_buffer_insert (wTx, &iter, actBuf, -1);
  actBuf[ilen] = '\0';  // remove NL wieder (f nachfolgendes strcmp)



  // moves the "insert" and "selection_bound" marks simultaneously
  gtk_text_buffer_place_cursor (wTx, &iter);

  // ganz nach hinten scrollen;
  mark = gtk_text_buffer_get_mark (wTx, "insert");
  // gtk_text_buffer_get_iter_at_mark (wTx, &iter, &mark)
  gtk_text_view_scroll_to_mark ((GtkTextView*)TxView, mark,
     0.1,              // within_margin
     FALSE,            // use_align
     0.5, 0.0);        // xalign,yalign



  // spez. f GTK2 : GUI_update__ ();
  while (gtk_events_pending()) {   // update display
    gtk_main_iteration();
  }


  // gtk_widget_set_sensitive (text, TRUE);


  return 0;

}


///================================================================
  int GUI_Tx_rmLast () {
///================================================================
/// letzte Ausgabezeile loschen !


  GtkTextIter  iVon, iBis;



  // startup-Fehlermeldungen
  if(TxView == NULL) return 0;

  gtk_text_buffer_get_end_iter (TxBuf, &iBis);

  iVon = iBis;
  gtk_text_iter_backward_line (&iVon);

  gtk_text_buffer_delete (TxBuf, &iVon, &iBis);

  // printf("GUI_Tx_rmLast\n");

  return 0;

}




//================== EOF =========================================
