/*                   ut_gtkEd.c

Hier alle Funktionen die das Editfenster betreffen;
Funktionen die den Sourcetext im Memory bearbeiten sind UTF_*.



Weiter:

gtk - Func GUI_Ed_RdLnAct


Offen :
gtk_editable_select_region: wird beim 2.mal immer grau, wenn
  man gtk_editable_set_position zusaetzl. (zum scroll to pos) verwendet.
  Gibts ein anderes scroll ?
  Gibts ein anderes markieren ? ev. fuer Text? Sodass man einen
    Zeilenhintergrund andersfarbig machen kann ? Nix zu finden.


========================================================
Korr.:
2003-05-05 GUI_Ed_Init: Parameter funcnam zu. RF.
2001-06-26 GUI_Ed_Focus,GUI_Ed_setCnxtL neu.
2001-06-06 Erfasst.


Compile:
cc -c -g3 `gtk-config --cflags` ut_gtkEd.c
cl -c /I ..\include ut_gtkEd.c


Help:
vi /usr/include/gtk/gtkeditable.h
vi /usr/include/gtk/gtktext.h



========================================================
Inhalt - Funktionen:

GUI_Ed_Focus         den Focus auf EditWindow
GUI_Ed_sel_ln        select Line, set Curpos to Line.
GUI_Ed_sel__         select_region
GUI_Ed_sel_del       delete select_region
GUI_Ed_sel_wrf       write selected -> file
GUI_Ed_getLsta       ZeilenStartPos suchen
GUI_Ed_getLend       ZeilenEndPos suchen
GUI_Ed_getLpos       ZeilenStart/EndPos lesen
GUI_Ed_getCpos       Cursorposition lesen
GUI_Ed_getEof        get EOF-Position
GUI_Ed_setCpos       Cursorposition setzen (= implizites unselect)
GUI_Ed_setCnxtL      Cursorposition auf next Line
GUI_Ed_scroll_s

GUI_Ed_Read          Den Windowinhalt -> txbuf kopieren.
GUI_Ed_RdLnAct       die aktuelle Zeile einlesen
GUI_Ed_RdChr         read char near cursor

GUI_Ed_Insert        Text einfuegen
GUI_Ed_Ins_f         Inhalt einer datei einfuegen
GUI_Ed_Write         das gesamte Editfenster neu schreiben (txbuf -> Window)
GUI_Ed_Init          Create ein Editfenster.
GUI_Ed_editable      editabel or frozen ..


========================================================
Doku:
vi /p2/devel/gtk/gtk_tutorial.20000721/txt/gtk_tut.txt
vi /usr/include/gtk/gtkeditable.h




========================================================
//Create:
      //das Edit-Fenster und das Grafik-fenster nebeneinender
      hpaned = gtk_hpaned_new ();
      gtk_container_add (GTK_CONTAINER(box0), hpaned);
      gtk_widget_show (hpaned);



      winED = GUI_Ed_Init (&wText, 0);
      gtk_paned_add1 (GTK_PANED(hpaned), winED);
      gtk_widget_show (winED);

------------------------------





MS-Win: Bild "zerfressen": dagegen hilft nur freeze - thaw !!




  // Datei als veraendert definieren (fuer nachfolgendes save ??)  ??
  gtk_editable_changed ((GtkEditable*)text);










// Sperren mit FALSE
gtk_text_set_editable (GtkText *text, TRUE);




  // nix selektieren und nach clipb = leeres clipb
  gtk_editable_select_region ((GtkEditable*)text, 0, 0);
  gtk_editable_copy_clipboard ((GtkEditable*)text);


  //  copy selection > clipb.
  //gtk_editable_cut_clipboard ((GtkEditable*)text);

  // paste clipb.
  gtk_editable_paste_clipboard ((GtkEditable*)text);




// kann man damit auf eine Zeile setzen ?
void gtk_text_set_adjustments( GtkText       *text,
                                      GtkAdjustment *hadj,
                                      GtkAdjustment *vadj );


// set insertion point; does not scroll.
void gtk_text_set_point( GtkText *text, guint index );


// getting the current insertion point:
guint gtk_text_get_point( GtkText *text );

// get current CurPos
(int)cpos = gtk_editable_get_position ((GtkEditable*)text));



// the current length of the Text widget
/int)txlen = gtk_text_get_length (GtkText *text );


// curPos setzen und scroll; macht aber ein unselect !
gtk_editable_set_position ((GtkEditable*)text, cpos);


gtk_editable_insert_text (text, newText, newLen, posi);


// Text is deleted relative to the current insertion point
gint gtk_text_backward_delete( GtkText *text, guint    nchars );
gint gtk_text_forward_delete ( GtkText *text, guint    nchars );

gtk_editable_delete_text(GTK_EDITABLE(text), i_startpos, i_endpos);




// retrieve the char at position index
GTK_TEXT_INDEX(t, index)


// retrieve larger blocks
gchar *gtk_editable_get_chars( GtkEditable *editable,
                                      gint         start_pos,
                                      gint         end_pos );
// end = -1 = EOT, start beginnt m. 0.
// don't forget to free it with a call to g_free(gpointer xx);



gtk_text_insert   SAMS.480   Log.697


  // geht net
  //gtk_selection_remove_all (win);
  //gtk_signal_emit_by_name (GTK_OBJECT(win), "selection-clear-event");
  //gtk_signal_emit_by_name (GTK_OBJECT(win), "unselect-all");

  //clearing the selection by setting the owner to NULL
  gtk_selection_owner_set (NULL, GDK_SELECTION_PRIMARY,
                                       GDK_SELECTION_TYPE_STRING);



  static GdkAtom targets_atom = GDK_NONE;
  targets_atom = gdk_atom_intern ("TARGETS", FALSE);
  // And request the "TARGETS" target for the primary selection
  gtk_selection_convert (win, GDK_SELECTION_PRIMARY, targets_atom,
                           GDK_CURRENT_TIME);


// Start-Endposition of Selected Region:
(int)ia = ((GtkEditable*)text->text)->selection_start_pos;
(int)ie = ((GtkEditable*)text->text)->selection_end_pos;

// select region
gtk_editable_select_region ((GtkEditable*)text->text, von, bis);


// selektierten text rauslschen; Geht !!
gtk_editable_delete_selection ((GtkEditable*)text);



  gtk_editable_claim_selection((GtkEditable*)win, TRUE, GDK_CURRENT_TIME);







*/




#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>



// GTK2.2 - WIN:
#include <gtk/gtk.h>
#include <gtk/gtktext.h>


#include "../gtk/ut_gtk.h"
#include "../gtk/ut_gtkEd.h"

#include "../ut/ut_txfil.h"




static int   UI_Ed_ln_sizY;
static float UI_Ed_ln_offY;




/* ??
//================================================================
  int GUI_Ed_editable (GIO_WinEd *text, int mode) {
//================================================================
// GUI_Ed_editable      editabel or frozen ..
// mode: 

  printf("GUI_Ed_editable %d\n",mode);

  gtk_text_view_set_editable (text->text,  FALSE);

  return 0;

}
*/


///================================================================
  int GUI_Ed_sel_wrf (GIO_WinEd *text, char *fnam) {
///================================================================
/// write selected -> file

  int  i1, ia, ie;
  char c1;
  FILE *fpo;


  // buf = gtk_editable_get_chars ((GtkEditable*)text, 0, -1);
  // printf("/%s/\n",txbuf);
  ia = ((GtkEditable*)text->text)->selection_start_pos;
  ie = ((GtkEditable*)text->text)->selection_end_pos;


  printf("GUI_Ed_sel_wrf %d %d\n",ia, ie);


  if(ie <= ia) return 0;


  if((fpo=fopen(fnam,"wb")) == NULL) {
    TX_Print("GUI_Ed_sel_wrf E001 |%s|",fnam);
    return -1;
  }


  for(i1=ia; i1 < ie; ++i1) {
    c1 = GTK_TEXT_INDEX((GtkText*)text->text, i1);
    // printf("%c",c1);
    fwrite(&c1, 1, 1, fpo);
  }
  // printf("\n",i1);

  fclose(fpo);

  return 0;

}


///=========================================================================
  int GUI_Ed_sel_del (GIO_WinEd *text) {
///=========================================================================
/// delete selected text


  // printf("GUI_Ed_sel_del %d %d\n",((GtkEditable*)text)->selection_start_pos,
                                  // ((GtkEditable*)text)->selection_end_pos);

  gtk_editable_delete_selection ((GtkEditable*)text->text);

  return 0;

}


///=========================================================================
  int GUI_Ed_del (GIO_WinEd *text, int von, int bis) {
///=========================================================================
/// delete text + scroll !

  int cpos;
  int txlen;

  // txlen = gtk_text_get_length ((GtkText*)text);
  txlen = gtk_text_get_length (GTK_TEXT(text->text));


  // printf("GUI_Ed_del %d %d %d\n",von,bis,txlen);


  if(von >= (txlen-1)) return -1;
  if(bis > txlen) bis = txlen;


  // del
  gtk_editable_delete_text (GTK_EDITABLE(text->text), von, bis);


  // den Cursor noch in die naechste zeile bewegen
  cpos = von + 1;

  // set curpos
  gtk_text_set_point (GTK_TEXT(text->text), cpos);

  // scroll to curpos
  // gtk_editable_set_position ((GtkEditable*)text, cpos);
  GUI_Ed_scroll_s (text);


  return 0;

}


///================================================================
  int GUI_Ed_sel_ln (GIO_WinEd *wText, long lNr) {
///================================================================
/// GUI_Ed_sel_ln         select Line, set Curpos to Line.
/// ACHTUNG: die ZeilenStart/Endposition wird aus dem mem gelesen !!!!

  int    i1, i2;
  long   ll;
  char   *p1, *p2;


  printf("GUI_Ed_sel_ln %d\n",lNr);


  // Ablauffehler in MAN; set CurPos, select act. Line.
        p1 = UTF_GetPosLnr (&ll, lNr);
        p2 = UTF_GetnextLnPos (p1);
        // Startposition der zeile abfragen
        i1 = UTF_offset_ (p1);
        i2 = UTF_offset_ (p2);
        // GUI_Ed_setCpos (wText, i2);
        // Zeile selektiert darstellen; setzt auch curPos.
        GUI_Ed_sel__ (wText, i1, i2);

  return 0;

}


///================================================================
  int GUI_Ed_sel__ (GIO_WinEd *text, int von, int bis) {
///================================================================
/// select_region von cpos bis cpos (und scroll!)
/// if(von < 0)  - unsect all !
/// ACHTUNG: crasht, wenn freezed !!

// vi /usr/include/gtk/gtkeditable.h



  printf("GUI_Ed_sel %d %d\n",von,bis);


  // macht Sele. immer grau; sonst erst ab dem 2. gtk_editable_select_region.
  // Schuld ist das gtk_editable_set_position (zum scroll to pos).
  gtk_editable_claim_selection((GtkEditable*)text->text,TRUE,GDK_CURRENT_TIME);

  // gtk_text_freeze (GTK_TEXT(text));

  // scrollt immer nach Charpos; macht aber ein unselect !!
  // gtk_editable_set_position ((GtkEditable*)text, bis);
  // GUI_Ed_scroll_s (text, bis);

/*
  // gtk_text_set_point(text, von); // tut nix

  // Now emit the "changed" signal to reconfigure all the widgets t
  //  re attached to this adjustment
  // gtk_signal_emit_by_name (GTK_OBJECT (text), "changed");

  //clearing the selection by setting the owner to NULL
  // gtk_selection_owner_set (text, GDK_SELECTION_PRIMARY,
                                 // GDK_SELECTION_TYPE_STRING);

  // gtk_signal_emit_by_name ((GtkEditable*)text, "selection_clear_event");
  // gtk_signal_emit_by_name (GTK_OBJECT(text), "unselect_all");
*/


  // Select characters vonCharpos BisCharpos
  // wenn schon andere selektion aktiv und set_positionvorher,
  // wird es aber grau !!
  gtk_editable_select_region ((GtkEditable*)text->text, von, bis);


  gtk_widget_grab_focus (text->text);


  // wieder "auftauen"
  // gtk_text_thaw (GTK_TEXT (text));

  // printf("GUI_Ed_sel__ %d\n",gtk_editable_get_position((GtkEditable*)text));


  return 0;
}


///==========================================================================
  long GUI_Ed_getEof (GIO_WinEd *text) {
///==========================================================================
/// GUI_Ed_getEof      get EOF-Position


  return gtk_text_get_length (GTK_TEXT(text->text));

}


///==========================================================================
  int GUI_Ed_setCnxtL (GIO_WinEd *text) {
///==========================================================================
/// GUI_Ed_setCnxtL      Cursorposition auf next Line

  int cpos, bLen;

  printf("GUI_Ed_setCnxtL \n");

  // bLen = gtk_text_get_length ((GtkText*)text);
  bLen = gtk_text_get_length (GTK_TEXT(text->text));

  // Curpos holen
  cpos = GUI_Ed_getCpos (text);
  // printf("GUI_Ed_setCnxtL pos %d len %d\n",cpos,bLen);


  // find end of Line
  cpos = GUI_Ed_getLend (text, cpos);


  ++cpos;
  if(cpos <= bLen) GUI_Ed_setCpos (text, cpos);

  
  Fertig:
  // printf("GUI_Ed_setCnxtL start=%d\n",cpos);
  return 1;

}


///==========================================================================
  int GUI_Ed_setCpos (GIO_WinEd *text, long cpos) {
///==========================================================================
/// Cursorposition setzen und Focus auf EditWin

  int txlen;

  printf("GUI_Ed_setCpos %d\n",cpos);

  // txlen = gtk_text_get_length ((GtkText*)text);
  txlen = gtk_text_get_length (GTK_TEXT(text->text));

  // printf("GUI_Ed_setCpos pos %d len %d\n",cpos,txlen);


  if(cpos < 0) return -1;
  if(cpos > txlen+1) return -1;


  // gtk_widget_grab_focus (text);

  gtk_text_freeze (GTK_TEXT(text->text));

  // set insert-Position
  // gtk_text_set_point((GtkText*)text, cpos);
  gtk_text_set_point(GTK_TEXT(text->text), cpos);

  // das geht leider SEHR langsam; es wird jede zeile gescrollt ...
  gtk_editable_set_position ((GtkEditable*)text->text, cpos);

  // wieder "auftauen"
  gtk_text_thaw (GTK_TEXT (text->text));



  return 1;

}


///==========================================================================
  int GUI_Ed_getLend  (GIO_WinEd *text, int cPos) {
///==========================================================================
/// get endingPos of Line,  cPos is CurPos in Line.


  int   bLen;
  int   cpos2;



    // Dateilaenge
    // bLen = gtk_text_get_length ((GtkText*)text);
    bLen = gtk_text_get_length (GTK_TEXT(text->text));
    // printf("GUI_Ed_getLend %d %d\n",cpos,bLen);

    // find end of Line
    cpos2 = cPos-1;


    LoadLine:
    ++cpos2;
    if(cpos2 >= bLen) goto Fertig;
    // printf("%d c1 = %c / %d\n",cpos,txbuf[llen],txbuf[llen]);
    // if(GTK_TEXT_INDEX((GtkText*)text, cpos2) != '\n') {
    if(GTK_TEXT_INDEX(GTK_TEXT(text->text), cpos2) != '\n') {
      goto LoadLine;
    }

  Fertig:
  // printf("GUI_Ed_getLpos %d - %d - %d\n",cpos1,cPos,cpos2);
  return cpos2;


}


///==========================================================================
  int GUI_Ed_getLsta  (GIO_WinEd *text, int cPos) {
///==========================================================================
/// get startPos of Line,  cPos is CurPos in Line.


  int   cpos1;


    // find end of Line
    cpos1 = cPos;

    // den Zeilenstart suchen; zurueck bis zum LF.
    FindStart:
    if(cpos1 <= 0) goto LoadLine;
    --cpos1;
    // if((GTK_TEXT_INDEX((GtkText*)text, cpos1)) != '\n') goto FindStart;
    if((GTK_TEXT_INDEX(GTK_TEXT(text->text), cpos1)) != '\n') goto FindStart;
    // printf("GUI_Ed_getLsta start=%d\n",cpos);


  LoadLine:
  // printf("ex GUI_Ed_getLsta %d\n",cpos1);
  return cpos1;

}


///==========================================================================
  int GUI_Ed_getLpos  (int *sPos, int *ePos, int cPos, GIO_WinEd *text) {
///==========================================================================
/// get starting a. endingPos of Line; cPos is CurPos in Line.


  int   cpos1, cpos2;



    // den Zeilenstart suchen; zurueck bis zum LF.
    cpos1 = GUI_Ed_getLsta (text, cPos);

    // find end of Line
    cpos2 = GUI_Ed_getLend (text, cPos);


  Fertig:
  *sPos = cpos1;
  *ePos = cpos2;

  // printf("GUI_Ed_getLpos %d - %d - %d\n",cpos1,cPos,cpos2);
  return 0;


}


///==========================================================================
  long GUI_Ed_getCpos (GIO_WinEd *text) {
///==========================================================================
/// cpos = offset vom Dateianfang in anz char
/// cpos -> Zeilennummer: UTF_GetLnrPos


  long cpos;

  cpos = gtk_editable_get_position ((GtkEditable*)text->text);
  // cpos = gtk_text_get_point ((GtkEditable*)text);

  // gtk_text_set_point ((GtkText*)text, cpos);
  // cpos = gtk_editable_get_position ((GtkEditable*)text);


  // printf("ex GUI_Ed_getCpos %d\n",cpos);

  // printf("GUI_Ed_getCpos %d %d\n",((GtkEditable*)text)->selection_start_pos,
                                  // ((GtkEditable*)text)->selection_end_pos);


  // Problem: wenn ganze zeile selektiert, dann zeigt cPos auf die
  //   nachfolgende zeile; in diesem Fall cpos = Startpos oder -= 1 !!
  if(((GtkEditable*)text->text)->selection_end_pos >
     ((GtkEditable*)text->text)->selection_start_pos)
    cpos = ((GtkEditable*)text->text)->selection_start_pos;
    // --cpos;


  // printf("ex GUI_Ed_getCpos %d\n",cpos);

  return cpos;

}


///=========================================================================
  int GUI_Ed_scroll_s (GIO_WinEd *text) {
///=========================================================================
/// Es fehlt noch das Auslesen der Zeilenhoehe; dzt fix 14 !!
/// if(cPos < 0) goto EOF !
/// MACHT EIGENTLICH DASSELBE WIE GUI_Ed_setCpos
///  Jedoch wie selected Zone wiederhergestellt !!!


  int           lNr, ia, ie;
  long          l1;
  gfloat        y_val, y_max;
  GtkStyle      *style_act;
  // GtkAdjustment *adj;


  gtk_text_freeze (GTK_TEXT(text->text));

  // Start-Endposition of Selected Region:
  ia = ((GtkEditable*)text->text)->selection_start_pos;
  ie = ((GtkEditable*)text->text)->selection_end_pos;


  printf("GUI_Ed_scroll_s %d %d\n",ia,ie);

  if(ia < 0) ia = ie;
  if(ie < 0) return 0;
  
  // Cursor setzen auf charPos (loescht aber selection !
  gtk_editable_set_position ((GtkEditable*)text->text, ia);


  // reselect region
  if(ia != ie)
  gtk_editable_select_region ((GtkEditable*)text->text, ia, ie);


  gtk_text_thaw (GTK_TEXT (text->text));


  // gtk_widget_grab_focus (text->text);


/*
  // gtk_text_freeze (GTK_TEXT(text));




  // auf bestimmte Zeile setzen (mit verschieben !!)
  // printf("upper=%d\n",GTK_ADJUSTMENT(GTK_TEXT(text)->vadj)->upper);
  // adj = GTK_TEXT(text)->vadj;
  // printf("upper=%f\n",adj->upper);

  // der Abstand des Cursor s in Pixel von oben 
  //printf("posy=%d\n",GTK_TEXT(text)->cursor_pos_y);


  // der Abstand char - char zwischen den Zeilen in pixels; = 3
  // printf("offs=%d\n",GTK_TEXT(text)->cursor_char_offset);


  // style_act = gtk_widget_get_style (text);
  // printf("fontAsc=%d\n",style_act->font->ascent);
  // printf("fontDesc=%d\n",style_act->font->descent);
  // // printf("fontAsc=%d\n",GTK_FONT(GTK_TEXT(text)->current_font)->ascent);

  // // Position 1.Zeile
  // printf("pgLow=%f\n",GTK_ADJUSTMENT(GTK_TEXT(text)->vadj)->lower);
  // // Pos. letzte Zeile
  // printf("pgUpp=%f\n",GTK_ADJUSTMENT(GTK_TEXT(text)->vadj)->upper);
  // printf("Value=%f\n",GTK_ADJUSTMENT(GTK_TEXT(text)->vadj)->value);
  // printf("pgStp=%f\n",GTK_ADJUSTMENT(GTK_TEXT(text)->vadj)->step_increment);
  // printf("pgInc=%f\n",GTK_ADJUSTMENT(GTK_TEXT(text)->vadj)->page_increment);
  // printf("pgSiz=%f\n",GTK_ADJUSTMENT(GTK_TEXT(text)->vadj)->page_size);


  // // kann man damit auf eine Zeile setzen ? geht ned ..
  // GTK_ADJUSTMENT(GTK_TEXT(text)->vadj)->value = line;
  // gtk_text_set_adjustments ((GtkText*)text, NULL, adj);
                                      // GtkAdjustment *hadj,
                                      // GtkAdjustment *vadj );

  lNr = UTF_GetLnrPos (cPos);
  // printf(" lNr=%d\n",lNr);

  // y_val ist in Pixeln von oben weg !!
  // y_val = line * 16;

  // Minus eine Zeile - damit ist es die oberste Zeile.
  // y_val = (lNr-1) * UI_Ed_ln_sizY;
  y_val = lNr * UI_Ed_ln_sizY;

  // muss kleiner sein als ..
  y_max = GTK_ADJUSTMENT(GTK_TEXT(text->text)->vadj)->upper;
  if(y_val >= y_max) {
    y_val = y_max - 1;
  }

  // muss groesser als halbes Win sein
  // scrollt so von hinten nicht auf Zeile 3!
  // if(y_val > UI_Ed_ln_offY) {
    // printf(" val=%d\n",y_val-UI_Ed_ln_offY);
    gtk_adjustment_set_value((GTK_TEXT(text->text)->vadj),y_val-UI_Ed_ln_offY);
  // }

  // gtk_adjustment_set_value ((GTK_TEXT(text)->vadj),
    // ((line * GTK_ADJUSTMENT(GTK_TEXT(text)->vadj)->upper)
    // (line_total - GTK_ADJUSTMENT(GTK_TEXT(text)->vadj)->page_increment)));

     // //GtkAdjustment *adj
     // // Set the page size and page increment size of the sample
     // // adjustment to the value specified by the "Page Size" scale
     // adj->upper     = 4;
     // adj->page_size = 10.;
     // adj->page_increment = 10.;
     // // Now emit the "changed" signal to reconfigure all the widgets t
     // //  re attached to this adjustment
     // gtk_signal_emit_by_name (GTK_OBJECT (adj), "changed");



  // wieder "auftauen"
  // gtk_text_thaw (GTK_TEXT (text));



  // scrollt immer nach Charpos; macht aber ein unselect !!
  // Absturz wenn cPos > ??
  // l1 = gtk_text_get_length ((GtkText*)text);
  l1 = gtk_text_get_length (GTK_TEXT(text->text));

  if(cPos > 0) {
    if(cPos < l1) l1 = cPos;
  }
  // printf(" cPos=%d l1=%ld\n",cPos,l1);

  gtk_editable_set_position ((GtkEditable*)text->text, l1);
*/


  return 0;

}


///==========================================================================
  char GUI_Ed_RdChr (GIO_WinEd *text, int offset) {
///==========================================================================
/// read char near cursor;
/// offset  0 = char right of cursor
/// offset -1 = char left of cursor

  char c1;
  int  cpos;

  cpos = gtk_editable_get_position ((GtkEditable*)text->text);

  cpos += offset;

  // c1 = GTK_TEXT_INDEX((GtkText*)text, cpos);
  c1 = GTK_TEXT_INDEX(GTK_TEXT(text->text), cpos);

  // printf("GUI_Ed_RdChr |%c| %d\n",c1,cpos);

  return c1;

}


///==========================================================================
  int GUI_Ed_RdLnAct (GIO_WinEd *text, char* txbuf, int *txlen) {
///==========================================================================
/// die aktuelle Zeile aus dem Editor einlesen

  // char c1;
  int  cpos, index, bLen, llen;


  llen = 0;


  // Curpos holen
  cpos = GUI_Ed_getCpos (text);

  // Dateilaenge
  // bLen = gtk_text_get_length ((GtkText*)text);
  bLen = gtk_text_get_length (GTK_TEXT(text->text));
  // printf("GUI_Ed_RdLnAct %d %d\n",cpos,bLen);




  // den Zeilenstart suchen; zurueck bis zum LF.
  cpos = GUI_Ed_getLsta (text, cpos);
  if(cpos < 1) goto L_fstat;   // no LF on start of file

  
  // einlesen bis zum LF
  LoadLine:
  ++cpos;
  L_fstat:
  if(cpos >= bLen) goto Fertig;
  // txbuf[llen] = GTK_TEXT_INDEX((GtkText*)text, cpos);
  txbuf[llen] = GTK_TEXT_INDEX(GTK_TEXT(text->text), cpos);
  // printf("%d c1 = %c / %d\n",cpos,txbuf[llen],txbuf[llen]);
  if(txbuf[llen] != '\n') {
    ++llen;
    goto LoadLine;
  }



  Fertig:
  txbuf[llen] = '\0';
  *txlen = llen;

  // printf("ex GUI_Ed_RdLnAct |%s| %ld\n",txbuf,*txlen);
  return 1;
}



///=========================================================================
  int GUI_Ed_Read (GIO_WinEd *text, char* txbuf, long *txlen) {
///=========================================================================
/// Den gesamten Windowinhalt -> txbuf kopieren.
/// Input: txlen = maxlen of txbuf!


  gchar *buf;
  int   irc, fSiz;


  gtk_text_freeze (GTK_TEXT(text->text));

  // *txlen = (long) gtk_text_get_length ((GtkText*)text);
  fSiz = gtk_text_get_length (GTK_TEXT(text->text));
  // printf("GUI_Ed_Read len %ld\n",*txlen);

  // buf is malloced memory !
  buf = gtk_editable_get_chars ((GtkEditable*)text->text, 0, -1);
  // printf("/%s/\n",txbuf);


  if(fSiz < *txlen) {
    // copy out
    memcpy (txbuf, buf, fSiz);
    txbuf[fSiz] = '\0';
    *txlen = fSiz;
    // *txlen = strlen(txbuf);
    irc = 0;

  } else {
    *txlen = fSiz;
    irc = -1;
  }


  g_free(buf);

  // wieder "auftauen"
  gtk_text_thaw (GTK_TEXT (text->text));


  // nur Testausg:
  // printf("============= anf dump mem\n");
  // printf("%s",txbuf);
  // printf("============= end dump mem\n");

  return irc;

}



///===================================================================
  void GUI_Ed_Focus (GIO_WinEd *text) {
///===================================================================
/// den Focus auf EditWindow

  gtk_widget_grab_focus (text->text);

}


///================================================================
  int GUI_Ed_Ins_f (GIO_WinEd *text, char *fnam) {
///================================================================
/// GUI_Ed_Ins_f         Inhalt einer datei einfuegen

  int  i1, i2;
  char c1;
  FILE *fpi;


  // printf("GUI_Ed_Ins_f |%s|\n",fnam);


  if((fpi=fopen(fnam,"rb")) == NULL) {
    TX_Print("GUI_Ed_Ins_f E001 |%s|",fnam);
    return -1;
  }

  gtk_text_freeze (GTK_TEXT(text->text));


  i1 = gtk_text_get_point((GtkText*)text->text);
  // printf(" i1=%d\n",i1);


  while(fread(&c1,1,1,fpi)) {
    // printf("%c",c1);
    gtk_text_insert (GTK_TEXT(text->text),
                   NULL,                      // font
                   NULL,                      // foreground
                   NULL,                      // backgrnd
                   &c1,                       // text
                   1);                        // length; -1 = alles.
  }
  // printf("\n");
  fclose(fpi);


  i2 = gtk_text_get_point((GtkText*)text->text);
  // printf(" i2=%d\n",i2);

  gtk_text_thaw (GTK_TEXT (text->text));

  GUI_Ed_sel__  (text, i1, i2);

  return 0;

}


///===================================================================
  int GUI_Ed_Insert (GIO_WinEd *text, int cpos, char* txbuf, long txlen) {
///===================================================================
/// text einfuegen
/// cpos zB von GUI_Ed_getCpos


  printf("GUI_Ed_Insert at %d len=%ld\n",cpos,txlen);
  printf("  |%s|\n",txbuf);



  gtk_text_freeze (GTK_TEXT(text->text));

  // gtk_text_set_point ((GtkText*)text, cpos);
  gtk_text_set_point (GTK_TEXT(text->text), cpos);

  gtk_text_insert (GTK_TEXT(text->text),
                   NULL,                      // font
                   &text->text->style->black, // foreground
                   NULL,                      // backgrnd
                   txbuf,                     // text
                   txlen);                    // length; -1 = alles.


  // wieder "auftauen"
  gtk_text_thaw (GTK_TEXT (text->text));

  return 0;

}


///=========================================================================
  int GUI_Ed_Write (GIO_WinEd *text, char* txbuf, long txlen) {
///=========================================================================
/// das gesamte Editfenster neu schreiben (txbuf(=mem) -> Window).


  int i1;



  printf("GUI_Ed_Write %ld\n",txlen);

  // printf("  |%s|\n",txbuf);


  gtk_text_freeze (GTK_TEXT(text->text));



  // gesamtes File loeschen
  // gtk_text_set_point ((GtkText*)text, 0);
  gtk_text_set_point (GTK_TEXT(text->text), 0);

  // i1 = gtk_text_get_length ((GtkText*)text);
  i1 = gtk_text_get_length (GTK_TEXT(text->text));

  // gtk_text_forward_delete ((GtkText*)text, i1);
  gtk_text_forward_delete (GTK_TEXT(text->text), i1);




  // das gesamte Editfenster neu schreiben
  gtk_text_insert (GTK_TEXT(text->text),
                   NULL,                      // font
                   // &text->text->style->black, // foreground
                   NULL,                      // foreground
                   NULL,                      // backgrnd
                   txbuf,                     // text
                   txlen);                    // length; -1 = alles.
                   // -1);                    // length; -1 = alles.


  // set Posi ans EOF
  gtk_text_set_point (GTK_TEXT(text->text), txlen);
  // gtk_editable_set_position ((GtkEditable*)text->text, txlen);

  // wieder "auftauen"
  gtk_text_thaw (GTK_TEXT (text->text));

  return 0;

}

/*
//========================================================================
  GtkWidget* GUI_Ed_Init_New (GIO_WinEd **wtext) {
//========================================================================

  static GtkWidget *text;
  static GtkWidget *scrolled_win;
  static GtkWidget *hscrollbar;
  static GtkWidget *vscrollbar;


  // scrolled_win = gtk_scrolled_window_new (NULL, NULL);
  scrolled_win = gtk_scrolled_window_new ((GtkAdjustment*)hscrollbar,
                                          (GtkAdjustment*)vscrollbar);
  gtk_widget_show (scrolled_win);


  text = gtk_text_new (NULL, NULL);
  gtk_text_set_line_wrap(GTK_TEXT(text), FALSE);
  gtk_widget_show (text);

  // gtk_box_pack_start (GTK_BOX (bact), scrolled_win, TRUE, TRUE, 0);


  gtk_container_add (GTK_CONTAINER(scrolled_win), text);



  *wtext = (GtkWidget*)text;

  // table fuer den Packer
  return scrolled_win;
  // return text;

}
*/

///================================================================
  void GUI_Ed_Init (GIO_WinEd *wtext, void* funcnam, int mode) {
///================================================================
/// retObj fuer den Packer; Par1 fuer FocusSetzen; Par2 fuer alles andere.


  GtkWidget *text;
  GtkWidget *sw;


  printf("GUI_Ed_Init %d\n",mode);


  text = gtk_text_new (NULL, NULL);

  gtk_text_set_editable (GTK_TEXT(text), TRUE); // editable: TRUE od FALSE

  sw = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (sw),
          GTK_POLICY_NEVER,
          GTK_POLICY_AUTOMATIC);
  gtk_container_add (GTK_CONTAINER (sw), text);
  // gtk_widget_show (sw);
  gtk_widget_show (text);




  // wrap words: TRUE od FALSE; damit worte nicht abgeteilt werden.
  // lines werden immer gewrapped.
  gtk_text_set_word_wrap(GTK_TEXT(text), FALSE);


  // damit geht scrollen schnell, aber er teilt nicht !!
  if(mode == 0) {
    gtk_text_set_line_wrap(GTK_TEXT(text), FALSE);
  } else {
    gtk_text_set_line_wrap(GTK_TEXT(text), TRUE);
  }



  if(funcnam) {
    gtk_widget_set_events (GTK_WIDGET(text),
                          GDK_KEY_PRESS_MASK);
                          // GDK_KEY_RELEASE_MASK);

    gtk_signal_connect (GTK_OBJECT(text), "key_press_event",
                        GTK_SIGNAL_FUNC(funcnam), NULL);

    // gtk_signal_connect (GTK_OBJECT(text), "key_release_event",
                       // GTK_SIGNAL_FUNC(funcnam2), NULL);


  }


  wtext->view = text;    // Focus geht nur mit EdView
  wtext->text = text;    // buffer fuer alle iterOper's
  wtext->win  = sw;


  // Init Textfensterparameter
  GUI_Ed_Init1 (wtext);


  return;

}

 
/*
//=========================================================================
  GtkWidget* GUI_Ed_Init (GtkWidget **wview, GtkWidget **wtext,
                          void* funcnam, int mode) {
//=====================
//  Create ein Editfenster.
//
//mode = 0: kein Lineumbruch
//mode = 1: Lineumbruch
//
//funcnam = NULL od CallBackroutine for every char entered or removed

//  winED = GUI_Ed_Init (&wtext, UI_EdKeyPress, 0);
//  gtk_container_add (GTK_CONTAINER(box0), winED);
//  gtk_widget_show (winED);


//  // reinschreiben
//  GUI_EdLoad (wtext, "123\n456");

//  void UI_EdChange () {
//    ..
//  }

//siehe \gtk\include\gtktable.h
//siehe \gtk\include\gtktext.h





  GtkWidget *table;
  GtkWidget *text;
  GtkWidget *hscrollbar;
  GtkWidget *vscrollbar;

  // GtkText  *t1;



  // Create a table to hold the text widget and scrollbars
  // see TablePacking; 2 Rows, 2 col's, size ungleich.
  table = gtk_table_new (2, 1, FALSE);




  // Put a text widget in the upper left hand corner. Note the use of
  // GTK_SHRINK in the y direction
  text = gtk_text_new (NULL, NULL); // automatic scrolling
  // text=gtk_text_new ((GtkAdjustment*)hscrollbar,(GtkAdjustment*)vscrollbar);


  gtk_text_set_editable (GTK_TEXT(text), TRUE); // editable: TRUE od FALSE



  gtk_table_attach (GTK_TABLE (table), text,
                    0, 1, 0, 1,    // tablepositionen li, re, ob, unt
                    GTK_FILL | GTK_EXPAND | GTK_SHRINK, // x-options
                    GTK_FILL | GTK_EXPAND,              // y-options
                    0, 0);                              // padding
  gtk_widget_show (text);




//
//// Put a HScrollbar in the lower left hand corner
//hscrollbar = gtk_hscrollbar_new (GTK_TEXT (text)->hadj);
//gtk_table_attach (GTK_TABLE (table), hscrollbar,
//                  0, 1, 1, 2,
//                  GTK_EXPAND | GTK_FILL | GTK_SHRINK,
//                  GTK_FILL,
//                  0, 0);
//gtk_widget_show (hscrollbar);
//



  // And a VScrollbar in the upper right 
  vscrollbar = gtk_vscrollbar_new (GTK_TEXT(text)->vadj);
  // t1 = GTK_TEXT(text);
  // vscrollbar = gtk_vscrollbar_new (t1->vadj);


  gtk_table_attach (GTK_TABLE (table), vscrollbar,
                    1, 2, 0, 1, // tablepositionen li, re, ob, unt
                    GTK_FILL,                            // x-options
                    GTK_EXPAND | GTK_FILL | GTK_SHRINK,  // y-options
                    0, 0);                               // padding
  gtk_widget_show (vscrollbar);




  // wrap words: TRUE od FALSE; damit worte nicht abgeteilt werden.
  // lines werden immer gewrapped.
  gtk_text_set_word_wrap(GTK_TEXT(text), FALSE);


  // damit geht scrollen schnell, aber er teilt nicht !!
  if(mode == 0) {
    gtk_text_set_line_wrap(GTK_TEXT(text), FALSE);
  } else {
    gtk_text_set_line_wrap(GTK_TEXT(text), TRUE);
  }


  // gtk_text_set_adjustments(GTK_TEXT(text),
              // (GtkAdjustment*)hscrollbar, (GtkAdjustment*)vscrollbar);


//
//// Add a handler to put a message in the text widget when it is realized
//gtk_signal_connect (GTK_OBJECT (text), "realize",
//                           GTK_SIGNAL_FUNC (realize_text), NULL);
//

//
//// "activate" is raised when the user hits the enter key
//// "changed" is raised for every character entered or removed.
//if(funcnam) {
//  gtk_signal_connect (GTK_OBJECT (text), "changed",
//                           GTK_SIGNAL_FUNC (funcnam), NULL);
//}
//


  if(funcnam) {
    gtk_widget_set_events (GTK_WIDGET(text),
                          GDK_KEY_PRESS_MASK);
                          // GDK_KEY_RELEASE_MASK);

    gtk_signal_connect (GTK_OBJECT(text), "key_press_event",
                        GTK_SIGNAL_FUNC(funcnam), NULL);

    // gtk_signal_connect (GTK_OBJECT(text), "key_release_event",
                       // GTK_SIGNAL_FUNC(funcnam2), NULL);


  }



  // Init Textfensterparameter
  GUI_Ed_Init1 (text);


  // nur mit wtext kann man ins Editfenster schreiben !
  *wtext = (GtkWidget*)text;


  // table fuer den Packer
  return table;
  // return text;

}
*/


///=========================================================================
  void GUI_Ed_Init1 (GIO_WinEd *text) {
///=========================================================================
///  geht erste nach gtk_widget_show



  GtkStyle      *style_act;

  style_act = gtk_widget_get_style (text->view);
  UI_Ed_ln_sizY = style_act->font->ascent + style_act->font->descent;
  // printf("  UI_Ed_ln_sizY = %d\n",UI_Ed_ln_sizY);


  // Mitte Window als Offset; geht aber erst viel spaeter !
  // printf("pgSiz=%f\n",GTK_ADJUSTMENT(GTK_TEXT(text)->vadj)->page_size);
  // printf("pgIncr=%f\n",GTK_ADJUSTMENT(GTK_TEXT(text)->vadj)->page_increment);
  // UI_Ed_ln_offY = GTK_ADJUSTMENT(GTK_TEXT(text)->vadj)->page_size;
  UI_Ed_ln_offY = UI_Ed_ln_sizY * 10.;
  // printf("UI_Ed_ln_offY=%f\n", UI_Ed_ln_offY);


  // liefert size vom ganzen Win; Mist.
  // printf(" height=%d\n", GTK_WIDGET(text)->allocation.height);


}




 
/* ====================== EOF =========================== */
