/*
Ein Textfenster, mit dem einfach Textzeilen (Messages und Errors)
  dargestellt werden (Errorausgaben, Infozeilen ...).

---------------------------------------------------------
Weiter:


---------------------------------------------------------
Letzte Korrektur:
2001-06-06 GUI_Tx_wri zu.


---------------------------------------------------------
Inhalt - Funktionen:
GUI_Tx_Win       Create TextWindow.
GUI_Tx_add       Eine Zeile hintanfuegen.
GUI_Tx_rmLast    letzte Ausgabezeile loschen


---------------------------------------------------------
Anwendungsbeispiel:
  GtkWidget *winTX;   // das MotherWin
  GtkWidget *wText;   // das ErrMsgWin

      winTX = GUI_Tx_Win (&wText);
      // gtk_widget_set_usize (winTX, 400, 100);
      gtk_box_pack_start (GTK_BOX (box0), winTX, TRUE, TRUE, 2);
      gtk_widget_show (winTX);


    GUI_Tx_add (wText, "blabla ..")


---------------------------------------------------------
Offen :




---------------------------------------------------------
Compile:
cc -c `gtk-config --cflags` ut_gtkTx.c
cl -c /I ..\include ut_gtkTx.c




========================================================
*/




#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#include "../ut/ut_geo.h"                  // IMIN
#include "../gtk/ut_gtk.h"
#include "../gtk/ut_gtkTx.h"
//#include "ut_gtkEd.h"




// das zuletzt mit GUI_Tx_Win generierte Window
static GtkWidget *actWin;
static int       oldPos;




//================================================================
  int GUI_Tx_fwri (char* txbuf) {
//================================================================
// Datei txbuf ausgeben ...

  FILE *fp1;
  char cbuf[256];

  printf("GUI_Tx_fwri |%s|\n",txbuf);

  if((fp1=fopen(txbuf,"r")) == NULL) {
    TX_Print("GUI_Tx_fwri open Error %s",txbuf);
    return -1;
  }


  while (!feof (fp1)) {
    if (fgets (cbuf, 256, fp1) == NULL) break;
    UTX_CleanCR (cbuf);
    printf(" nxt: |%s|\n",cbuf);
    GUI_Tx_add (actWin, cbuf);
  }

  fclose (fp1);
  return 0;

}


/*==========================================================================*/
  int GUI_Tx_wri (char* txbuf) {
/*==============
Schreibt an das zuletzt mit GUI_Tx_Win generierte Window !
*/


  GUI_Tx_add (actWin, txbuf);

  return 0;

}



//================================================================
  int GUI_Tx_rmLast () {
//================================================================
// letzte Ausgabezeile loschen !

 
  int  i1, iold;


  iold = oldPos;

  i1 = gtk_text_get_length ((GtkText*)actWin);

  gtk_text_set_point ((GtkText*)actWin, iold);

  gtk_text_forward_delete ((GtkText*)actWin, i1-iold);

  // printf("GUI_Tx_rmLast %d %d\n",iold,i1);

  return 0;

}


/*==========================================================================*/
  int GUI_Tx_add (GtkWidget *text, char* txbuf) {
/*==============
*/

static  char buf[128];

  int  i1, ilen;


  // printf("GUI_Tx_add !%s!\n",txbuf);


  ilen = strlen(txbuf);
  //if(ilen > 120) txbuf[ilen]='\0';

  // skip msg, if first 60 chars ident.
  i1 = IMIN(60,ilen);
  if(!strncmp(buf, txbuf, i1)) return 0;


  strcpy(buf, txbuf);
  strcat(buf, "\n");

  ilen = strlen(buf);
  /* printf("ilen=%d\n",ilen); */


  // in MS-Win sieht man den Update; dagegen:
#ifdef _MSC_VER
  gtk_widget_unmap (text);
#endif

  // gtk_widget_set_sensitive (text, FALSE);
  gtk_text_freeze (GTK_TEXT(text));

  // size tot ?
  oldPos = gtk_text_get_length ((GtkText*)text);
  // printf(" oldPos=%d\n",oldPos);


  // Wenn Text > 5000 Char, die ersten 1000 raus
  if(oldPos > 5000) {

    gtk_text_set_point ((GtkText*)text, 0);
    gtk_text_forward_delete ((GtkText*)text, 1000);


    gtk_editable_changed ((GtkEditable*)text);
    oldPos = gtk_text_get_length ((GtkText*)text);
    gtk_text_set_point ((GtkText*)text, oldPos);
  }


  // nun den neuen text dazu 
  gtk_text_insert (GTK_TEXT(text),
                   NULL,                      // font
                   NULL,   // &text->style->black,       // foreground
                   NULL,                      // backgrnd
                   buf,                       // text
                   ilen);                     // length; -1 = alles.





  // wieder "auftauen" - muss vor dem positionieren sein !
  gtk_text_thaw (GTK_TEXT (text));


  // ganz nach hinten scrollen; muss NACH thaw sein!
  i1 = gtk_text_get_length ((GtkText*)text);
  gtk_editable_set_position ((GtkEditable*)text, i1);


#ifdef _MSC_VER
  gtk_widget_map (text);
#endif

  while (gtk_events_pending()) {   // update display
    gtk_main_iteration();
  }


  // gtk_widget_set_sensitive (text, TRUE);

  return 0;

}



/*========================================================================= */
  GtkWidget* GUI_Tx_Win (GtkWidget **wtext) {
/*=====================
  Create ein Editfenster.

  winED = GUI_EdWin (&wtext);

  // reinschreiben
  GUI_EdLoad (wtext, "123\n456");

*/


  // static GtkWidget *table;
  //static GtkWidget *hscrollbar;
  // static GtkWidget *vscrollbar;



  GtkWidget *text;
  // GtkWidget *vpaned;
  GtkWidget *sw;


  text = gtk_text_new (NULL, NULL);



  //----------------------------------------------------------------
  // vpaned = gtk_vpaned_new ();
  // gtk_container_set_border_width (GTK_CONTAINER(vpaned), 0);
  // gtk_container_add (GTK_CONTAINER (*wtext), vpaned);
  sw = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (sw),
          GTK_POLICY_NEVER,
          GTK_POLICY_AUTOMATIC);
  // gtk_paned_add1 (GTK_PANED (vpaned), sw);
  // gtk_widget_show (sw);
  // gtk_widget_show (vpaned);
  gtk_container_add (GTK_CONTAINER (sw), text);
  gtk_widget_show (text);



/*
  // Create a table to hold the text widget and scrollbars
  // see TablePacking; 2 Rows, 2 col's, size ungleich.
  table = gtk_table_new (2, 1, FALSE);

  // Put a text widget in the upper left hand corner. Note the use of
  // GTK_SHRINK in the y direction
  text = gtk_text_new (NULL, NULL);

  gtk_text_set_editable (GTK_TEXT(text), FALSE); // editable: TRUE od FALSE

  // wrap words: TRUE od FALSE; damit worte nicht abgeteilt werden.
  // lines werden immer gewrapped.
  gtk_text_set_word_wrap(GTK_TEXT(text), FALSE);

  gtk_table_attach (GTK_TABLE (table), text,
                    0, 1, 0, 1,    // tablepositionen li, re, ob, unt
                    GTK_FILL | GTK_EXPAND | GTK_SHRINK, // x-options
                    GTK_FILL | GTK_EXPAND,              // y-options
                    0, 0);                              // padding
  gtk_widget_show (text);

  // // Put a HScrollbar in the lower left hand corner
  // hscrollbar = gtk_hscrollbar_new (GTK_TEXT (text)->hadj);
  // gtk_table_attach (GTK_TABLE (table), hscrollbar, 0, 1, 1, 2,
                    // GTK_EXPAND | GTK_FILL, GTK_FILL, 0, 0);
  // gtk_widget_show (hscrollbar);

  // And a VScrollbar in the upper right
  vscrollbar = gtk_vscrollbar_new (GTK_TEXT (text)->vadj);
  gtk_table_attach (GTK_TABLE (table), vscrollbar,
                    1, 2, 0, 1, // tablepositionen li, re, ob, unt
                    GTK_FILL,                            // x-options
                    GTK_EXPAND | GTK_FILL | GTK_SHRINK,  // y-options
                    0, 0);                               // padding
  gtk_widget_show (vscrollbar);

  // // Add a handler to put a message in the text widget when it is realized
  // gtk_signal_connect (GTK_OBJECT (text), "realize",
                             // GTK_SIGNAL_FUNC (realize_text), NULL);
*/


  // nur mit wtext kann man ins Editfenster schreiben !
  *wtext = (GtkWidget*)text;

  // merken
  actWin = text;

  return sw;

}





/* ====================== EOF =========================== */
