/***************************************************************************
                          ut_geo.h  -  description
                             -------------------
    begin                : Fri Aug 25 2000
    copyright            : (C) 2000 by CADCAM-Services Franz Reiter
    email                : franz.reiter@cadcam.co.at

 ***************************************************************************

Achtung: Bug in MS-Windows: never use "double rad1"


-------------------------------------------
Korr:
2004-08-06  struct Circ: ango added !! RF.
2003-05-10  Memspc neu zu. RF.
2002-02-12  Ditto neu zu. RF.
2001-04-26  alle #define Typ_xx aus ut_gr zu, RAD_1 genauer.


------------------------------------
Offen:
Bitoperations siehe IG_r_done_get / IG_r_done_set


-------------------------------------------
*/



/*
// NUR bei LINUX (ex math.h):
#define RAD_360 M_2_PI                   // 360 Grad
#define RAD_180 M_PI                     // 180 Grad
#define RAD_90  M_PI_2                   //  90 Grad
#define RAD_45  M_PI_4                   //  45 Grad
#define RAD_30  ??                       //  30 Grad
*/

// angles ..
#define RAD_360  6.2831853071795862319    // 360 Grad
#define RAD_270  4.7123889803846896739    // 270 Grad
#define RAD_225  3.92699081698724151736   // 225 Grad
#define RAD_180  3.14159265358979323846   // 180 Grad
#define RAD_135  2.3561944901923448368    // 135 Grad
#define RAD_90   1.5707963267948965579    //  90 Grad
#define RAD_60   1.0471975511965976313    //  60 Grad
#define RAD_45   0.7853981633974482789    //  45 Grad
#define RAD_30   0.5235987755982988156    //  30 Grad
#define RAD_10   0.174532925199432954     //  10 Grad
#define RAD_1    0.0174532925199432954    //   1 Grad
#define RAD_01   0.0017453292519943295    //   0.1 Grad
#define SR_3     1.7320508075688772       // SQRT(3)
#define SR_2     1.4142135623730951       // SQRT(2)
#define SR_PI    1.7724538509055159       // SQRT(PI) = SQRT(RAD_180)


#define CCW                1             // 2006-10-18
#define CW                -1


#define YES                0             // FALSE
#define NO                 1             // TRUE

#define ON                 0             // FALSE
#define OFF                1             // TRUE


/*
enum TYP_OBJ {
  Typ_Error  = 0,
  Typ_VAR    = 1,
  Typ_PT     = 2,
  Typ_LN     = 3,
  Typ_CI     = 8,
  Typ_AC     = 4,
  Typ_VC     = 5,
  Typ_CVPOL  = 7,
  Typ_CVPSP3 = 11,
  Typ_CVBSP  = 9,
  Typ_CVCCV  = 10,
  Typ_CVELL  = 31,
  Typ_CVBEZ  = 32}
*/


#define Typ_Error          0  // U   U0 = undefined
#define Typ_VAR            1  // V   numer. variable
#define Typ_PT             2  // P   point
#define Typ_LN             3  // L   Line
#define Typ_CI             4  // C    do not use; use Typ_AC.
#define Typ_AC             5  // C        Circ
#define Typ_VC             6  // D        Vector
#define Typ_CV             7  // S
#define Typ_CVPOL          8  // S        CurvPoly
#define Typ_CVPSP3         9  // S
#define Typ_CVBSP         10  // S        CurvBSpl
#define Typ_CVRBSP        11  // S        CurvRBSpl
#define Typ_CVCCV         12  // S
#define Typ_CVELL         13  // S        CurvElli
#define Typ_CVBEZ         14  // S        CurvBez
#define Typ_CVRBEZ        15  // S        CurvRBez
#define Typ_CVCLOT        16  // S   ClothoidCurve

#define Typ_APPOBJ        20
#define Typ_PT2           22
#define Typ_LN2           23
#define Typ_AC2           24
#define Typ_CI2           25
#define Typ_VC2           26
#define Typ_CV2           27
#define Typ_CVPOL2        28
#define Typ_CVPSP2        29
#define Typ_CVBSP2        30
#define Typ_CVRBSP2       31
#define Typ_CVCCV2        32
#define Typ_CVELL2        33
#define Typ_CVBEZ2        34

// unbegrenzte Flaechen:
#define Typ_PLN           70  // R  plane/Refsys
#define Typ_SOL           71  // B  body (CON, TOR, ..)
#define Typ_SPH           72  // B  sphere
#define Typ_CON           73  // B  conus
#define Typ_TOR           74  // B  torus
#define Typ_CYL           75  // B  torus


// begrenzte Flaechen:
#define Typ_SUR          150  // A
#define Typ_SURCIR       151
#define Typ_SURSTRIP     152
#define Typ_SURRU        153  // Ruled Sur
#define Typ_SURRV        154  // Revolved Sur
#define Typ_SURPLN       155  // Planar surf.
#define Typ_SURCON       156  // Conus
#define Typ_SURTOR       157  // Torus
#define Typ_SURBSP       158  // A B_Spline_Surf       SurBSpl
#define Typ_SURRBSP      159  // A Rat.B_Spline Surf   SurRBSpl
//#define Typ_SURSPI       158  // Spine (Kontur + Verfahrweg; zB Spiralfl.)
//#define Typ_SURSK        153  // Skin
#define Typ_SURMSH       160  // Mesh
#define Typ_SURHAT       161  // Hatch
#define Typ_SURPHN       162  // surf from polyhedralNet
#define Typ_SURPTAB      149  // surf from PTAB

#define Typ_Fac3         215  // Triangle
#define Typ_QFac         163  // 
#define Typ_Tria         164  // Triangle

//#define Typ_TRI           74
//#define Typ_RFac          75
//#define Typ_RCone         76


#define Typ_GL_Sur       210     // tesselated surface
#define Typ_GL_PP        211     // tesselated planar patch
#define Typ_GL_CV        212     // Polygon


#define Typ_ATXT          40
#define Typ_GTXT          41  // N  Note  N20=... GroupCode f ATXT Dimen
#define Typ_Dimen         42      // f. N20=...
#define Typ_Dim3          53      // f. N20=...
#define Typ_Txt           43  // $  ohne ", normal mit , begrenzt f. $20=
#define Typ_String        44      // durch " begrenzt
#define Typ_SymB          45      // bitmap symbols: SYM_TRI_S SYM_STAR_S ..
#define Typ_SymV          46      // Vektorymbole: SYM_PLANE SYM_ARROW ..
#define Typ_StrDel        47      // StringDelimiter "\" Fortsetzungszeile 
#define Typ_StrDel1       48      // StringDelimiter 1 "|"
#define Typ_Tag           49      // Bitmap (Blocknote, Image ..)


#define Typ_Box           50
#define Typ_TmpPT         51
#define Typ_TmpLN         52
#define Typ_TmpVC         54
#define Typ_TmpSym        55

#define Typ_EyePT         56

#define Typ_TmpTRI        61
#define Typ_TmpPLN        62

// 70-80 fuer selectionTypes:           GeoTypen.   selectionTypes:
#define Typ_goGeom        80      // alle
#define Typ_goPrim        81      // PT/LN/CI/Spline; nicht Plg,CCV
#define Typ_lFig          82      // geom. Obj. Linear LN/CI/CV
#define Typ_goGeo1        86      // geom. Obj. LN/CI/CV/PL/Sur/Sol (nicht PT)
#define Typ_goGeo2        87      // geom. Obj. CI/ELL (prj -> PLN)
#define Typ_goGeo3        88      // geom. Obj. PT/LN/CI/CV CW CCW MOD (Contour)
#define Typ_goGeo4        89      // geom. Obj. VC/LN/PLN
#define Typ_goGeo5        83      // geom. Obj. CIR/ELL/CCV (closed cont.)
#define Typ_goGeoSUSU     84      // Supporting Surface (CON/TOR/SRU/SRV/SBS)
#define Typ_goGeo6        85      // geom. Obj. PT/VC/LN
#define Typ_goGeo7        79      // ANG/PT  angle (0-360) od angle from point
#define Typ_goGeo8        78      // Val/PT  parameter (0-1) od par. from point
#define Typ_goAxis        77      // RotAxis LN/PT+PT/PT+LN/PT+VC/PLN
#define Typ_goRadius      76      // Radius  Val/PT/AC

#define Typ_Ditto         90
#define Typ_Group         91      // U ObjGX
#define Typ_Layer         92
#define Typ_apDat         93      // application-data
#define Typ_TEXB          94      // Base-Texture
#define Typ_TEXR          57      // Ref-Texture
#define Typ_Part          98
#define Typ_SubModel      97  // M  - basicModel
#define Typ_Model         99  // M  - ModelReference
#define Typ_Mock          95

#define Typ_Typ          106  // form of ObjGX-Record defines Typ
#define Typ_Address      107  // form of ObjGX-Record defines dataPosition
#define Typ_Size          96  // recordSize for following record
#define Typ_Index        100  // int oder long-Tabelle
#define Typ_Name         101
#define Typ_Color        102
#define Typ_Ltyp         103
#define Typ_Thick        104
#define Typ_G_Att        105  // G
#define Typ_Tool         108
#define Typ_Activ        109  // I = Interactivity

#define Typ_Val          110  // double-Value
#define Typ_ValX         124
#define Typ_ValY         125
#define Typ_ValZ         126
#define Typ_XVal         111
#define Typ_YVal         112
#define Typ_ZVal         113
#define Typ_Angle        114
#define Typ_Rad          115
#define Typ_Dist         116
#define Typ_Par1         127  // Parameter 0-1; for knotvals use Typ_Val

#define Typ_UVal         128
#define Typ_VVal         129
#define Typ_AngN         117
#define Typ_AngP         118
#define Typ_RadISO       119
#define Typ_Conic        120
// #define Typ_Side         121  // hi, lo, le or ri
// #define Typ_Side1        122  // in or out
#define Typ_DirS         123  // X / Y / Z / P

#define Typ_Int1         135   // ein char
#define Typ_Int2         136   // 16 bit
#define Typ_Int4         137   // 32 bit-int
#define Typ_Float4       138   // 32 bit-float
#define Typ_Float8       139

#define Typ_Polynom1     165   // Polynom1
#define Typ_Polynom3     166   // Polynom3
#define Typ_Polynom_     167
#define Typ_polynom_d3   168

#define Typ_M3x2         145   // Mat_3x2
#define Typ_M3x3         146   // Mat_3x3
#define Typ_M4x3         147   // Mat_4x3
#define Typ_M4x4         148   // Mat_4x4

#define Typ_Memspc       140
#define Typ_ObjG2        141
#define Typ_ObjG         142
#define Typ_ObjGX        143

#define Typ_Tra          130  // T
#define Typ_TraTra       131  // Translation // dzt unused; Typ_VC used
#define Typ_TraRot       132  // Rotation
#define Typ_TraMat       133  // Matrixtransformation

#define Typ_ope_eq       221
#define Typ_ope_ne       222
#define Typ_ope_lt       223
#define Typ_ope_gt       224
#define Typ_ope_ge       225
#define Typ_ope_le       226

#define Typ_cmdNCsub     170
#define Typ_Subtyp       172

#define Typ_modif        175  // Modifier
#define Typ_modCoord     176  // Modifier; HIX LOX HIY LOY HIZ LOZ
#define Typ_modCWCCW     177  // Modifier; CW CCW
#define Typ_modAux       178  // Modifier; Value depends
#define Typ_modREV       179  // Modifier; Reverse
#define Typ_modCX        173  // Modifier ACROSS (Default = Along)
#define Typ_modCTRL      174
#define Typ_modHIX       180
#define Typ_modLOX       181
#define Typ_modHIY       182
#define Typ_modLOY       183
#define Typ_modHIZ       184
#define Typ_modLOZ       185
#define Typ_modCCW       186
#define Typ_modCW        187
#define Typ_modIN        188
#define Typ_modOUT       189


#define TYP_FuncInit     190
#define TYP_FuncInit1    191
#define TYP_FuncMod      192
#define TYP_FuncAdd      193
#define TYP_FuncDel      194
#define TYP_FuncEnd      200
#define TYP_FuncExit     201

#define TYP_EvMouseL     230
#define TYP_EvMouseM     231
#define TYP_EvMouseR     232
#define TYP_EvMouse2L    233  // doubleclick

#define TYP_FilNam       238
#define Typ_CtlgPart     239

#define Typ_ALL          240
#define Typ_Done         241
#define Typ_NULL         241  // nothing empty


#define BCKPLN_XY          2      // Z-Vec BCKVEC_Z
#define BCKPLN_XZ          1      // Y-Vec BCKVEC_Y 
#define BCKPLN_YZ          0      // X-Vec BCKVEC_X

#define BCKVEC_Z           2      // Z-Vec BCKPLN_XY
#define BCKVEC_Y           1      // Y-Vec BCKPLN_XZ
#define BCKVEC_X           0      // X-Vec BCKPLN_YZ


#define GL_TRIANGLE_NPFAN 16      // non planar fan (GL_TRIANGLE_FAN = planar)



// AP_ck_ftyp
#define Mtyp_Gcad       0
#define Mtyp_DXF        1
#define Mtyp_Iges       2
#define Mtyp_Step       3
#define Mtyp_3DS        4
#define Mtyp_LWO        5
#define Mtyp_XML        6
#define Mtyp_WRL       10    // VRML1      10-19  tess-Formate
#define Mtyp_WRL2     110    // VRML2
#define Mtyp_OBJ       11
#define Mtyp_STL       12
#define Mtyp_TESS      13
#define Mtyp_BMP       20    // 20-29 PixelImages





#ifndef TimeStamp
#define TimeStamp  float
// typedef float TimeStamp;
#endif


//....................... Math. Objects: ..................................
typedef double Mat_3x2[2][3];
typedef double Mat_3x3[3][3];
typedef double Mat_4x3[3][4];            // size 96
typedef double Mat_4x4[4][4];

typedef struct {double e0, e1, e2, e3;}                             Quat;

typedef struct {double a, b;}                                       dcomplex;
typedef struct {double a, b, c, d;}                                 polcoeff_d3;
typedef struct {double a, b, c, d, e;}                              polcoeff_d4;
typedef struct {double a, b, c, d, e, f;}                           polcoeff_d5;

// Typ_polynom_d3 Typ_CVPSP3
typedef struct {double u; polcoeff_d3  x, y, z;}                    polynom_d3;
// size = 104


// Typ_Polynom1
typedef struct {int polNr; double *pol;}                            Polynom1;
// Struktur von pol:  double pol[polNr]

// Typ_Polynom3
typedef struct {int polNr; double *pol[3];}                         Polynom3;
// Struktur von pol:  double pol[3][polNr]


typedef struct {int dim1, dim2; double *pol;}                       Polynom_;
// Struktur von pol:  double pol[dim1][dim2]
// Zugriff pol[ind1*dim2*ind2] entspricht pol[ind1][ind2] !






//....................... Geom. Objects: ..................................
// Typ_PT2
typedef struct {double x, y;}                                       Point2;
// size = 16

// Typ_PT
typedef struct {double x, y, z;}                                    Point;
// size = 24

// Typ_VC2
typedef struct {double dx, dy;}                                     Vector2;
// size = 16

// Typ_VC
typedef struct {double dx, dy, dz;}                                 Vector;
// size = 24

typedef struct {Point p; Vector v;}                                 Ray;

// Typ_LN2
typedef struct {Point2 p1, p2;}                                     Line2;

// Typ_LN
typedef struct {Point p1, p2;}                                      Line;


// Typ_Tria
typedef struct {Point *pa[3];}                                      Triangle;
// 3 pointers !


// Typ_CI2, Typ_AC2    2004-08-06 ango added. RF.
typedef struct {Point2 p1, p2, pc; double rad, ango;}               Circ2;
// p1     .. startpoint
// p2     .. endpoint
// pc     .. Centerpoint
// rad    .. radius; positiv for CCW, negative for CW
// ango   .. opening angle in rad; positiv for CCW, negative for CW
// size = 64

// Typ_CI, Typ_AC      2004-08-06 ango added. RF.
typedef struct {Point p1, p2, pc; Vector vz; double rad, ango;}     Circ;
// p1     .. startpoint
// p2     .. endpoint
// pc     .. Centerpoint
// vz     .. axis
// rad    .. radius; positiv for CCW, negative for CW
// ango   .. opening angle in rad
// size = 112

// Typ_CVELL
typedef struct {Point p1, p2, pc; Vector vz, va, vb; int dir;}      CurvElli;
// dir    .. 1=CCW, -1=CW
// size = 148


// do not use; replaced by ObjGX
typedef struct {int typ, cvnr, ind1, ind2; Point p1, p2;
                 long ID1, ID2;}                                    Curv;


// Typ_CVPOL
typedef struct {int ptNr; double v0, v1, *lvTab; Point *cpTab;}     CurvPoly;
// ptNr    ... number of control points
// v0      ... start parameter (len-offset)
// v1      ... end parameter (len-offset)
// lvTab[ptNr] length absolut
// cpTab[ptNr] cornerpoints
// size = 28


// Curve: B-spline   Typ_CVBSP
typedef struct {int ptNr, deg; double v0, v1, *kvTab;
                Point *cpTab;}                                      CurvBSpl;
// ptNr    ... number of control points
// deg     ... degree of B-spline curve
// v0      ... B-spline curve start parameter
// v1      ... B-spline curve end parameter
// kvTab[ptNr+deg+1] knot values (non-decreasing, <= v0 < v1 <= )
// cpTab[ptNr]       control points
// size = 32


// Rational B-Spline-curve; Typ_CVRBSP
typedef struct {int ptNr, deg; double v0, v1, *kvTab, *wTab;
                Point *cpTab;}                                      CurvRBSpl;
// ptNr              ... number of control points
// deg               ... degree
// v0                ... start parameter
// v1                ... end parameter
// kvTab[ptNr+deg+1] ... knot values (non-decreasing)
// wTab[ptNr]        ... weights
// cpTab[ptNr]       ... control points
// size = 36


// 2D-Bezier curve  Typ_CVBEZ2
typedef struct {int ptNr; Point2 *cptab; double va, vb;}            CurvBez2;


// Bezier curve     Typ_CVBEZ
typedef struct {int ptNr; Point *cptab; double va, vb;}             CurvBez;
// ptNr   ... number of control points; degree = (ptNr - 1)
// cptab  ... control points of Bezier curve (number = ptNr)
// va, vb ... global end-parameters of Bezier curve
// size = 24


// Rational Bezier curve
typedef struct {int ptNr;Point *cptab;double *wtab;double va, vb;}  CurvRBez;
// ptNr   ... number of control points; degree = (ptNr - 1)
// cptab[ptNr] control points of rational Bezier curve
// wtab[ptNr]  weights of rational Bezier curve (number = ptNr)
// va, vb ... global end-parameters of rational Bezier curve


// // Typ_CVVC    2007-03-24 RF.
// // Curve with Vectors for all Curvepoints from Offsetcurve.
// typedef struct {void *cv1; void *cv2; int cTyp;}                    CurvVec;


// Clothoid curve   Typ_CVCLOT
typedef struct {Point stp; Vector stv, plv;
            double pc, cs, ce; int lr;}                     CurvClot;
// stp     ... startpoint
// stv     ... startvector
// plv     ... normalvector of plane of curve (not parallel stv)
// pc      ... curvetype parameter (>0)
// cs      ... curvature at startpoint (>=0)
// ce      ... curvature at endpoint (>=0, !=cs)
// lr      ... 0/1 <=> left/right bended curve


// Typ_PLN
typedef struct {Point po; Vector vx, vy, vz; double p;}             Plane;
// size = 104
// (pln.vz.dx * p.x) + (pln.vz.dy * p.y) + (pln.vz.dz * p.z) + pln.p = 0


// Hatch  Typ_SURHAT
typedef struct {int cvID; float off, dir;}                          SurHat;
// off = offset of hatchlines
// dir = direction


// RevolvedSurf Typ_SURRV
typedef struct {double ang1, ang2, v0, v1;
                long indCen, indCov;  short typCen, typCov; }       SurRev;
// indCen = Nr of Centerline
// typCen = typ of Centerline (dzt nur Typ_LN)
// indCov = Nr of contour(-cover)element
// typCov = typ of contourelement
// ang1   = starting angle in rad
// ang2   = ending angle in rad
// v0,v1  = start/end-parameters of contour; for all types of contour 0-1


// StandardSurf (planar, conic, toroid)  Typ_SUR
typedef struct {long baseID, cvID;
                unsigned typ:8, cvTyp:8;}                           SurStd;
// typ = Typ_SURPLN (planar), Typ_SURCON (Conus), Typ_SURTOR (Torus)
// base = basic body (Conus, Torus, Sur-RU, SurBSP ...)
// cv   = limitcurve (CI, CCV ..)


// Area: 1-n Stripes; 1.Stripe: U=0,1; 2.Stripe: U=1,2 ...
// ptNr = ptUNr * ptVNr.
typedef struct {long ptUNr, ptVNr, *ptiTab;}                        SurStripe;


// Area: B-Spline-Surf   Typ_SURBSP
typedef struct {long ptUNr, ptVNr, degU, degV;
                double v0U, v1U, v0V, v1V, *kvTabU, *kvTabV;
                Point *cpTab;}                                      SurBSpl;
// cpTab[ptUNr*ptVNr]    u0v0,u1v0..uUv0;u1v0,u1v1..uUv1;..;uUv0,uUv1..uUvV;
// kvTabU[ptUNr+degU+1]
// kvTabV[ptVNr+degV+1]
// size = 60


// Area: Rat.B-Spline-Surf   Typ_SURRBSP
typedef struct {long ptUNr, ptVNr, degU, degV;
                double v0U, v1U, v0V, v1V, *kvTabU, *kvTabV, *wTab;
                Point *cpTab;}                                      SurRBSpl;
// cpTab[ptUNr*ptVNr]    u0v0,u1v0..uUv0;u1v0,u1v1..uUv1;..;uUv0,uUv1..uUvV;
// kvTabU[ptUNr+degU+1]
// kvTabV[ptVNr+degV+1]
// wTab[ptUNr*ptVNr]
// size = 64


// Typ_Color
typedef struct {unsigned cr:8, cg:8, cb:8,
                  unused:3, vtra:2, vsym:1, vtex:1, color:1;}       ColRGB;
// vtra   view transparent; 0=not, 1=25% transparent, 2=50%, 3=75%
// vtex   has texture; 0=not, 1=yes; (cr+cg+cb) = textureRefNr
// vsym   view normal (0,shaded) or symbolic (1,wireframeboundary)
// color  0=color not active; 1=color from cr/cg/cb
// size = 4


// Typ_ATXT, Typ_Tag ..
typedef struct {Point p1, p2; char *txt;
                float scl; char typ, col, ltyp;}                    AText;
// p1   Textblock-/Imageposition (links Mitte)
// p2   Startpunkt Leaderline
// scl  Scale (for Image)
// typ  0=Text, 1=Image, 2=Label-Block, 3=Label-Kreis  4=PointCoord
//      5=Symbol SYM_STAR_S (Stern klein) 6=Symbol SYM_TRI_S (Dreieck klein)
//      7=Symbol SYM_CIR_S (Kreis klein)  8=SYM_TRI_B (Viereck)
//      9=Vector (normalized)            10=Vector (true length)
// col  Farbe fuer Label; -1=kein Label
// ltyp Linetyp Leaderline; -1=keine Leaderline.
// txt  Text/ImageFilename


// Typ_TEXB
typedef struct {long dli; char *fnam;
                short xSiz, ySiz, texNr, keep;}                     TexBas;
// dli          DispListindex of the Texture
// texNr        (OpenGL-) TextureNr
// keep         0=do not keep texture; 1=keep.
// fnam         Filename (symbolicPath/Filename) of the Texturefile
// xSiz, ySiz   size of the Texure in pixels


// Typ_TEXR
typedef struct {long ibas; float uscx, uscy, udx, udy, uar;
                float scx, scy, dx, dy; Vector vx, vy;}             TexRef;
// ibas         index of the Base-Texure
// uscx uscy    User-defined-scale in X- and Y-direction;
// udx  udy     User-defined-offset of texture; 0-1
// uar          User-defined-rotationAngle for texture in degree
// scx scy      scale in X- and Y-direction;
// dx, dy       offset of texture; 0-1
// vx, vy       X- and Y-vector of textureplane


// Typ_GTXT
typedef struct {Point pt; float size, dir; char *txt;}              GText;


// Typ_Ditto
typedef struct {Point po; long ind, siz;}                           Ditto;


typedef struct {char *mnam; long ind, siz;
                Point po; Vector vx, vz;}                           ModelMock;
// ind   DL-startindex of ditto
// siz   nr of DL-objects of ditto
// po    position of ditto


// Typ_SubModel
typedef struct {char *mnam; Point po; long DLind, DLsiz;
                short typ, seqNr;}                                  ModelBas;
// po    .. origin
// DLind .. ind of first obj in DL
// DLsiz .. nr of objects in DL


// Typ_Model
typedef struct {char *mnam; int modNr; double scl;
                Point po; Vector vx, vz;}                           ModelRef;
// modNr .. modelnumber of ModelBas-obj. (DB_get_ModNr())
// po    .. position of ditto


// Typ_ModelNode
typedef struct {int mod, par, ind;}                                 ModelNode;
// mod    basicModelIndex
// par    parent - basicModelIndex
// ind    ref.ModelIndex (= APT-Index)


// Typ_SPH
typedef struct {Point pc; double rad;}                              Sphere;
// pc     ... center
// rad    ... radius
// siz = 32


// Typ_CON
typedef struct {Plane pl; double r1, r2, h;}                        Conus;
// pl.po ... center of circle 1
// pl.vx ... vec -> startpoint of circle 1 (radius = r1)
// pl.vz ... axis
// h     ... distance circle 1 - circle 2
// siz = 128


// Typ_TOR
typedef struct {Plane pl; double r1, r2;}                           Torus;
// pl.po ... center
// pl.vz ... axis
// pl.vx ... vec -> startpoint of major circle (radius = r1-r2)
// r1    ... radius of outermost circle !!
// r2    ... radius of torusring
// siz = 120


// Typ_REV


// Typ_Dimen
typedef struct {Point2 p1, p2, p3; float a1, a2;
			          char dtyp, hd, ld, uu; char *txt;}                  Dimen;
// dtyp: 0=Linearmasz 3=Winkelmasz 11,12=Durchmesser 21=Leader
// hd:   heads: 0=none, 1=<, 2=>, 3=/, 4=X; Default is 12.
// hl    lines: 0=none, 1=line; Default is 11.


// Typ_Dim3
typedef struct {long ip1, ip2, ipt;
                char dtyp, hd, ld, bp; char *txt;}                  Dim3;
// dtyp: X Y Z blank=parallel
// bp    Backplane  0=BCKPLN_YZ; 1=BCKPLN_XZ; 2=BCKPLN_XY



//....................... Geom. Attributes: ..................................

typedef struct {unsigned  col:4, ltyp:4, lthick:4, 
                          unused:15, used:1;}                       GR_Att;
// size = 4


// PermanentAttributRecord
typedef struct {long ind;
                unsigned long iatt;
                unsigned lay:16, typ:8,
                         unused:7, disp:1;}                         ObjAtt;
// typ    DB-Typ
// ind    DB-Index
// iatt   for typ=LN/AC/Curve: LineTypNr.
//        for typ=TAG/IMG: sx/sy
//        for typ=Surf/Model: ColRGB
// disp   0=normal; 1=hidden
// oNam   objectname; not yet impl.
// size = 12


typedef struct {long ind, lNr, irs;
                unsigned long iatt;
                unsigned modInd:16, typ:8,
                         disp:1,  pick:1,  hili:1,  dim:1,
                         grp_1:1, temp:1,  unvis:1, sPar:1;}        DL_Att;
// lNr    APTlineNr.
// typ    DB-Typ
// ind    DB-Index
// irs    index RefSys
// modInd ModelNr
// iatt   for typ=LN/AC/Curve: LineTypNr.
//        for typ=TAG/IMG: sx/sy
//        for typ=Surf/Model: ColRGB
//        in Parent-state DL-index of child
// disp, hili:
//        normal = ((disp == 0)&&(hili == 1))
//        hilite = ((disp == 1)&&(hili == 0))
//        hidden = ((disp == 1)&&(hili == 1))
// pick   0=unpickable, 1=pickable
// unvis  0=visible; 1=obj does not have graph. representation
// sPar   0=independent; 1=Parent-state is active.
// grp_1  0=belongs to active Group, 1=not
// size = 16


// Typ_TraRot:
typedef struct {Mat_4x3 ma; Vector vz; double angr;}                TraRot;
// rotationOrigin = ma[0][3], ma[1][3], ma[2][3].
// vz = rotationAxis
// angr = rotationAngle (rad)
// size = 128


// Typ_Activ ("I")
typedef struct {int typ; long ind; char *data;}                     Activity;
// typ,ind     Activity connected to this obj
// data        commandText




//....................... Tess. Objects: ..................................

typedef struct {Point *pTab; int pNr; char *pTyp;}                  Verts;
// pTyp[pNr]: NULL=undefined;
//            0=internal; 1=internal&crease;
//            2=boundary; 3=boundary&crease


typedef struct {int *ipt; int *inf;}                                Face;
// ipt:  index points; 3 or 4
// inf:  index neighbor-faces; 3 or 4


typedef struct {int i1, i2, i3;}                                    Fac3;
// ipt:  index points; 3 or 4
// inf:  index neighbor-faces; 3 or 4


typedef struct {void *fTab; int fNr; int fTyp;}                     Faces;
// fTyp = 3: Face/TriangleMesh; fTab = *Face; Face->ipt = int[3];
// fTyp = 4: Face/QuadMesh;
// fTyp = 5: Fac3/tableOfTriangleIndices; fTab = *int; iTab[fNr][3];
// fTyp = 6: optimized format


typedef struct {int ipt[2];}                                        Edge;
// ipt:  index points;


typedef struct {int i1, i2;}                                        Edg3;
// i1, i2 index to points


// Face with NeigbourFaces
typedef struct {int ip1, ip2, ip3, if1, if2, if3;}                  FacNf;
// ip1, ip2, ip3   index to points
// if1, if2, if3   index to NeigbourFaces. -1=outerBound; -2=unresolved; -3=new
//                ip3
//         if3   /  |
//            /     | if2
//         /        |
//   ip1 ----------ip2
//          if1


typedef struct {Edge *eTab; int eNr; char *eTyp;}                   Edges;
// eTyp[eNr]: NULL=undefined;
//            0=internalEdge; 2=boundaryEdge;


// Typ_SURMSH  2007-03-24 TB.
typedef struct {Verts *p; Faces *f; Edges *e; int mTyp;}            Mesh;
// f:    Faces; NULL=not yet created
// e:    Edges; NULL=not yet created
// mTyp: 0=open_mesh; 1=closed_mesh.




//....................... NC. Objects: ..................................

typedef struct {double dmr;}                                        BTool;





//....................... containerobjects: ................................


// Typ_Memspc
typedef struct {TimeStamp ts; void *start; void *next; void *end;}  Memspc;
// ts     TimeStamp for owner
// start  startpos of memspc
// next   first free pos of memspc
// end    position of start + memspcSiz


// Typ_ObjGX
// complex-object; can hold primitives (Point ..),
// or a table of ObjGX
typedef struct {short typ, form; void *data;
			          unsigned siz:24, dir:1, aux:7;}                     ObjGX;
// typ   what info is in the record in *data
// form  type of record of *data
// data  address of data; if(form==Typ_Index) data=(long)DB-Index
// siz   number of records in *data; all of them have structure "form"
// dir   direction; 0=normal, 1=reverse.
// size = 12


// Typ_Group
typedef struct {int typ; long ind; unsigned char stat;}             ObjGrp;
// typ   DB-typ
// ind   DB-index


// do not use; replaced by ObjGX.
// primitive 2D-object.
typedef struct {int typ, att, ID, ID1; Point2 p1, p2, pc;
                 double rad; long nam;}                             ObjG2;


// do not use; replaced by ObjGX.
// primitive object; Pt, Ln or Ci.
typedef struct {int typ, att; long ID; void *data;
                Point p1,p2,pc; Vector vz; double rad;}             ObjG;


// can be replaced by ObjGX.data
typedef union {Point *pt; Line *ln; Vector *vc;
               Circ *ci; ObjGX *cv; CurvElli *el;
               CurvPoly *plg; CurvBSpl *bsp;
               void *vp;}                                           ObjX;
// size = void* = 4
// do not use; replaced by ObjGX.


typedef union {Point pt; Vector vc; Line ln; Circ ci;}              ObjUX;
// do not use; replaced by ObjGX.


typedef struct {Point *pa; Point *p2a; int iNr;
                Point p1, p2;
                unsigned char typ, use, dir, unused;}               ContTab;
// pa      PointArray 3D-Points
// p2a     PointArray 2D-Points (Format 3D-Point!)
// iNr     Nr of points
// p1,p2   BoundingBox
// typ     C=Contour A=Automatic
// use     A=active, I=inactive,
//         B=Base, C=Cut-Fenster, M=Merged (results), D=deleted.
// dir     '+'=counterclockwise, '-'=clockwise





//....................... aux. structs: ..................................
typedef union {long i4; short i2[2];}                               uni_i4i2;
typedef struct {short i20, i21;}                                    stru_2i2;
typedef struct {unsigned b123:24, b4:8;}                            stru_c3c1;



//.........................................................................

// tolerances depending from Modelsize:
// identical Points-tolerence
extern double UT_TOL_pt;
// max Abweichung Curve. (Tol. bei Umwandlung Curve -> Polygon).
extern double UT_TOL_cv;
// Toleranz fuer die Behandlung einer Menge von Punkten als Gerade
extern double UT_TOL_ln;
// max. Abweichung bei der Darstellung von Kreisen, Kurven
extern double UT_DISP_cv;




// ------------- constants defined in ut_geo.c ------------- 
extern double UT_TOL_min0;
extern double UT_TOL_min1;
extern double UT_TOL_min2;
// tolerance for parallelism
extern double UT_TOL_PAR;
// tolerance for Angle 0.01 Grad
extern double UT_TOL_Ang1;


extern const double UT_VAL_MIN;
extern const double UT_VAL_MAX;
extern const double UT_DB_LEER;
extern const double UT_DB_NULL;
extern const int    UT_INT_MAX;
extern const int    UT_I2_MAX;
extern const char   UT_CHR_NULL;


extern const Point2  UT2D_PT_NUL;
extern const Point   UT3D_PT_NUL;

extern const Vector2 UT2D_VECTOR_NUL;
extern const Vector2 UT2D_VECTOR_X;
extern const Vector2 UT2D_VECTOR_Y;

extern const Vector  UT3D_VECTOR_NUL;

extern const Vector  UT3D_VECTOR_X;
extern const Vector  UT3D_VECTOR_Y;
extern const Vector  UT3D_VECTOR_Z;

extern const Vector  UT3D_VECTOR_IX;
extern const Vector  UT3D_VECTOR_IY;
extern const Vector  UT3D_VECTOR_IZ;

extern const Mat_3x3 UT3D_MAT_3x3;
extern const Mat_4x3 UT3D_MAT_4x3;
extern const Mat_4x4 UT3D_MAT_4x4;



#define OBJ_SIZ_MAX        160        // max. obj-size (for get, copy ..)
                                      // 160 = 5 * 32
#define UT_BEZDEG_MAX       50        // maximal degree of Bezier curve







/*============== Belegung der att - Bitfelder ============================= */
#define ATT_BIT_ABS          1  /* das Absolut-Bit; Achtung:
                                   0=ON=absolut, 1=relativ! */
#define ATT_BIT_LIM          2  /* Limited; 0=On;
                                   2=unbegrenzte Linie/Vollkreis */

/*
zB. Absolut-Bit setzen (mit OR):      obj.att = obj.att | ATT_BIT_ABS;
    Absolut-Bit filtern (mit AND; ergibt 0 oder ATT_BIT_ABS):
      i1 = obj.att & ATT_BIT_ABS;
      Achtung: entspricht NICHT ON/OFF!
*/






//================================================================
// prototypes for gcad_ut_geo.c

 // ut_mem.o:
 int    MEM_swap__   (void *stru1, void* stru2, long strSiz);
 int    MEM_swap_int (int *i1, int *i2);
 int    MEM_swap_2db (double *d1, double *d2);


 int    MEM_ins_rec  (void *insPos, long movSiz, void *insDat, long insSiz);
 int    MEM_chg_rec  (void *datStart, long *datSiz,
                      void *insDat,   long insSiz,
                      void *delPos,   long delSiz);
 int    MEM_ins_nrec (int *recNr, void *recTab,
                     int ipos, void *insDat, int insRecNr, int sizRec);
 int    MEM_del_nrec (int *recNr, void *recTab,
                     int ipos, int delRecNr, int sizRec);


//----------------------------------------------------------------
 int    UTP_comp_0  (double);
 int    UTP_compdb0 (double, double);
 int    UTP_comp2db (double, double, double);
 int    UTP_comp2x2db (double d11,double d12,double d21,double d22,double tol);
 int    UTP_db_ck_in2db (double v, double v1, double v2);
 int    UTP_db_ck_in2dbTol (double v, double v1, double v2, double tol);
 int    UTP_db_cknear_2db (double *db, double *d1, double *d2);
 int    UTP_db_cknear_ndb (double db1, int dbNr, double *dbTab);
 double UTP_db_rnd1sig (double);
 double UTP_db_rnd2sig (double);


 int    UT1D_ndb_npt_bp (double *da, Point *pa, int pNr, int bp);

 double UT_DEGREES (double);
 double UT_RADIANS (double);

 int    UT2D_sidPerp_3pt (Point2 *p1, Point2 *p2, Point2 *p3);

 int    UT2D_angr_set (double *angr);
 int    UT2D_2angr_set (double *ang1, double *ang2, int irot);
 double UT2D_angr_2angr (double ang1, double ang2, int irot);
 int    UT2D_ptNr_ci  (double rdc, double ao, double tol);

 int    UT2D_solvtriri_a (double *a, double b, double c);
 int    UT2D_solvtriri_ac (double *,double *,double,double);
 int    UT2D_solvtri_abc (double *,double *,double,double,double);

 int    UT2D_ckBoxinBox1 (Point2 *p1, Point2 *p2, Point2 *p3, Point2 *p4);
 int    UT2D_ckBoxinBox2 (Point2*, Point2*, Point2*, Point2*, double);

 double UT2D_skp_2vc (Vector2 *, Vector2 *);
 double UT2D_skp_vc2pt (Vector2 *, Point2 *, Point2 *);
 double UT2D_acos_2vc (Vector2 *, Vector2 *);
 double UT2D_acos_vc2pt (Vector2 *, Point2 *, Point2 *);
 double UT2D_crossprod_2vc (Vector2 *, Vector2 *);

 double UT2D_angd_angr (double);
 double UT2D_angd_invert (double *andi);
 double UT2D_angr_angd (double);
 double UT2D_angr_triri_ab (double, double);
 double UT2D_angr_ptpt (Point2 *, Point2 *);
 double UT2D_angr_vc   (Vector2 *);
 double UT2D_angr_2ln (Line2 *, Line2 *);
 double UT3D_angr_vc2pt (Point *pz, Vector *vz, Point *p1, Point *p2);
 double UT3D_angr_vcpl (Plane *pl1, Vector *vc1);
 double UT3D_angr_2pl (Plane* pl1, Plane* pl2);
 double UT2D_angr_2vc (Vector2 *, Vector2 *);
 double UT2D_angr_3ptdr (Point2 *, Point2 *, Point2 *, int);
 double UT3D_angr_4pt (Point *p11, Point *p12, Point *p21, Point *p22);
 double UT2D_angr_ci (Point2 *pa,Point2 *pe,Point2 *pc,double rad_in);
 double UT3D_angr_cipt (Circ *ci1, Point *pti);
 double UT2D_angr_perpangr (double*);

 double UT2D_len_vc (Vector2 *);
 double UT2D_lenq_vc (Vector2 *);
 void   UT2D_lenq_2pt (double *lq, Point2 *p1, Point2 *p2);
 double UT2D_len_2pt (Point2 *,Point2 *);
 double UT2D_lenB_2pt (Point2 *p1, Point2 *p2);
 int    UT2D_minLenB_4pt (double *dp,Point2*,Point2*,Point2*,Point2*);
 int    UT3D_minLen_3pt (double*,Point*,Point*,Point*);
 int    UT3D_minLen_4pt (double*,Point*,Point*,Point*,Point*);
 double UT2D_len_ptln (Point2 *pt, Point2 *pa, Point2 *pe);
 int    UT2D_3len_ptln (double*, double*, double*, Point2*, Point2*, Point2*);
 int    UT2D_slenq_ptptvc (double *qlen, Point2 *pa, Point2 *pb, Point2 *pc);
 double UT2D_slen_nor3pt (Point2 *p1, Point2 *p2, Point2 *p3);
 double UT2D_slen_norvc2pt (Vector2 *v1, Point2 *p1, Point2 *p2);
 double UT2D_len_ptlnX (Point2 *pt,  Point2 *pl, Vector2 *vl);
 double UT2D_len_ptlnY (Point2 *pt,  Point2 *pl, Vector2 *vl);
 void   UT2D_2len_ptvc (double*,double*,Point2*,Point2*,Vector2*);

 int    UT2D_irot_r (double r);
 int    UT2D_sid_2vc (Vector *v1, Vector *v2);
 int    UT2D_sidPerp_2vc (Vector *v1, Vector *v2);
 int    UT2D_sid_3pt (Point2 *pt,  Point2 *p1, Point2 *p2);
 int    UT2D_sidPerp_3pt (Point2 *p1, Point2 *p2, Point2 *p3);
 int    UT2D_sid_ptvc (Point2*, Point2*, Vector2*);
 int    UT2D_sidPerp_ptvc (Point2 *pt,  Point2 *pl, Vector2 *vl);

 int    UT3D_sid_2vc (Vector *v1, Vector *v2);
 int    UT3D_sid_3pt (Point *p1, Point *p2, Point *p3);
 int    UT3D_sid_ptpl (Point *pt, Plane *pl);
 int    UT3D_sid_ptptvc (Point *ptx, Point *pto, Vector *vz);

 int    UT2D_comp2pt (Point2*, Point2*, double);
 int    UT2D_comp4pt (Point2*, Point2*, Point2*, Point2*, double);
 int    UT2D_pt_ck_int4pt (Point2*, Point2*, Point2*, Point2*);
 int    UT2D_pt_ck_onLine (Point2 *po, Point2 *p1,Point2 *p2,Point2 *p3);
 int    UT2D_pt_ck_inLine (Point2 *p1, Point2 *p2, Point2 *p3, double tol);
 int    UT2D_pt_ck_linear (int np, Point2 *ptab, double tol);
 int    UT2D_pt_ck_inBox (Point2 *p1, Point2 *p2, Point2 *p);
 int    UT2D_pt_ck_inBoxTol (Point2 *p1, Point2 *p2, Point2 *p, double tol);
 int    UT2D_pt_ck_inAc (Point2 *pt, Circ2 *ci);
 int    UT2D_pt_ck_inTriangle (Point2 *p1, Point2 *p2, Point2 *p3, Point2 *p);
 int    UT2D_pt_ck_inCv3 (Point *ptx, int pNr, Point *pTab);
 int    UT2D_pt_cknear_npt (Point2 *p0, Point2 *ptTab, int ptNr);

 void   UT2D_swap2pt (Point2 *p1, Point2 *p2);
 Point2 UT2D_pt_pt3 (Point *);
 void   UT2D_pt_2db (Point2 *, double, double);
 void   UT2D_pt_addpt (Point2 *, Point2 *);
 void   UT2D_pt_opp2pt (Point2 *, Point2 *, Point2 *);
 void   UT2D_pt_mid2pt (Point2 *, Point2 *, Point2 *);
 // void   UT2D_pt_traptvc (Point2 *, Point2 *, Vector2 *);
 void   UT2D_pt_tra2ptlen (Point2 *, Point2 *, Point2 *, double);
 void   UT2D_pt_traPtPtPar (Point2 *po, Point2 *p1, Point2 *p2, double d1);
 void   UT2D_pt_tra3ptlen (Point2 *, Point2 *, Point2 *, Point2 *,double);
 void   UT2D_pt_tra2pt2len (Point2 *,Point2 *,Point2 *,double,double);
 void   UT2D_pt_tra2pt3len (Point2 *,Point2 *,Point2 *,double,double,double);
 void   UT2D_pt_traptvclen (Point2 *,Point2 *,Vector2 *,double);
 void   UT2D_pt_traptangrlen (Point2 *,Point2 *,double,double);
 void   UT2D_pt_tranor2ptlen (Point2 *,Point2 *,Point2 *,double);
 void   UT2D_pt_tranorptvclen (Point2 *, Point2 *, Vector2 *, double);
 void   UT2D_pt_traptvc2len (Point2 *,Point2 *,Vector2 *,double,double);
 void   UT2D_pt_tracirlen (Point2 *, Point2 *, Point2 *, double, double);
 void   UT2D_pt_rotptangr (Point2*,Point2*,Point2*,double);
 int    UT2D_pt_projptptvc (Point2 *, Point2 *, Point2 *, Vector2 *);
 int    UT2D_pt_projpt2pt(Point2 *pp,  double *len,
                        Point2 *pt, Point2 *pl, Vector2 *vl);
 int    UT2D_pt_projptln (Point2 *, Point2 *, Line2 *);
 void   UT2D_2pt_projptci (Point2*,Point2*,Point2*,Point2*,double);
 int    UT2D_pt_projptci (Point2 *pp, Point2 *pt, Circ2 *ci1);
 int    UT2D_pt_int4pt (Point2*,double*,double*,Point2*,Point2*,Point2*,Point2*);
 int    UT2D_pt_int2ln (Point2*, Line2*, Line2*);
 int    UT2D_pt_intptvcy (Point2 *pto, Point2 *ptl, Vector2 *vcl, double yVal);
 int    UT2D_pt_intlny (Point2 *pto, Point2 *lp1, Point2 *lp2, double yVal);
 int    UT2D_pt_int2vc2pt (Point2 *, Point2 *, Vector2 *, Point2 *, Vector2 *);
 int    UT2D_2pt_intciptvc (Point2*,Point2*,Point2*,double,Point2*,Vector2*);
 int    UT2D_2pt_intlnci (Point2 *ip1, Point2 *ip2,
                          Line2 *ln, int lnMode, Circ2 *ci, int ciMode);
 int    UT2D_2pt_intcici (Point2*,Point2*,Point2*,double,Point2*,double);
 int    UT2D_2pt_int2ci (Point2 *ip1, Point2 *ip2,
                         Circ2 *ci1, int ci1Mode, Circ2 *ci2, int ci2Mode);
 void   UT2D_pt_traptm2 (Point2 *, Mat_3x2, Point2 *);
 Point2 UT2D_pt_obj2 (ObjG2 *obj1);

 void   UT2D_ln_ptpt (Line2*, Point2*, Point2*);
 void   UT2D_ln_ptvc (Line2*, Point2*, Vector2*);
 void   UT2D_ln_ln3 (Line2 *ln2, Line *ln3);
 void   UT2D_ln_inv (Line2 *ln1);
 void   UT2D_ln_4db (Line2 *ln2, double xs, double ys, double xe, double ye);
 Line2  UT2D_ln_obj2 (ObjG2*);
 int    UT2D_lncoe_ln (double *k, double *d, Line2 *ln);
 int    UT2D_ln_pts_dmax (Line2 *ln, int np, Point2 *ptab, double tol);

 int    UT2D_comp2vc (Vector2*, Vector2*, double);
 int    UT2D_comp2vc_p (Vector2*, Vector2*, double);
 int    UT2D_ckvc_in2vc (Vector *v1, Vector *v2, Vector *v3);
 int    UT2D_2parvc_3vc(double*,double*,Vector2*,Vector2*,Vector2*);
 void   UT2D_vc_2db (Vector2 *, double, double);
 void   UT2D_vc_angr (Vector2 *, double);
 void   UT2D_vc_angrlen (Vector2 *, double, double);
 void   UT2D_vc_2pt (Vector2 *, Point2 *, Point2 *);
 void   UT2D_vc_2pt3 (Vector2 *vc, Point *p1, Point *p2);
 int    UT2D_vc_2pt3_bp (Vector2 *vo, Point *p1, Point *p2, int bp);
 void   UT2D_vc_2ptlen (Vector2 *, Point2 *, Point2 *, double);
 void   UT2D_vc_ln  (Vector2 *, Line2 *);
 void   UT2D_vc_invert (Vector2 *, Vector2 *);
 void   UT2D_vc_perpvc (Vector2 *, Vector2 *);
 void   UT2D_vc_perp2pt (Vector2 *, Point2 *, Point2 *);
 void   UT2D_vc_normalize (Vector2*,Vector2*);
 void   UT2D_vc_setLength (Vector2 *, Vector2 *, double);
 void   UT2D_vc_mid2vc (Vector2*,Vector2*,Vector2*);
 void   UT2D_vc_merge2vc (Vector2 *vm, Vector2 *v1, Vector2 *v2);
 void   UT2D_vc_rotangr (Vector2 *,Vector2 *,double);
 void   UT2D_vc_travcm2 (Vector2 *vo, Mat_3x2 mata, Vector2 *vi);

 double UT2D_angr_ciSec (double hc, double radc);
 double UT2D_len_ciSec (double hSec, double rCi);
 double UT2D_len_cia (double rad, double ango);
 double UT2D_len_cir (double *angOpe,
                       Point2 *pa,Point2 *pe,Point2 *pc,double rad_in);
 int    UT2D_compPtOnAc (double, double, double, int);
 Circ2  UT2D_ci_obj2 (ObjG2 *);
 int    UT2D_ci_ptrd (Circ2 *ci, Point2 *ptc, double rdc);
 void   UT2D_ci_ci3 (Circ2 *ln2, Circ *ln3);
 int    UT2D_ci_2vc2ptrd (Point2*,Point2*,Vector2*,Point2*,Vector2*,double);
 int    UT2D_ci_ciptvcrd (Point2*,Point2*,double,int,Point2*,Vector2*,double);
 int    UT2D_ci_ptvcpt (Point2 *,double *,Point2 *,Vector2 *,Point2 *);

 int    UT2D_obj_obj3 (ObjGX *oo, ObjGX *oi, Memspc *memSeg);

 ObjG2  UT2D_obj_pt3 (Point*);
 ObjG2  UT2D_obj_ln3 (Line*);
 ObjG2  UT2D_obj_ci2 (Circ2*);
 ObjG2  UT2D_obj_ci3 (Circ*);
 ObjG2  UT2D_obj_cv3 (Curv *);

 int    UT2D_void_obj2 (void *memObj, unsigned long *oSiz, ObjG2 *og2);

 void   UT2D_cv_ci360 (Point2 *cv, int ptNr, double rd, Point2 *ptCen);
 int    UT2D_cv_ln (Point2 *cv, int ptAnz, Point2 *p1, Point2 *p2);
 int    UT2D_cv_ci (Point2[],int*,Point2*,Point2*,Point2*,int);
 int    UT2D_cv_cin (int *ptNr,Point2 *cv,Point2 *p1,Point2 *p2,Point2 *pc,
                     double rdc, int ptAnz);
 int    UT2D_cv3_linear (int *pNr, Point *pTab, double tol);
 int    UT2D_srar_polc (double *aro, int ptNr, Point2 *pa);


void   UT2D_m2_load (Mat_3x2,  Vector2 *, Point2 *);
void   UT2D_m2_loadtravcm2 (Mat_3x2 ma, Vector2 *vx, Vector2 *vy, Vector2 *vt);
int    UT2D_m2_invtravcm2 (Mat_3x2 im1, Mat_3x2 m1);


/*===============================================================*/


int    UT3D_stru_dump (int typ, void *data, char *txt, ...);


double UT3D_len_vc (Vector *);
double UT3D_lenq_vc (Vector *);
int    UT3D_bplen_vc (double *lnv, Vector *vc1);
double UT3D_lenB_2pt (Point *p1, Point *p2);
double UT3D_len_2pt (Point*,Point*);
double UT3D_lenq_PtPt (Point *p1, Point *p2);
int    UT3D_lenq_PtLn (double *lenq, Point *p, Point *p1, Point *p2);
double UT3D_len_ln (Line *);
double UT3D_len_ci (Circ *ci1);
double UT3D_slen_3pt (Point *pt, Point *p1, Point *p2);
double UT3D_slen_projvcvc (Vector *vc1, Vector *vc2);
double UT3D_slenq_projvcvc (Vector *vc1, Vector *vc2);
double UT3D_slenq_2ptvc (Point *p1, Point *p2, Vector *vc);
double UT3D_nlen_projvcvc (Vector *vc1, Vector *vc2);
double UT3D_slen_2ptvc (Point *p1, Point *p2, Vector *vc);
double UT3D_slen_ptpl (Point *pt, Plane *pl);
double UT3D_nlen_2ptvc (Point *p1, Point *pv, Vector *vc);
double UT3D_nlen_3pt (Point *p1, Point *p2, Point *p3);
int    UT3D_parpt_objpt (double *po, Point *pti, int oTyp, void *oDat);
double UT3D_parpt_lnbp (Point *pti, Line *ln1, int bp);
double UT3D_parpt_cipt (Point *pti, Circ *ci1);

int    UT3D_pt_ck_npt (Point *p0, Point *pTab, int pNr, double tol);
int    UT3D_ipt_cknear_npt (Point *p0, Point *ptTab, int ptNr);
int    UT3D_ipt_ckfar_npt (Point *p0, Point *ptTab, int ptNr);
int    UT3D_ipt_cknearn_npt (Point *p0, Point *ptTab, int ptNr, int distNr);
int    UT3D_ipt2_nptvc (Point *pt1, Point *pt2, int mode,
                        Point *pta, int iNr, Vector *vc);
int    UT3D_pt_ck_onel (Point *pt, CurvElli *el);
int    UT3D_pt_ck_ptvc (Point *pt, Point *pl, Vector *vl, double tol);
int    UT3D_pt_ck_2pt (Point *pt, Point *pl1, Point *pl2, double tol);
int    UT3D_pt_ck_onLine (Point *p1, Point *p2, Point *p3, double tol);
int    UT3D_pt_ck_inLine (Point *p1, Point *p2, Point *p3, double tol);
int    UT3D_pt_ck_on_pta (Point *pTab, int ptNr, Point *pt1, double tol);
int    UT3D_pt_ck_in2pt (Point *p1,Point *p2,Point *p3, double tol);
int    UT3D_pt_ck_inCirc (Circ *ci1, Point *pt1, double tol);
int    UT3D_pt_ck_inSph (Point *pt, Point *ps, double rs);

void   UT3D_swap2pt (Point *p1, Point *p2);
// int    UT3D_comp2pt (Point *, Point *, double);
int    UT3D_comp4pt (Point *p1a,Point *p1e,Point *p2a,Point *p2e,double tol);
int    UT3D_compptpl (Point*, Plane*);
Point  UT3D_pt_pt2 (Point2 *);
Point  UT3D_pt_pt2z (Point2 *pt20, double zVal);
void   UT3D_pt_3db (Point *, double, double, double);
void   UT3D_pt_txt (Point *, char *);
void   UT3D_pt_mid2pt (Point *, Point *, Point *);
int    UT3D_pt_mid_pta (Point *pto, Point *pTab, int ptNr);
void   UT3D_pt_midci (Point *, Circ *);
void   UT3D_pt_opp2pt (Point *, Point *, Point *);
int    UT3D_pt_oppptptvc (Point *po, Point *pi, Point *pl, Vector *vl);
int    UT3D_2pt_oppptvclen (Point*,Point*,Point*,Vector*,double);
void   UT3D_pt_addpt (Point *, Point *);
void   UT3D_pt_add2pt (Point *, Point *, Point *);
// void   UT3D_pt_traptvc (Point *, Point *, Vector *);
void   UT3D_pt_traptvclen (Point *po,Point *pi,Vector *vc,double dist);
void   UT3D_pt_traptvc1len (Point *po,Point *pi,Vector *vc,double dist);
void   UT3D_pt_trapt2vc (Point *po,Point *pi,Vector *vc1, Vector *vc2);
void   UT3D_pt_trapt2vc2len (Point *,Point *,Vector *,double,Vector *,double);
void   UT3D_pt_trapt3vc3len (Point *po,Point *pi,
              Vector *vx,double dx, Vector *vy,double dy, Vector *vz,double dz);
void   UT3D_pt_traptptlen (Point *po,Point *pi,Point *pDir,double lenv);
void   UT3D_pt_trapt2pt (Point *po, Point *pi, Point *p1, Point *p2);
int    UT3D_pt_tracirlen (Point *pto, Point *pti, Circ *cii, double clen);
int    UT3D_pt_rotptptangr (Point *pto, Point *ptc, Point *pti, double *ar);
void   UT3D_pt_rotptptvcangr (Point *pto,
                              Point *pti,Point *ptc,Vector *vz,double angr);
int    UT3D_pt_rotptm3 (Point *p2, Point *p1, Mat_4x3 ma);
int    UT3D_pt_rotciangr (Point *pto, double angr, Circ *ci1);
int    UT3D_pt_projpt2pt (Point *pp,double *len,Point *pt,Point *p1,Point *p2);
int    UT3D_pt_projptln (Point *, double *, Point *, Line *);
int    UT3D_pt_projptci (Point *pto, Point *pt1, Circ *ci1);
int    UT3D_pt_projptptvc(Point *pp,double *len,Point *pt,Point *pl,Vector *vl);
int    UT3D_pt_projptel (int *numpe, Point *pe, CurvElli *ell, Point *pt);
int    UT3D_pt_projptbspl (int *nxp, Point *ptab, double *ttab, Memspc *memSeg1,
                           CurvBSpl *bspl, Point *pt);
int    UT3D_pt_projptptnvc (Point *po, Point *pi, Point *plo, Vector *plz);
void   UT3D_pt_projptpl (Point *, Plane *, Point *);
int    UT3D_pt_int2pt2vc (Point *ip1, Point *ip2, double *dist,
                         Point *ptu, Vector *vcu, Point *ptv, Vector *vcv);
int    UT3D_pt_intptvcplx (Point *px, Point *pl, Vector *vl, double plx);
int    UT3D_pt_intptvcply (Point *px, Point *pl, Vector *vl, double ply);
int    UT3D_pt_intptvcplz (Point *px, Point *pl, Vector *vl, double plz);
int    UT3D_pt_intptvcln (Point *ip1, Point *ip2, double *dist,
                         Point *pt1, Vector *vc1, Line *ln2);
int    UT3D_pt_intptvcxpln (Point *pti, Point *ptl,
                           Point *ptpl,  Vector *vcpl);
int    UT3D_pt_intptvcypln (Point *pti, Point *ptl,
                           Point *ptpl,  Vector *vcpl);
int    UT3D_pt_intptvczpln (Point *pti, Point *ptl,
                           Point *ptpl,  Vector *vcpl);
int    UT3D_pt_intptvcsph (Point *pa, Point *pl, Vector *vl,
                          Point *ps, double rs);
int    UT3D_pt_int2ln (Point*,Point*,double*,Line*,Line*);
int    UT3D_pt_intperp2ln (Point *po,Point *p1,Vector *v1,Point *p2,Vector *v2);
int    UT3D_pt_intlnci__ (int *np, Point xp[], Line *ln, Circ *ci1);
int    UT3D_pt_intlnci_p (int *np, Point xp[], Line *ln, Circ *ci1);
int    UT3D_pt_intlnsph (Line *ln1, Point *ps, double rs);
int    UT3D_pt_intcici (int *np, Point xp[], Circ *ci1, Circ *ci2);
int    UT3D_pt_intplnln (Point *ip, double *dist, Plane *pl, Line *ln);
int    UT3D_pt_intlnpl (Point *, Plane *, Line *);
int    UT3D_pt_intlnpl1 (Point*, double*, Point*, Point*, double, double);
int    UT3D_pt_intptvcpln (Point *pti,
                          Point *ptl, Vector *vcl, Point *ptpl, Vector *vcpl);
int    UT3D_pt_intplci (int *np, Point xp[], Plane *pl, Circ *ci);
int    UT3D_pt_intcidpln (int *np, Point xp[],
                         Point *pc, Point *p1, Vector *vz, double dx);
int    UT3D_pt_intptvcpl_ (Point *, Plane *, Point *, Vector *);
int    UT3D_pt_intlnel__ (int *np, Point xp[], Line *ln, CurvElli *el);
int    UT3D_pt_intlnel_p (int *np, Point xp[], Line *ln, CurvElli *el);
int    UT3D_pt_mirptpl (Point *pto, Point *pti, Plane *pln);
int    UT3D_pt_tangptci (Point *po1, Point *po2, Point *pt1, Circ *ci1);
int    UT3D_pt_elfoc (Point *fp1, Point *fp2, CurvElli *el);

int UT3D_pt_evparln (Point *pto, double lpar, Line *ln1);
int UT3D_pt_evparci (Point *pto, double lpar, Circ *ci1);

int    UT3D_pt_m3 (Point *pto, Mat_4x3 ma);
void   UT2D_pt_traptm3  (Point2 *p2, Mat_4x3 mata, Point2 *p1);
void   UT3D_pt_traptm3  (Point*, Mat_4x3, Point*);
void   UT3D_pt_traptm4 (Point *p2, Mat_4x4 ma, Point *p1);

int    UT3D_ptvc_int2pl (Point *pt, Vector *vc, Plane *pl1, Plane *pl2);
int    UT3D_ptvc_int2pln (Point *pti, Vector *vci,
                  Point *pl1pt, Vector *pl1vz, Point *pl2pt, Vector *pl2vz);
int    UT3D_ptvc_ox (Point *pta, Vector *vca, ObjGX *oxi);

// double UT3D_acos_2vc (Vector*,Vector*);

double UT3D_angr_3pt (Point *p1, Point *pc, Point *p2);
double UT3D_angr_2vc (Vector*,Vector*);
double UT3D_angr_3vc (Vector *vz, Vector *v1, Vector *v2);
double UT3D_angr_ci  (Circ *ci1);
int    UT3D_2angr_vc (double *az, double *ay, Vector *vc1);
int    UT3D_atan_vcpl (double *kvc, Vector *vci, Plane *pli);

int    UT3D_compvc0 (Vector *v1, double tol);
int    UT3D_comp2vc_d (Vector *, Vector *, double);
int    UT3D_comp2vc_p (Vector *, Vector *, double);
int    UT3D_vc_ck_parpl (Vector *vci, Plane *pli, double tol);
int    UT3D_vc_ckperp_2vc1 (Vector *vc1, Vector *vc2, double tol);
int    UT3D_parvc_2vcbp (double *dl, int mainPln, Vector *v1, Vector *v2);
int    UT3D_2parvc_3vcbp (double*,double*,int,Vector*,Vector*,Vector*);
// int    UT3D_vc_multvc (Vector *vo, Vector *vi, double d);
// void   UT3D_vc_3db (Vector *, double, double, double);
// void   UT3D_vc_pt (Vector *, Point *);
void   UT3D_vc_txt (Vector *vc, char *txt);
// void   UT3D_vc_2pt (Vector *, Point *, Point *);
void   UT3D_vc_2ptlen (Vector *, Point *, Point *, double);
void   UT3D_vc_angr (Vector *vc, double angr);
void   UT3D_vc_2angr (Vector *, double, double);
void   UT3D_vc_2vc (Vector *, Vector *, Vector *);
void   UT3D_vc_ln (Vector *, Line *);
int    UT3D_vc_bp (Vector *vn, int bp);
void   UT3D_vc_invert (Vector*, Vector*);
// int    UT3D_vc_add2vc (Vector *v3, Vector *v1, Vector *v2);
// int    UT3D_vc_sub2vc (Vector *v3, Vector *v1, Vector *v2);
void   UT3D_vc_perp1vc (Vector *vp, Vector *vi);
void   UT3D_vc_perp2vc (Vector *, Vector *, Vector *);
int    UT3D_vc_perpvc2pt (Vector *vp, Vector *vx, Point *pc, Point *py);
int    UT3D_vc_perp3pt (Vector *vp, Point *ptc, Point *ptx, Point *pty);
int    UT3D_vc_perp4pt (Vector *vp, Point *p1, Point *p2, Point *p3, Point *p4);
void   UT3D_vc_perpTria (Vector *vn, Triangle *tri);
void   UT3D_vc_perpvcplXY (Vector *, Vector *);
int    UT3D_vc_perppta (Vector *vcn, int pNr, Point *pa);
void   UT3D_vc_normalize (Vector*,Vector*);
void   UT3D_vc_setLength (Vector *, Vector *, double);
int    UT3D_vc_setLenLen (Vector *vco,Vector *vci,double newLen,double actLen);
void   UT3D_vc_tangci (Vector *vs, Circ *ci1, double u);
int    UT3D_vc_tangcipt (Vector *vt, Point *p1, Circ *ci);
int    UT3D_vc_rotangr (Vector *vco, Vector *vci, double *ar);
void   UT3D_vc_rot3angr (Vector *,Vector *, double, double, double);
int    UT3D_vc_rotvcvcangr (Vector *vo, Vector *va, Vector *vi, double angr);
int    UT3D_vc_projvcvc (Vector *v3, Vector *v1, Vector *v2);
int    UT3D_vc_projvc2vc (Vector *vo, Vector *vi, Vector *v1, Vector *v2);
int    UT3D_vc_projvcnvc (Vector *vo, Vector *vi, Vector *vz);
void   UT3D_vc_projvcpl (Vector *, Plane *, Vector *);
int    UT3D_vc_mirvcpl (Vector *vco, Vector *vci, Plane *pln);
void   UT3D_vc_travcm3 (Vector *b, Mat_4x3 ma, Vector *a);
void   UT3D_vc_travcm4 (Vector *b, Mat_4x4 ma, Vector *a);

int    UT3D_comp2ln (Line *pa1, Line *pa2, double tol);
int    UT3D_ln_ck_on_ln (Point*,Point*,Point*,Point*,Point*,Point*,double tol);
int    UT3D_ln_ck_parpl (double *dist, Line *ln, Plane *pl, double tol);
void   UT3D_ln_6db (Line*, double, double, double, double, double, double);
void   UT3D_ln_2pt2 (Line *ln1, Point2 *pta, Point2 *pte);
int    UT3D_ln_int2pl (Line *ln, Plane *pl1, Plane *pl2);
int    UT3D_ln_tangcici (Line *ln1, Circ *ci1, Circ *ci2, int sNr);
int    UT3D_ln_parl2ln (Point*, Point*, Point*, Point*, Point*, Point*);
int    UT3D_ln_pts_dmax (Line *ln, int np, Point *ptab, double tol);
int    UT3D_ln_setLen (Line *lno, Point *pc, double lnlg, Line *lni);
void   UT3D_ln_inv (Line *ln1);
void   UT3D_ln_ln2 (Line*, Line2*);

int    UT3D_rdc_3pt (double *rdc, Point *pp1, Point *pp2, Point *pp3);
int    UT3D_ck_ci180 (Circ *ci1);
int    UT3D_ck_ci360 (Circ *ci1);
int    UT3D_ci_cip1  (Circ *ci1, Point *p1);
int    UT3D_ci_ptvcr (Circ *ci1, Point *pc, Vector *vz, double rc);
int    UT3D_ci_pt2vcr (Circ *ci1, Point *pc, Vector *vz, Vector *vx, double rc);
int    UT3D_ci_cip2  (Circ *ci1, Point *p2);
int    UT3D_ci_cip3  (Circ *ci1, Point *p1, Point *p2);
int    UT3D_ci_ciangr (Circ *ci, double ao2);
int    UT3D_ci_ptptvcangr (Circ *ci,Point *pc,Point *p1,Vector *vz,double ao);
int    UT3D_ci_ptptvcrd (Circ *ci,
                        Point *p1,Point *p2,double rd,Vector *vz,int siz);
int    UT3D_ci_cipt180 (Circ *ci1, Point *p1);
int    UT3D_ci_cipt360   (Circ *ci1, Point *p1);
int    UT3D_ci_pcvzpt180 (Circ *ci1,Point *pc,Vector *vz,Point *p1,int dreh);
int    UT3D_ptNr_ci (Circ *ci1, double tol);
int    UT3D_ci_inv1 (Circ *ci1);
int    UT3D_ci_inv2 (Circ *ci1);
int    UT3D_ci_inv3 (Circ *ci1);
Circ   UT3D_ci_ci2  (Circ2*);
Circ   UT3D_ci_obj2 (ObjG2 *);
Circ   UT3D_ci_obj (ObjG *ci_in);
int    UT3D_ci_ptvcrd (Circ *ci, Point *ps, Vector *vs, double rd,
                       Vector *vz, double a1);
int    UT3D_ci_2ptvcrd (Circ *cia,Point *pp1,Point *pp2,Vector *vz,double rdc);
int    UT3D_ci_3pt (Circ *cpo, Point *pp1, Point *pp2, Point *pp3);
int    UT3D_civz_ci (Circ *ci1);
int    UT3D_ci_ptptrd (Circ ca[], Point *pt1, Point *pt2, double radi);
int    UT3D_ci_lnptrd (Circ ca[], Line *ln1,Point *pt1,Vector *vz,double rdc);
int    UT3D_ci_ciptrd (Circ ca[], Circ *ci1, Point *pt1, double rdc);
int    UT3D_ci_2lnrd  (Circ ca[], Line *ln1, Line *ln2, double rdc, int);
int    UT3D_ci_cicird (Circ ca[], Circ *ci1, Circ *ci2, double rdc, int);
int    UT3D_ci_lncird (Circ ca[], Line *ln1, Circ *ci1, double rdc, int);
int    UT3D_ci_intplsph (Circ *cio, Plane *pli, Sphere *spi);
int UT3D_ci_ptrd2vc2angr (Circ *ci, Point *pc, double rd,
                            Vector *vz, Vector *vx,
                            double a1, double a2);
int UT3D_ci_ptvcpt2angr (Circ *ci,
                           Point *pc, Point *p1, Vector *vz,
                           double a1, double a2);

// source ../ut/ut_elli.c
int UT3D_ck_el360 (CurvElli *el1);
int UT3D_el_elpt180 (CurvElli *el1, Point *p1);
double UT3D_angr_elpt (Point *pti,Point *ptc,Vector *va,Vector *vb);
int UT2D_pt_elangd (Point2 *pto, double lx, double ly, double angr);
int UT3D_pt_elangd (Point *pto,Point *ptc,Vector *va,Vector *vb,double angr);
int UT3D_el_pt2vc2a (CurvElli *el, Point *ptc, Vector *vcx, Vector *vcy,
                       double a1, double a2, int idir);
int    UT3D_el_projcipl (CurvElli *el, Plane *pl, Circ *ci);
int    UT3D_el_projelpl (CurvElli *elo, Plane *pl, CurvElli *eli);
int    UT3D_el_elcoe(CurvElli *,polcoeff_d5 *,Point2 *pa,Point2 *pe,double zt);
int    UT3D_elcoe_el(polcoeff_d5*, CurvElli*);


int    UT3D_pta_ck_planar (int pNr, Point *pTab, Point *pPln, Vector *vc);
int    UT3D_rMin_pta (double *rMin, int pNr, Point *pTab);
int    UT3D_sr_polc (int ptNr, Point *pa, Vector *vcn, int plMain);
Curv   UT3D_cv_obj2 (ObjG2 *);
void   UT3D_cv_ln (Point *cv, int *ptAnz, Point *p1, Point *p2);
void   UT3D_cv_ci (Point cv[], int *ptanz, Circ *ci1, int ptmax, double tol);
int    UT3D_cv_ell (Point cv[],int *numpt,CurvElli *el,int ptmax,double stol);
int    UT3D_cv_delia (int *pNr, Point *pTab, char *ptStat);
int    UT3D_cv3_linear (int *pNr, Point *pTab, double tol);

int    UT3D_obj_dump (ObjG *el);
// ObjG   UT3D_obj_pt  (Point*);
ObjG   UT3D_obj_ln  (Line*);
// ObjG   UT3D_obj_ci2 (Circ2 *ci1, double zVal);
ObjG   UT3D_obj_ci  (Circ*);
// ObjG   UT3D_obj_obj2 (ObjG2 *o2);

int    UT3D_bp_2pt (Point *pt1, Point *pt2);
int    UT3D_bp_vc_ (Vector*);
int    UT3D_bp_vcz (Vector*);
void   UT3D_pl_XYZ (Plane *pl1);
int    UT3D_pl_bpdb (Plane *plo, int bp, double dbc);
int    UT3D_pl_3pt (Plane *, Point *, Point *, Point *);
void   UT3D_pl_ptvcvc (Plane *pl1, Point *po, Vector *vx, Vector *vz);
void   UT3D_pl_pt2vc (Plane *, Point *, Vector *, Vector *);
int    UT3D_pl_ptvc (Plane *, Point *, Vector *);
void   UT3D_pl_ptvcpt (Plane *pl1, Point *po, Vector *vz, Point *ptx);
int    UT3D_pl_ln (Plane *pln, Line *lna);
void   UT3D_pl_2ln (Plane *pl1, Line *ln1, Line *ln2);
int    UT3D_pl_ci (Plane *pl1, Circ *ci1);
int    UT3D_pl_nobj (Plane *pl1, int oNr, ObjGX *oTab);
void   UT3D_pl_invert (Plane *pl);
int    UT3D_pl_rotpt (Plane *plo, Plane *pli, Point *ptx);
void   UT3D_pl_ptpl (Plane *pl, Point *pt1);
int    UT3D_pl_plcoe (Plane *pl, polcoeff_d3 *co);
int    UT3D_plcoe_pl (polcoeff_d3 *co, Plane *pl);

double UT3D_plg_lvTab (double *lvTab, Point *pta, int ptNr);
int    UT3D_pta_plg (int *ptNr, Point *pta, CurvPoly *plg);

int UT3D_box_ck_intLn (Line *ln, Point *pmin, Point *pmax, double tol);
int UT3D_box_pts (Point *pmin, Point *pmax, int nump, Point *ptab);
int UT3D_box_extend (Point* pb1, Point* pb2, Point* pt1);
int    UT3D_rbox_loadxy (Point* pb1,double x1,double x2,double y1,double y2);

void   UT3D_tria_pta_fac(Triangle*, Fac3*, Point*);

int    UT3D_m3_inirot   (Mat_4x3 ma, Point *pa, Vector *va, double angr);
void   UT3D_m3_loadpl   (Mat_4x3, Plane *);
void   UT3D_m3_load     (Mat_4x3, Vector *, Vector *, Vector *);
void   UT3D_m3_load_povxvy (Mat_4x3 ma, Point *ori, Vector *vx, Vector *vy);
void   UT3D_m3_load_povxvz (Mat_4x3 ma, Point *ori, Vector *vx, Vector *vz);
void   UT3D_m3_load_o   (Mat_4x3, Point *);
// int    UT3D_m3_get      (void *out, int mode, Mat_4x3 ma);
// int    UT3D_m3_set      (Mat_4x3 ma, int mode, void *da);
int    UT3D_m3_invm3    (Mat_4x3, Mat_4x3);
void   UT3D_m3_multm3   (Mat_4x3 m3, Mat_4x3 m1, Mat_4x3 m2);
int    UT3D_m3_tram3m3  (Mat_4x3 m3, Mat_4x3 m1, Mat_4x3 m2);

void UT3D_m4_init       (Mat_4x4 ma);
void UT3D_m4_init_ori   (Mat_4x4 ma, double px, double py, double pz);
void UT3D_m4_init_rot   (Mat_4x4 ma, double angle, Vector *axis);
void UT3D_m4_loadpl     (Mat_4x4 m1, Plane *pl1);
void UT3D_m4_addrot     (Mat_4x4 mo, Mat_4x4 ma, Mat_4x4 mb);
void UT3D_m4_addtra     (Mat_4x4 ma, double px, double py, double pz );

double UT3D_sbs_ck_planar (SurBSpl *su1);
double UT3D_sru_ck_planar (ObjGX *ru1);


void OGX_SET_OBJ (ObjGX *ox, int oTyp, int oForm, int oSiz, void *oDat);


//================================================================
 // inline functions

#define IABS(i)    (((i)<0)?-(i):(i))
#define ISIGN(i)   ((i>=0)?(1):(-1))          // sign of int; +1 or -1
#define ICHG01(i)  (((i)>0)?(0):(1))          // change 0 -> 1, 1 -> 0.

#define IMIN(x,y)  (((x)<(y))?(x):(y))
#define IMAX(x,y)  (((x)>(y))?(x):(y))
#define ICHAR(x)   ((x) & 15)                 // char --> int; auch x-48

// UTI_iNr_chrNr             give nr of ints for n characters (not including \0)
#define UTI_iNr_chrNr(i1) (((i1) >> 2) + 1)   // (((i1) + 4) / 4)
//   makes 2 from 4  (4 chars + \0 needs 2 ints to store in int-words)


#define DMIN(x,y)  (((x)<(y))?(x):(y))
#define DMAX(x,y)  (((x)>(y))?(x):(y))
#define DSIGN(d)   ((d>=0.)?(1):(-1))         // sign of double; +1 or -1
#define DSIGTOL(d,t) ((d>t)?(1):((d<-(t))?(-1):(0))) // d>t=1; d<-t=-1; else 0
#define DLIM2(x,lo,hi) (((x)>(hi))?(hi):(((x)<(lo))?(lo):(x))) // between lo,hi

#define ACOS(dCos) ((dCos>=1.)?(0.):((dCos<=-1.)?(RAD_180):acos(dCos)))

#define UT_RADIANS(angle) ((angle)*(RAD_1))
#define UT_DEGREES(angle) ((angle)/(RAD_1))

#define UT3D_vc_crossprod2vc      UT3D_vc_perp2vc
#define UT2D_acos_innerprod2vc    UT2D_acos_2vc


//----------------------------------------------------------------
// UTP_comp_0                compare double (double == 0.0 + - UT_TOL_min1)
// Retcode 0:   db <> 0.0
//         1:   db = 0.0
#define UTP_comp_0(db) (fabs(db) < UT_TOL_min1)


// UTP_comp2db               compare 2 doubles (with tolerance)
// Retcode 0 = Differenz der Werte > tol   - different
// Retcode 1 = Differenz der Werte < tol   - ident
#define UTP_comp2db(d1,d2,tol) (fabs(d2-d1) < (tol))

// UTP_px_paramp0p1px        Zahl aus p0, p1 und Parameterwert
// see also UTP_param_p0p1px
#define UTP_px_paramp0p1px(p0,p1,par)\
  ((p1) - (p0)) * (par) + (p0);


//----------------------------------------------------------------
// BIT_SET                 set bits;    BITSET(i1,2);    // set bit 1
#define BIT_SET(i,b) (i)|=(b)

// BIT_CLR                 clear bits;  BITCLR(i1,3);    // clear bit 0 and 1
#define BIT_CLR(i,b) (i)&=~(b)

// BIT_GET                 filter bits  if(BITGET(i1,2)) gives 0=clear >0=set.
#define BIT_GET(i,b) ((i)&(b))


//----------------------------------------------------------------
// Direction from Radius; if(rd > 0.) irc=CCW(1) else irc=CW(-1)
#define UT2D_irot_r(rd) (((rd) > 0.) ? CCW : CW)

// UT2D_lenq_vc         quadr.length of 2D-vector
#define UT2D_lenq_vc(vc) ((vc)->dx*(vc)->dx + (vc)->dy*(vc)->dy)

// UT2D_len_vc          length of 2D-vector
#define UT2D_len_vc(vc) (sqrt((vc)->dx*(vc)->dx + (vc)->dy*(vc)->dy))

// UT2D_lenq_2pt        quadr. distance pt - pt
#define UT2D_lenq_2pt(lq,p1,p2) {\
  double _dx = (p2)->x - (p1)->x;\
  double _dy = (p2)->y - (p1)->y;\
  *(lq) = _dx * _dx + _dy * _dy;}

// UT2D_comp2pt              compare 2 points
// RC = 0: Punkte nicht gleich; Abstand > tol.
// RC = 1: Punkte sind gleich; Abstand < tol.
#define UT2D_comp2pt(p1,p2,tol)\
  ((fabs((p2)->x - (p1)->x) < tol) &&\
   (fabs((p2)->y - (p1)->y) < tol))

// UT2D_swap2pt                  swap 2 2D-points
// see also MEM_swap_
#define UT2D_swap2pt(p1,p2){\
  Point2 p3 = *(p1); *(p1) = *(p2); *(p2) = p3;}

// UT2D_pt_2db              2D-Point < 2 doubles (x, y)
#define UT2D_pt_2db(pt2,dx,dy)\
  (pt2)->x = dx; (pt2)->y = dy

// UT2D_pt_pt3               2D-Point = 3D-Point
#define UT2D_pt_pt3(pt3)\
  (*(Point2*)pt3)

// UT2D_pt_pt                2D-Point = 3D-Point
#define UT2D_pt_pt(pt2,pt3) (memcpy((pt2), (pt3), sizeof(Point2)))

// UT2D_pt_pt3bp        2D-Point = 3D-Point on Backplane
#define UT2D_pt_pt3bp(p2o,p3i,bpi) {\
  if     (bpi == BCKPLN_XY) {(p2o)->x = (p3i)->x; (p2o)->y = (p3i)->y;} \
  else if(bpi == BCKPLN_XZ) {(p2o)->x = (p3i)->x; (p2o)->y = (p3i)->z;} \
  else if(bpi == BCKPLN_YZ) {(p2o)->x = (p3i)->y; (p2o)->y = (p3i)->z;}}

// UT2D_pt_addpt                 Add two points:      po += p1
#define UT2D_pt_addpt(po,p1)\
 (po)->x = (po)->x + (p1)->x;\
 (po)->y = (po)->y + (p1)->y

// UT2D_pt_opp2pt                opposite point (p1 = center)
#define UT2D_pt_opp2pt(po,p1,p2)\
  (po)->x = (p1)->x - ((p2)->x - (p1)->x);\
  (po)->y = (p1)->y - ((p2)->y - (p1)->y)

// UT2D_pt_mid2pt                midpoint between 2 points
#define UT2D_pt_mid2pt(po,p1,p2){\
  (po)->x = ((p1)->x + (p2)->x) / 2.0;\
  (po)->y = ((p1)->y + (p2)->y) / 2.0;}

// UT2D_pt_traptvc               2D Point = Point + Vector
#define UT2D_pt_traptvc(po,pi,vc)\
 (po)->x = (pi)->x + (vc)->dx;\
 (po)->y = (pi)->y + (vc)->dy

//----------------------------------------------------------------
// UT2D_skp_2vc        cos of opening angle of 2 vecs (dot=scalarprod) DOT
#define UT2D_acos_2vc UT2D_skp_2vc
#define UT2D_skp_2vc(v1,v2)\
 ((v1)->dx*(v2)->dx + (v1)->dy*(v2)->dy)

// UT3D_acos_vc2pt      cos of opening angle of vec-(pt-pt) (dot=scalarprod) DOT
#define UT2D_acos_vc2pt UT2D_skp_vc2pt
#define UT2D_skp_vc2pt(v1,p1,p2)\
 ((v1)->dx * ((p2)->x - (p1)->x) +\
  (v1)->dy * ((p2)->y - (p1)->y))

// UT2D_crossprod_2vc        crossprod of 2 2D-Vectors
#define UT2D_crossprod_2vc(vc1,vc2)\
 (((vc1)->dx * (vc2)->dy) - ((vc2)->dx * (vc1)->dy))

// UT2D_vc_2db              2D-Vector < 2 doubles (x, y)
#define UT2D_vc_2db(vc,dx,dy)\
 (vc)->dx = (dx);\
 (vc)->dy = (dy)

// UT2D_vc_invert          2D-Vector invert (change direction)
#define UT2D_vc_invert(vo,vi)\
  (vo)->dx = -(vi)->dx;\
  (vo)->dy = -(vi)->dy

// UT2D_vc_add2vc                v3 = v1 + v2                ADD
#define UT2D_vc_add2vc(v3,v1,v2)\
 (v3)->dx = (v1)->dx + (v2)->dx;\
 (v3)->dy = (v1)->dy + (v2)->dy

// UT2D_vc_sub2vc                v3 = v1 - v2                SUB
#define UT2D_vc_sub2vc(v3,v1,v2)\
 (v3)->dx = (v1)->dx - (v2)->dx;\
 (v3)->dy = (v1)->dy - (v2)->dy

// UT2D_vc_multvc                vo = vi * d                 MULT
#define UT2D_vc_multvc(vo,vi,d)\
 (vo)->dx = (vi)->dx * (d);\
 (vo)->dy = (vi)->dy * (d)

// UT2D_vc_perpvc            vector = perpendic. to vector ( + 90 degrees)
#define UT2D_vc_perpvc(vo,vi){\
  double _dx = (vi)->dx; (vo)->dx = -(vi)->dy; (vo)->dy = _dx;}

// UT2D_vc_perp2pt           vector = perpendic. to Line ( + 90 degrees)
#define UT2D_vc_perp2pt(vo,p1,p2)\
  (vo)->dx = (p1)->y - (p2)->y;\
  (vo)->dy = (p2)->x - (p1)->x

// UT2D_vc_angr            2DVector =  angle (radians)
#define UT2D_vc_angr(vc,angr)\
  (vc)->dx = cos(angr);\
  (vc)->dy = sin(angr)

// UT2D_vc_vc3bp        2D-Vector = 3D-Vector on Backplane
#define UT2D_vc_vc3bp(v2o,v3i,bpi) {\
 if     (bpi == BCKPLN_XY) {(v2o)->dx = (v3i)->dx; (v2o)->dy = (v3i)->dy;} \
 else if(bpi == BCKPLN_XZ) {(v2o)->dx = (v3i)->dx; (v2o)->dy = (v3i)->dz;} \
 else if(bpi == BCKPLN_YZ) {(v2o)->dx = (v3i)->dy; (v2o)->dy = (v3i)->dz;}}

// UT2D_vc_2pt               2D-Vector = 2D-Point -> 2D-Point
#define UT2D_vc_2pt(vc,p1,p2)\
 (vc)->dx = (p2)->x - (p1)->x;\
 (vc)->dy = (p2)->y - (p1)->y;

// UT2D_vc_ln               2D-Vector from 2D-Line
#define UT2D_vc_ln(vc,ln)\
 (vc)->dx = (ln)->p2.x - (ln)->p1.x;\
 (vc)->dy = (ln)->p2.y - (ln)->p1.y


//----------------------------------------------------------------

// UT2D_ln_ptpt                  2D-Line from 2 2D-points
#define UT2D_ln_ptpt(ln1,pt1,pt2)\
 (ln1)->p1 = *(pt1);\
 (ln1)->p2 = *(pt2)

// UT2D_ln_ptvc                  2D-Line from 2D-point and 2D-vector
#define UT2D_ln_ptvc(ln,pt,vc)\
 (ln)->p1 = *(pt);\
 (ln)->p2.x = (pt)->x + (vc)->dx;\
 (ln)->p2.y = (pt)->y + (vc)->dy

// UT2D_ln_ln3                   2D-Line = 3D-Line
#define UT2D_ln_ln3(ln2,ln3)\
 (ln2)->p1.x = (ln3)->p1.x;\
 (ln2)->p1.y = (ln3)->p1.y;\
 (ln2)->p2.x = (ln3)->p2.x;\
 (ln2)->p2.y = (ln3)->p2.y

// UT2D_len_cia                  length arc (from rad & angle)
#define UT2D_len_cia(radius, ango) (fabs((radius)*(ango)))

// UT2D_ln_inv                Invert 2D-Line
#define UT2D_ln_inv(ln){\
  Point2 _pt = (ln)->p1; (ln)->p1 = (ln)->p2; (ln)->p2 = _pt;}

// UT2D_ci_ci3                  2D-Circ = 3D-Circ
#define UT2D_ci_ci3(ci2,ci3)\
 (ci2)->p1.x = (ci3)->p1.x;\
 (ci2)->p1.y = (ci3)->p1.y;\
 (ci2)->p2.x = (ci3)->p2.x;\
 (ci2)->p2.y = (ci3)->p2.y;\
 (ci2)->pc.x = (ci3)->pc.x;\
 (ci2)->pc.y = (ci3)->pc.y;\
 (ci2)->rad = (ci3)->rad;\
 (ci2)->ango = (ci3)->ango



//----------------------------------------------------------------
// UT3D_lenq_vc         quadr.length of 3D-vector
#define UT3D_lenq_vc(vc)\
 ((vc)->dx*(vc)->dx + (vc)->dy*(vc)->dy + (vc)->dz*(vc)->dz)

// UT3D_len_vc          length of 3D-vector
#define UT3D_len_vc(vc)\
 (sqrt((vc)->dx*(vc)->dx + (vc)->dy*(vc)->dy + (vc)->dz*(vc)->dz))

// UT3D_skp_2vc         scalarprod of 2 vecs (dotprod,Skalarprod)
// UT3D_acos_2vc        cos of opening angle of 2 vecs; see double UT3D_acos_2vc
#define UT3D_skp_2vc(v1,v2)\
 ((v1)->dx*(v2)->dx + (v1)->dy*(v2)->dy + (v1)->dz*(v2)->dz)

#define UT3D_skp_vc2pt(v1,p1,p2)\
 ((v1)->dx * ((p2)->x - (p1)->x) +\
  (v1)->dy * ((p2)->y - (p1)->y) +\
  (v1)->dz * ((p2)->z - (p1)->z))

// UT3D_acos_vc2pt      cos of opening angle of vec-(pt-pt) (dot=scalarprod) DOT
#define UT3D_acos_2vc UT3D_skp_2vc
#define UT3D_acos_vc2pt UT3D_skp_vc2pt


//----------------------------------------------------------------
// UT3D_pt_ptz               3D-Point = 2D-Point + Z-Val
#define UT3D_pt_pt(pt3,pt2,zVal)\
  memcpy((pt3), (pt2), sizeof(Point)); (pt3)->z = (zVal)

// UT3D_pt_multpt                po = pi * d
#define UT3D_pt_multpt(po,pi,d)\
 (po)->x = (pi)->x * (d);\
 (po)->y = (pi)->y * (d);\
 (po)->z = (pi)->z * (d)

// UT3D_pt_LinComb2Pts   Linear combination of two points:
//                   po = a1 * p1 + a2 * p2
#define UT3D_pt_LinComb2Pts(po,a1,p1,a2,p2)\
 (po)->x = a1 * (p1)->x + a2 * (p2)->x;\
 (po)->y = a1 * (p1)->y + a2 * (p2)->y;\
 (po)->z = a1 * (p1)->z + a2 * (p2)->z

// UT3D_pt_addpt             Add two points:      po += p1
#define UT3D_pt_addpt(po,p1)\
 (po)->x += (p1)->x;\
 (po)->y += (p1)->y;\
 (po)->z += (p1)->z

// UT3D_pt_add2pt   Add two points:               po = p1 + p2
#define UT3D_pt_add2pt(po,p1,p2)\
 (po)->x = (p1)->x + (p2)->x;\
 (po)->y = (p1)->y + (p2)->y;\
 (po)->z = (p1)->z + (p2)->z

// UT3D_swap2pt                  swap 2 3D-points
// see also MEM_swap_
#define UT3D_swap2pt(p1,p2){\
  Point p3 = *(p1); *(p1) = *(p2); *(p2) = p3;}

// UT3D_pt_vc                Point = Vector
 #define UT3D_pt_vc(pt,vc) (memcpy((pt), (vc), sizeof(Point)))

// UT3D_pt_traptvc               Point = Point + Vector
#define UT3D_pt_traptvc(po,pi,vc)\
 (po)->x = (pi)->x + (vc)->dx;\
 (po)->y = (pi)->y + (vc)->dy;\
 (po)->z = (pi)->z + (vc)->dz

// UT3D_pt_traptivc               Point = Point - Vector
#define UT3D_pt_traptivc(po,pi,vc)\
 (po)->x = (pi)->x - (vc)->dx; \
 (po)->y = (pi)->y - (vc)->dy;\
 (po)->z = (pi)->z - (vc)->dz


// u3d_LinComb2Pts   Linear combination of two points:
//                   po = a1 * p1 + a2 * p2
#define u3d_LinComb2Pts(po,a1,p1,a2,p2)\
 (po)->x = a1 * (p1)->x + a2 * (p2)->x;\
 (po)->y = a1 * (p1)->y + a2 * (p2)->y;\
 (po)->z = a1 * (p1)->z + a2 * (p2)->z


// UT3D_vc_vc2               3D-vector = 2D-vector
#define UT3D_vc_vc2(v3o,v2i)\
 (v3o)->dx = (v2i)->dx;\
 (v3o)->dy = (v2i)->dy;\
 (v3o)->dz = UT_DB_NULL

// UT3D_vc_3db              Vector < 3 doubles (x, y, z)
#define UT3D_vc_3db(vc,x,y,z)\
 (vc)->dx = (x);\
 (vc)->dy = (y);\
 (vc)->dz = (z)

// UT3D_vc_pt                Vector = Point
 #define UT3D_vc_pt(vc,pt) (memcpy((vc), (pt), sizeof(Point)))

// UT3D_vc_2pt               Vector = Point -> Point
#define UT3D_vc_2pt(vc,p1,p2)\
 (vc)->dx = (p2)->x - (p1)->x;\
 (vc)->dy = (p2)->y - (p1)->y;\
 (vc)->dz = (p2)->z - (p1)->z

// UT3D_vc_perpTria          vector = perpendic. to Triangle (crossprod)
#define UT3D_vc_perpTria(vn,tri)\
  UT3D_vc_perp3pt ((vn),(tri)->pa[0],(tri)->pa[1],(tri)->pa[2])

// UT3D_vc_invert            invert Vector
#define UT3D_vc_invert(vio,vii)\
  (vio)->dx = -(vii)->dx;\
  (vio)->dy = -(vii)->dy;\
  (vio)->dz = -(vii)->dz

// UT3D_vc_addvc                vo += vi
#define UT3D_vc_addvc(vo,vi)\
 (vo)->dx += (vi)->dx;\
 (vo)->dy += (vi)->dy;\
 (vo)->dz += (vi)->dz

// UT3D_vc_add2vc                v3 = v1 + v2                ADD
#define UT3D_vc_add2vc(v3,v1,v2)\
 (v3)->dx = (v1)->dx + (v2)->dx;\
 (v3)->dy = (v1)->dy + (v2)->dy;\
 (v3)->dz = (v1)->dz + (v2)->dz

// UT3D_vc_addvc2pt       v3 = v1 + (p2-p1)      Vector + (Vector from 2 points)
#define UT3D_vc_addvc2pt(v3,v1,p1,p2)\
 (v3)->dx = (v1)->dx + (p2)->x - (p1)->x;\
 (v3)->dy = (v1)->dy + (p2)->y - (p1)->y;\
 (v3)->dz = (v1)->dz + (p2)->z - (p1)->z

// UT3D_vc_add3vc                vo = v1 + v2 + v3
#define UT3D_vc_add3vc(vo,v1,v2,v3)\
 (vo)->dx = (v1)->dx + (v2)->dx + (v3)->dx;\
 (vo)->dy = (v1)->dy + (v2)->dy + (v3)->dy;\
 (vo)->dz = (v1)->dz + (v2)->dz + (v3)->dz

// UT3D_vc_sub2vc                v3 = v1 - v2                SUB
#define UT3D_vc_sub2vc(v3,v1,v2)\
 (v3)->dx = (v1)->dx - (v2)->dx;\
 (v3)->dy = (v1)->dy - (v2)->dy;\
 (v3)->dz = (v1)->dz - (v2)->dz;

// UT3D_vc_multvc                vo = vi * d                 MULT
#define UT3D_vc_multvc(vo,vi,d)\
 (vo)->dx = (vi)->dx * (d);\
 (vo)->dy = (vi)->dy * (d);\
 (vo)->dz = (vi)->dz * (d)

// UT3D_vc_merge2vc              merge 2 vectors   vo = (v1 + v2) / 2
#define UT3D_vc_merge2vc(vo,v1,v2){\
 (vo)->dx = ((v1)->dx + (v2)->dx) / 2.;\
 (vo)->dy = ((v1)->dy + (v2)->dy) / 2.;\
 (vo)->dz = ((v1)->dz + (v2)->dz) / 2.;}

// UT3D_comp2pt              compare 2 points
// RC = 0: Punkte nicht gleich; Abstand > tol.
// RC = 1: Punkte sind gleich; Abstand < tol.
#define UT3D_comp2pt(p1,p2,tol)\
  ((fabs((p2)->x - (p1)->x) < tol) &&\
   (fabs((p2)->y - (p1)->y) < tol) &&\
   (fabs((p2)->z - (p1)->z) < tol))
  // ((UTP_comp2db((p1)->x,(p2)->x,(tol))) &&\
   // (UTP_comp2db((p1)->y,(p2)->y,(tol))) &&\
   // (UTP_comp2db((p1)->z,(p2)->z,(tol))))


// UT3D_ln_inv                Invert 3D-Line
#define UT3D_ln_inv(ln){\
  Point _pt = (ln)->p1; (ln)->p1 = (ln)->p2; (ln)->p2 = _pt;}

// UT3D_ln_ptpt                Line = Point, Point
#define UT3D_ln_ptpt(ln1,pt1,pt2)\
 (ln1)->p1 = *(pt1);\
 (ln1)->p2 = *(pt2)

// UT3D_ln_ptvc                Line = Point, Vector
#define UT3D_ln_ptvc(ln,pt,vc)\
 (ln)->p1 = *(pt);\
 (ln)->p2.x = (pt)->x + (vc)->dx;\
 (ln)->p2.y = (pt)->y + (vc)->dy;\
 (ln)->p2.z = (pt)->z + (vc)->dz

// UT3D_ln_ln2                 3D-Line from 2D-Line (Z=0)
#define UT3D_ln_ln2(ln3,ln2)\
 (ln3)->p1.x = (ln2)->p1.x;\
 (ln3)->p1.y = (ln2)->p1.y;\
 (ln3)->p1.z = UT_DB_NULL;\
 (ln3)->p2.x = (ln2)->p2.x;\
 (ln3)->p2.y = (ln2)->p2.y;\
 (ln3)->p2.z = UT_DB_NULL


//----------------------------------------------------------------
// ut_tria

// UT3D_ck_triaOrientI        get orientation from indices
// CCW ist 01 12 20;      CW ist 02 21 10;    Val0=1, Val1=2, Val2=4.
#define UT3D_ck_triaOrientI(i0,i1)\
 (((((i0)==0)&&((i1)==1))||(((i0)==1)&&((i1)==2))||(((i0)==2)&&((i1)==0))) ? CCW : CW)

// UT3D_ck_triaOrientV        get orientation from indices
// CCW ist 01 12 20;      CW ist 02 21 10;    Val0=1, Val1=2, Val2=4.
#define UT3D_ck_triaOrientV(i0,i1)\
 (((((i0)==1)&&((i1)==2))||(((i0)==2)&&((i1)==4))||(((i0)==4)&&((i1)==1))) ? CCW : CW)

// UT3D_ind3Tria_2ind         give index of 3.point of triangle (0/1/2)
#define UT3D_ind3Tria_2ind(i1,i2) (IABS((i1)+(i2)-3))

// UT3D_tria_pta_fac          create triangle from Fac3
#define UT3D_tria_pta_fac(tri,fac,pTab)\
 (tri)->pa[0] = &(pTab)[(fac)->i1];\
 (tri)->pa[1] = &(pTab)[(fac)->i2];\
 (tri)->pa[2] = &(pTab)[(fac)->i3]



//----------------------------------------------------------------
// OGX_SET_OBJ                load complex-object
#define OGX_SET_OBJ(ox,oTyp,oForm,oSiz,oDat)\
  (ox)->typ = (oTyp);\
  (ox)->form = (oForm);\
  (ox)->siz = (oSiz);\
  (ox)->data = (oDat);\
  (ox)->dir = 0

// OGX_SET_INDEX              load complex-object with db-typ and index
// replaces: ox.form = Typ_Index; ox.typ = dbTyp; ox->data = (void*)dbInd;
#define OGX_SET_INDEX(dbTyp,dbInd,ox){\
  (ox)->typ = (dbTyp);\
  (ox)->form = Typ_Index;\
  (ox)->siz = 1;\
  (ox)->data = (void*)(dbInd);}

// OGX_GET_INDEX              get index out of complex-object
// replaces: (int)ind = (long)oxi->data;   (if oxi->form == Typ_Index)
#define OGX_GET_INDEX(ox)\
  (long)(ox)->data


//----------------------------------------------------------------
#define MEM_swap_int(i1,i2){\
  int _i3 = *(i1); *(i1) = *(i2); *(i2) = _i3;}

#define MEM_swap_2vp(v1,v2){\
  void *_v3 = *(v1); *(v1) = *(v2); *(v2) = _v3;}
  // void MEM_swap_2vp (void **p1, void **p2)

#define MEM_swap_2db(d1,d2){\
  double _d3 = *(d1); *(d1) = *(d2); *(d2) = _d3;}


//----------------------------------------------------------------
// UME_getPos                get actual memSpacePosition
#define UME_connect(memPos,memSeg)(memPos)=(memSeg)->next

// UME_setPos                release memSpace
#define UME_release(memPos,memSeg)(memSeg)->next=(memPos)


//=============== EOF ============================================
