/***************************************************************************
                          ut_geo_const.h  -  description
                             -------------------
    begin                : Fri Aug 25 2000
    copyright            : (C) 2000 by CADCAM-Services Franz Reiter
    email                : franz.reiter@cadcam.co.at

****************************************************************************

FOR INFORMATION ONLY;
DO NOT INCLUDE.
USE WITH:
// includes from ../ut/ut_geo_const.h
extern <typ> <name>;

*/




//================================================================
// constant Tolerances:
double UT_TOL_min2 = 1E-12;
double UT_TOL_min1 = 0.00000001; // was 0.000001
double UT_TOL_min0 = 0.0000005;
double UT_TOL_PAR  = 0.00001;    // tolerance for parallelism
double UT_TOL_Ang1 = 0.00017;    // Angle 0.01 Grad
double UT_TOL_0Cos = 0.0000001;  // tolerance for zero cosine



//================================================================
// Tolerances depending on Modelsize: APT_ModSiz (../ci/NC_Main.c)
// Defaultvalues with Modelsize=500:

// identical Points-tolerence
double UT_TOL_pt   = 0.0001;

// Toleranz fuer die Behandlung einer Menge von Punkten als Gerade
double UT_TOL_ln   = 0.001;

// max Abweichung Curve. (Tol. bei Umwandlung Curve -> Polygon).
double UT_TOL_cv   = 0.005;    // Angle: ca 0.3 degree

// max. Abweichung bei der Darstellung von Kreisen, Kurven
double UT_DISP_cv  = 0.05;         // 2003-09-05: 0.05; war 0.01   

// Angles: degree-val: 1=0.017  0.1:0.002  0.01=0.0002




//================================================================
// constant geometric objects:

const Point2  UT2D_PT_NUL     = { 0.0, 0.0 };
const Point   UT3D_PT_NUL     = { 0.0, 0.0, 0.0 };

const Point2  UT2D_PT_INFTY   = {9999999999999.999, 9999999999999.999};

const Vector2 UT2D_VECTOR_NUL = { 0.0, 0.0 };
const Vector2 UT2D_VECTOR_X   = { 1.0, 0.0 };
const Vector2 UT2D_VECTOR_Y   = { 0.0, 1.0 };

const Vector  UT3D_VECTOR_NUL = { 0.0, 0.0, 0.0 };

const Vector  UT3D_VECTOR_X   = { 1.0, 0.0, 0.0 };
const Vector  UT3D_VECTOR_Y   = { 0.0, 1.0, 0.0 };
const Vector  UT3D_VECTOR_Z   = { 0.0, 0.0, 1.0 };

const Vector  UT3D_VECTOR_IX  = {-1.0, 0.0, 0.0 };
const Vector  UT3D_VECTOR_IY  = { 0.0,-1.0, 0.0 };
const Vector  UT3D_VECTOR_IZ  = { 0.0, 0.0,-1.0 };


const Mat_3x3 UT3D_MAT_3x3    = { {1.0, 0.0, 0.0},
                                  {0.0, 1.0, 0.0},
                                  {0.0, 0.0, 1.0} };

                                // VX   VY   VZ   PO
const Mat_4x3 UT3D_MAT_4x3    = { {1.0, 0.0, 0.0, 0.0},
                                  {0.0, 1.0, 0.0, 0.0},
                                  {0.0, 0.0, 1.0, 0.0} };

const Mat_4x4 UT3D_MAT_4x4    = { {1.0, 0.0, 0.0, 0.0},
                                  {0.0, 1.0, 0.0, 0.0},
                                  {0.0, 0.0, 1.0, 0.0},
                                  {0.0, 0.0, 0.0, 1.0} };




//================================================================
// constants:

const int    UT_INT_MAX  = 999999999;
const int    UT_I2_MAX   = 65535;
const double UT_VAL_MIN  = -9999999999999.999;
const double UT_VAL_MAX  =  9999999999999.999;
const double UT_DB_LEER  = -99999999.99999999;
const double UT_DB_NULL  = 0.0;
const char   UT_CHR_NULL = '\0';




//================  EOF =====================
