/* ut_txt.h


2002-02-25 term_buf u term_anz von ut_txfil.h hierher. RF.

*/



#define TXT_Typ_EOF       0
#define TXT_Typ_spec      1
#define TXT_Typ_text      2         /* nicht in " eingeschlossenen Texte */
#define TXT_Typ_num       3
#define TXT_Typ_string    4         /* in " eingeschlossenen Texte */






// die Anzahl der Zeilentrennzeichen bei Windows 2 (CRLF), bei Unix 1 (LF).
// Achtung: bei gtk wird das \r scheinbar automatisch eingefuegt !!!
#ifdef _MSC_VER
#define  term_anz 1
#define  term_buf "\n"
// #define  term_anz 2
// #define  term_buf "\r\n"
// FilenamedelimiterChar
#define  fnam_del '\\'
#define  fnam_del_s "\\"
#else
#define  term_anz 1
#define  term_buf "\n"
#define  fnam_del '/'
#define  fnam_del_s "/"
#endif




// ------------- inline functions ------------------------------------

// skip the active char and following blanks.    tp=(char**) !
#define UTX_skip_1bl(tp) {++(*(tp)); while(**(tp) == ' ') ++(*(tp));}

// skip blanks (returns Position of first non-blank)
#define UTX_pos_skipLeadBlk(p1) while (*p1 == ' ') ++p1

// find end of string ('\0')           p1 = UTX_pos_EOS(cString);
#define UTX_pos_EOS(p1) strchr(p1, '\0')

// -------------------------------------------------------------------
extern const char TX_NUL;





/*****************************************************************************/
/*                              PROTOTYPES                                   */
/*****************************************************************************/

  void  UTX_cp_word_2_upper (char* txtout, char* txtin);
  char* UTX_cp_word_term (char* txtOut, char* txtIn, char term);
  char  UTX_cp_word_t (char *txtOut, char **cBuf);
  char* UTX_cp_word__ (char *txtOut, char *txtIn);
  int   UTX_cp_right (char *sOut, char *sIn, int cNr);

  int UTX_ftyp_s (char *ftyp, char *cbuf, int mode);
  int UTX_fnam_s (char *fnam, char *cbuf);
  int UTX_fdir_s (char *fdir, char *cbuf);

  char  UTX_pos_del    (char**, char**);
  long  UTX_pos_del_next (char *cBuf, long cPos);
  long  UTX_pos_del_prev (char *cBuf, long cPos);
  char* UTX_pos_eos    (char*);
  char* UTX_pos_1n     (char*);
  char* UTX_pos_skipBrack (char *cbuf);
  char* UTX_pos_skipWord  (char *cbuf);
  char* UTX_pos_skipWords (int wNr, char *p1);
  char* UTX_pos_skipDeli1 (char *p1);
  int   UTX_pos_skip_int  (char **ps);

  int   UTX_ckc_Del1   (char c1);
  int   UTX_ck_num1    (char **pOut, char *cbuf);
  int   UTX_cmp_word_wordtab (char *wdtab[], char *wd1);

  char* UTX_2db_tx     (double *d1, double *d2, char *cbuf);
  double UTX_db_tx     (char **po, char *pi);

  int   UTX_add_i_u    (char[], int);
  int   UTX_add_db     (char outBuf[], double *db1);
  int   UTX_add_pt     (char outBuf[], void *pt1);
  int   UTX_add_fl_u   (char[], double);
  int   UTX_add_fl_u2  (char[], double, double);
  int   UTX_add_fl_u3  (char[], double, double, double);
  int   UTX_add_fl_f   (char[], double, int);
  int   UTX_add_fl_10  (char[], double);
  int   UTX_add_fl_15  (char[], double);

  int   UTX_del_foll0  (char strBuf[]);
  void  UTX_del_follBl (char *cbuf);
  int   UTX_del_FilTx  (char *dtxt, char *filNam);

  char* UTX_fgets      (char* line, int len, FILE* fp);
  int   UTX_fgetLine   (char *cbuf, char *filNam, int lNr);
  int   UTX_fsavLine   (char *cbuf, char *filNam, int lNr);
  int   UTX_fRevL      (char *fno, char *fni);

  void  UTX_ins_s2     (char*, char*, int);

  void  UTX_CleanCR    (char*);
  void  UTX_CleanSC    (char*);
  int   UTX_CleanCommC (char *cBuf);
  int   UTX_Clean_db   (char*);
  int   UTX_chg_chr1   (char newChr, char oldChr, char *cBuf);
  int   UTX_chg_str1   (long *datSiz,
                        void *datStart, void *insDat, void *delPos, long delSiz);
  int   UTX_chg_nr     (char *txtOut, int iNr);
  char* UTX_CleanBracks (char* txtbuf, char ch1, char chr2);
  int   UTX_endDelChar (char* txtbuf, char chr);

  int   UTX_get_word   (char** txtIn,char** w_next,char* txtOut,double* val,
                                                              char* deli);
  char* UTX_find_word1 (char *was, char *wo);
  char* UTX_find_Del1  (char *p1);
  char* UTX_find_strrstr (char *cbuf, char *str);
  int   UTX_strcmp_right (char *string, char *text);

  char *UTX_memFind    (char *buf, char *str);
  char *UTX_memFind1   (char *buf, long bufSiz, char *str, long strSiz);
  char *UTX_memstr     (char* von, char* bis, char* sstr);
  int   UTX_insert1    (char *cbuf, long *bufSiz, char *auxBuf, long cPos);
  int   UTX_cut1       (char *cbuf, long *bufSiz, long cPos, long txLen);

  int UTX_wordnr       (char *cbuf);

  int UTX_cat_file     (FILE *fpo, char *fnam);
  int UTX_dir_listf    (char *outFilNam, char *fPath, char *fTyp);

/* ------------ eof ---------------- */
