/*  Demoprog                                         RF     2004-11-05

- clear model
- load 3 submodels
- place submodels
- redraw

*/



#include "MS_Def1.h"

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <stdarg.h>       // fuer Variad. Funktionen (...)
#include <time.h>         // f clock

#include <GL/gl.h>
#include <GL/glu.h>

#include <gdk/gdkkeysyms.h>            // GDK_Esc


#ifdef _MSC_VER
// die folgenden 2 Funktionen exportieren (werden vom Main gerufen):
__declspec(dllexport) int gCad_main ();
__declspec(dllexport) int gCad_fini ();
// nachfolgende externals werden aus dem Main-Exe imported:
#define extern __declspec(dllimport)
#endif



// #include "../ut/ut_geo.h"              // Point ...
// #include "../ut/ut_txt.h"              // fnam_del
// #include "../ut/ut_os.h"               // OS_get_bas_dir ..
// #include "../ut/ut_obj.h"              // UTO_stru_2_obj
#include "../gr/ut_UI.h"               // UI_Func... SYM_..
#include "../xa/xa_uid.h"              // UID_..
// #include "../xa/xa_mem.h"              // memspc51, mem_cbuf1
// #include "../xa/ut_ui_TX.h"            // TX_Print





//=========================================================
  int gCad_fini () {
//=========================================================
// dll being unloaded - reset Input, kill all open windows !!!

  TX_Print("...... gCad_fini DemoAssy1");

  return 0;

}


//=========================================================
  int gCad_main () {
//=========================================================
// init userfunction

  char   cBuf1[256], cBuf2[256];

  TX_Print("--->>>>>> gCad_main aus DemoAssy1 >>>>>>>---\n");


  // clear ("new")
  UI_menCB (NULL, "new");


  // get path for symbol "Data" (out of xa/dir.lst)
  Mod_sym_get1 (cBuf1, "Data/", 0);
    printf(" path=|%s|\n",cBuf1);



  // load 3 submodels from Directory "Data"
  Mod_LoadSubmodel ("sample_mod_blech1.gcad", cBuf1);
  Mod_LoadSubmodel ("sample_mod_screw1.gcad", cBuf1);
  Mod_LoadSubmodel ("sample_mod_nut1.gcad", cBuf1);


  // place submodels
  // init AuxBuf, add Lines -> Aux.Buffer
  UTF_clear1();
  UTF_add1_line ("M20=\"sample_mod_blech1\" P(0 10 0)");
  UTF_add1_line ("M21=\"sample_mod_screw1\" P(30 36.5 67)");
  UTF_add1_line ("M22=\"sample_mod_nut1\" P(36 36.5 67)");


  // Add Aux.Buffer -> MainBuffer
  UTF_insert1(-1);
  UI_AP (UI_FuncSet, UID_WinEdit, NULL);


  // execute (=Press END-Button), redraw
  UI_butCB (NULL, (void*)"butEND");
  DL_Redraw ();


  return 0;


}


//====================== EOF =============================
