/*
Example create objects.

Compile/Link/Reload is done while gCad3D is up and running !!


make -f DemoPlugin_Create.mak

*/

#include "MS_Def1.h"

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>



// #include <GL/gl.h>                     // GL_TRIANGLE_FAN
#define GL_TRIANGLE_FAN  6             // unsauber ..

// gtk muss vor __declspec(dllimport) stehen
#include "../gtk/ut_gtk.h"             // f. xa_ui.h



#ifdef _MSC_VER
// die folgenden 2 Funktionen exportieren (werden vom Main gerufen):
__declspec(dllexport) int gCad_main ();
__declspec(dllexport) int gCad_fini ();
// nachfolgende externals werden aus dem Main-Exe imported:
#define extern __declspec(dllimport)
#endif



#include "../ut/ut_geo.h"              // Point ...
#include "../gr/ut_UI.h"               // UI_Func...
#include "../xa/xa_ui.h"                     // UID_..





static  char   cBuf[512];

char myMemspc[50000];





//=========================================================
  int gCad_fini () {
//=========================================================

  return 0;
}



//=========================================================
  int gCad_main () {
//=========================================================


  printf("gCad_main aus DemoPlugin_Create\n");


  // Message ans MainWin
  TX_Print("gCad_main aus DemoPlugin_Create\n");


  // Gesamtes File loeschen
  UI_menCB (NULL, "new");


  // cre_1 ();  // create single permanent object
  // cre_2 ();  // create block of permanent objects

  // Create / display temporary objects:
  cre_3 ();      // Line Circ Curv Note
  cre_4 ();      // symbols
  cre_5 ();      // Ditto

  cre_6 ();      // ruled surfaces
  cre_7 ();      // revolved surfaces
  cre_8 ();      // tesselated surfaces
  cre_9 ();      // planare surf; trimmed / perforated

  cre_10();      // TestDisplayfunktions (_Disp_)

  // Redraw DispList
  DL_Redraw ();

  return 0;

}


//=========================================================
  int cre_1 () {
//=========================================================

  // 1. variante:
  // slow, aber kein execute erforderl.
  // add & execute single line

  ED_add_Line ("P1=P(100 110)");
  ED_add_Line ("P2=P(100 200)");
  ED_add_Line ("P3=P(200 200)");

  return 0;

}


//=========================================================
  int cre_2 () {
//=========================================================
// 2. Variante (viel schneller)


  // init AuxBuf, add Lines -> Aux.Buffer
  UTF_clear1();
  UTF_add1_line ("P1=P(100 100)");
  UTF_add1_line ("P2=P(200 100)");
  UTF_add1_line ("P3=P(200 200)");


  // Add Aux.Buffer -> MainBuffer
  UTF_insert1(-1);
  UI_AP (UI_FuncSet, UID_WinEdit, NULL);


  // execute (=Press END-Button)
  UI_butCB (NULL, (void*)"butEND");


  return 0;

}



//=========================================================
  int cre_3 () {
//=========================================================
// create object, change obj -> text, save text, execute text.


  int    iCv1, iCv2;
  Point2 pt21, pt22, pt2c, pt2a[5];
  Point  pt1, pt2, ptc, pta[5];
  Line2  ln21;
  Line   ln1;
  Circ2  ci21;
  Circ   ci1;
  GText  tx1;
  char   cbuf[80];


  // comment
  ED_add_Line ("# generated by DemoPlugin_Create");


  // 2D-Point
  pt21.x=100.; pt21.y=100.;
  pt22.x=100.; pt22.y=200.;
  cre_obj (Typ_PT, Typ_PT2, 1, (void*)&pt21);
  cre_obj (Typ_PT, Typ_PT2, 1, (void*)&pt22);


  // 3D-Point
  pt1.x=100.; pt1.y=100.; pt1.z=100.;
  pt2.x=100.; pt2.y=200.; pt2.z=100.;
  cre_obj (Typ_PT, Typ_PT, 1, (void*)&pt1);
  cre_obj (Typ_PT, Typ_PT, 1, (void*)&pt2);


  // dim following
  ED_add_Line ("DIM");


  // 2D-Line
  ln21.p1 = pt21; ln21.p2 = pt22;
  cre_obj (Typ_LN, Typ_LN2, 1, (void*)&ln21);


  // 3D-Line
  ln1.p1 = pt1; ln1.p2 = pt2;
  cre_obj (Typ_LN, Typ_LN, 1, (void*)&ln1);


  // reset dim
  ED_add_Line ("G1");


  // 2D-Circ
  ci21.pc.x=100.; ci21.pc.y=100.;
  ci21.p1.x=100.; ci21.p1.y=90.;
  ci21.p2.x=110.; ci21.p2.y=100.;
  ci21.p2 = ci21.p1;    // full circ
  ci21.rad = 10.;       // CW not possible !
  cre_obj (Typ_CI, Typ_CI2, 1, (void*)&ci21);



  // 3D-Circ
  ci1.pc.x=100.; ci1.pc.y=100.; ci1.pc.z=100.;
  ci1.p1.x=100.; ci1.p1.y=100.; ci1.p1.z=125.;
  // ci1.p2 = ci1.p1;    // full circ
  ci1.p2.x=125.; ci1.p2.y=100.; ci1.p2.z=100.;
  ci1.vz.dx=0.;  ci1.vz.dy=1.;  ci1.vz.dz=0.;
  ci1.rad = -25.;            // pos = CCW; neg = CW
  cre_obj (Typ_CI, Typ_CI, 1, (void*)&ci1);


  //  following -> Layer 1
  ED_add_Line ("LAY 1");



  // Text
  printf("DemoPlugin_Create: Text.\n");


  // Alfatext (does not scale)
  strcpy(cbuf, "ci1");
  tx1.pt   = ci1.pc;
  tx1.size = -1.;
  tx1.dir  = 0.;         // direction
  tx1.txt  = cbuf;
  cre_obj (Typ_GTXT, Typ_GTXT, 1, (void*)&tx1);


  // Graf.text (scales)
  strcpy(cbuf, "Graf.text");
  UT3D_pt_3db (&tx1.pt, 0., 100., 0.);
  tx1.size = 1.;
  tx1.dir  = 90.;         // direction
  tx1.txt  = cbuf;
  cre_obj (Typ_GTXT, Typ_GTXT, 1, (void*)&tx1);


  // hide following, back  to layer 0
  ED_add_Line ("DRAW OFF");
  ED_add_Line ("LAY 0");




  // Polygon
  UT3D_pt_3db (&pta[0], 200., 0.,  0.);
  UT3D_pt_3db (&pta[1], 250., 0.,  0.);
  UT3D_pt_3db (&pta[2], 300., 50., 0.);
  UT3D_pt_3db (&pta[3], 350., 50., 0.);
  UT3D_pt_3db (&pta[4], 400., 80., 0.);

  iCv1 = cre_obj (Typ_CVPOL, Typ_PT, 5, (void*)pta);


  // display, hilite following
  ED_add_Line ("DRAW ON");
  ED_add_Line ("HILI");



  // convert 2D-Polygon -> B-Spline-Curve, Degree 3
  sprintf(cbuf, "S%d,3",iCv1);
  iCv2 = cre_obj (Typ_CVBSP, Typ_Txt, 1, (void*)cbuf);



  // convert B-Spline-Curve -> Circs




  // clean undo-tables
  UI_undo_clear ();


  return 0;

}


//=================================================================
  int obj_obj (ObjGX *oo, int typ, int form, int siz, void *obj) {
//=================================================================


  oo->typ  = typ;     // die Bedeutung der Daten im Feld <data>
  oo->form = form;    // die Struktur der Daten im Feld <data>
  oo->siz  = siz;     // Anzahl der Daten; wenn > 1: ein Array im Feld <data>
  oo->data = obj;     //

  oo->dir  = 0;


  if(form == Typ_Index) {
   printf(" ind1=%d\n",(int)obj);
   printf(" ind2=%d\n",(int)oo->data);
}

  return 0;

}


//=========================================================
  int cre_obj (int typ, int form, int siz, void *obj) {
//=========================================================

  int    irc;
  long   ind;
  ObjGX  ox1;


  printf("cre_obj typ=%d form=%d siz=%d\n",typ,form,siz);


  // create obj
  obj_obj (&ox1, typ, form, siz, obj);


  // change Object -> Text
  irc = AP_obj_2_txt (cBuf, 512, &ox1, -1);
  if(irc < 0) return irc;

  // query typ and index of created object
  AP_obj_2_txt_query (&typ, &ind);

  // add & execute line
  ED_add_Line (cBuf);


  return ind;

}


//=========================================================
  int cre_4 () {
//=========================================================
// create dynamic objects
// Rework ("END") will delete these objects !!
// Overlaymodels (=permanent dynamic objects) not yet implemented.


  long   l1;
  Point2 pt21, pt22;
  Point  pt1,  pt2, pt3;
  Vector vc1;



  // bitmap symbols: SYM_TRI_S SYM_STAR_S SYM_TRI_B
  // att: att=0=Def, 1=sw, 2=rot, 4=bl.
  UT3D_pt_3db (&pt1, 200., 200., 50.); APT_disp_SymB (SYM_TRI_S,  0, &pt1);
  UT3D_pt_3db (&pt1, 200., 250., 50.); APT_disp_SymB (SYM_TRI_B,  1, &pt1);
  UT3D_pt_3db (&pt1, 200., 300., 50.); APT_disp_SymB (SYM_STAR_S, 2, &pt1);




  // scaled symbols: SYM_TRIANG SYM_SQUARE SYM_CROSS SYM_CROSS1
  UT3D_pt_3db (&pt1,200.,200.,0.); APT_disp_SymV1 (SYM_TRIANG, 1, &pt1, 1.);
  UT3D_pt_3db (&pt1,200.,250.,0.); APT_disp_SymV1 (SYM_SQUARE, 1, &pt1, 1.);
  UT3D_pt_3db (&pt1,200.,300.,0.); APT_disp_SymV1 (SYM_PLANE,  1, &pt1, 1.);
  UT3D_pt_3db (&pt1,200.,350.,0.); APT_disp_SymV1 (SYM_CROSS,  1, &pt1, 1.);
  UT3D_pt_3db (&pt1,200.,400.,0.); APT_disp_SymV1 (SYM_CROSS1, 1, &pt1, 1.);
  UT3D_pt_3db (&pt1,200.,450.,0.); APT_disp_SymV1 (SYM_AXIS,   1, &pt1, 1.);
  UT3D_pt_3db (&pt1,200.,500.,0.); APT_disp_SymV1 (SYM_AXIS1,  1, &pt1, 1.);


  // scaled oriented symbols: SYM_ARROH (arrowheads)
  UT3D_pt_3db (&pt1, 300., 200., 0.);
  UT3D_pt_3db (&pt2, 350., 250., 0.);
  UT3D_pt_mid2pt (&pt3, &pt1, &pt2);

  APT_disp_SymV2 (SYM_ARROH, 1, &pt1, &pt2, 1.);  // head only at pt1 !
  APT_disp_SymV2 (SYM_ARROH, 1, &pt2, &pt1, 1.);  // head only at pt2 !

  APT_disp_SymV3 (SYM_ARROW, 2, &pt1, &UT3D_VECTOR_Z, 10.);  // arrow
  APT_disp_SymV3 (SYM_ARROW, 2, &pt2, &UT3D_VECTOR_Z, 10.);  // arrow
  // 3D-Arrowhead
  APT_disp_SymV3 (SYM_ARRO3H, Typ_Att_Symb, &pt3, &UT3D_VECTOR_Z, 1.);


  // 3D-Plane
  UT3D_pt_3db (&pt1, 350., 600., 100.);
  UT3D_vc_3db (&vc1,   0.,  0.75,  0.75);
  APT_disp_SymB (SYM_STAR_S,  1, &pt1);
  APT_disp_SymV3 (SYM_SQUARE, 1, &pt1, &vc1, 1.);  // arrow



  return 0;

}


//=========================================================
  int cre_5 () {
//=========================================================
// create dynamic objects
// Rework ("END") will delete these objects !!
// ScaleAll cannot work (nothing in DB)
// Overlaymodels (=permanent dynamic objects) not yet implemented.

  long    id1;
  Point   pt1, pt2, pa[4];
  Line    ln1;
  Circ    ci1;
  Ditto   dit1;


  printf("cre_5\n");

  id1 = -1;    // temp. elem.
  // id1 = 1;     // +1: store in dynamic area in DB


  UT3D_pt_3db (&pt1, 100.,   0.,   0.);
  GR_CrePoint (&id1, Typ_Att_PT, &pt1);


  UT3D_pt_3db (&ln1.p1, 100.,   0.,   0.);
  UT3D_pt_3db (&ln1.p2, 100., 100.,   0.);
  ++id1; GR_CreLine (&id1, 1, &ln1);



  UT3D_pt_3db (&ci1.pc,   0.,    0.,   0.);
  UT3D_pt_3db (&ci1.p1, 100.,    0.,   0.);
  UT3D_pt_3db (&ci1.p2,   0.,    0., 100.);
  UT3D_vc_3db (&ci1.vz,   0.,   -1.,   0.);
  ci1.rad  = 100.;
  ci1.ango = UT3D_angr_ci (&ci1);  // MUST provide opening angle !
  id1=0; GR_CreCirc (&id1, Typ_Att_def, &ci1);
  printf(" circ %d\n",id1);


  // use following polygon for ditto; save ditto-startposition (active DL-posi)
  dit1.ind = GL_Get_DLind();



  // create attrib 
  // (AttNr, col(2=r,3=g,4=b),typ(0=voll,1=-.,2=- -, 3=--),thick(1-6))
  DL_InitAttRec (20,    4, 2, 3);  // att 20 = blue, strichl, thick3




  // polygon
  UT3D_pt_3db (&pa[0], 100.,  200.,   0.);
  UT3D_pt_3db (&pa[1], 100.,  250.,   0.);
  UT3D_pt_3db (&pa[2], 100.,  250., 100.);
  UT3D_pt_3db (&pa[3], 100.,  200., 100.);
  id1=0; GR_CrePoly (&id1, 20, 4, &pa);


  // DL_disp_set (GL_GetActInd(), OFF);         // hide last created Obj



  UT3D_pt_3db (&dit1.po, 100., 200., 0.);      // origin (rotate-pos)
  dit1.siz = GL_Get_DLind() - dit1.ind;        // save size of ditto
  UT3D_pt_3db (&pt1, 100.,   400.,   0.);      // new dittopos

  // ditto (pos, rotAng, mirror, ditto)
  // mirror: no=' ', 'X'=X-Z-plane, 'Y'=Y-Z-plane
  ++id1; GR_CreDitto2 (&id1, &pt1,  0., ' ', &dit1);
  ++id1; GR_CreDitto2 (&id1, &pt1, 30., 'X', &dit1);
  ++id1; GR_CreDitto2 (&id1, &pt1, 60., 'X', &dit1);
  ++id1; GR_CreDitto2 (&id1, &pt1, 90., ' ', &dit1);




  // bitmap text: (ID, att, pt, text)
  UT3D_pt_3db (&pt1, 200.,   0.,   0.);
  GR_CreTxtA (&id1, Typ_Att_Symb, &pt1, "abc");


  // scaled rotated text: (ID, att, pt, scale, dir, text)
  UT3D_pt_3db (&pt1, 200.,  50.,   0.);
  GR_CreTxtG (&id1, 1, &pt1, 1., 90., "--->>>");


  return 0;

}


//=========================================================
  int cre_6 () {
//=========================================================
// ruled surfaces ..

  long   id1;
  Point  pt1,  pt2, pa[9];
  Line   ln1, ln2;
  Vector v1;
  Circ   ci1;
  ObjGX  os, oa[2];


  // create Lineobj
  UT3D_pt_3db (&ln1.p1, 300.,  0.,   0.);
  UT3D_pt_3db (&ln1.p2, 350.,  0.,   0.);
  obj_obj (&oa[0], Typ_LN, Typ_LN, 1, &ln1);

  // create pointobj
  UT3D_pt_3db (&pt1, 300.,  0.,   100.);
  obj_obj (&oa[1], Typ_PT, Typ_PT, 1, &pt1);

  // create ruled surf
  obj_obj (&os, Typ_SURRU, Typ_ObjGX, 2, oa);

  // draw ruled surf
  TSU_DrawSurT_ (&os, Typ_Att_Fac1, 0L);





  // create ln 1
  UT3D_pt_3db (&ln1.p1, 300.,  100.,   0.);
  UT3D_pt_3db (&ln1.p2, 350.,  100.,   0.);
  obj_obj (&oa[0], Typ_LN, Typ_LN, 1, &ln1);

  // create ln 2
  UT3D_pt_3db (&ln2.p1, 320.,  120.,   100.);
  UT3D_pt_3db (&ln2.p2, 350.,  100.,   100.);
  obj_obj (&oa[1], Typ_LN, Typ_LN, 1, &ln2);

  obj_obj (&os, Typ_SURRU, Typ_ObjGX, 2, oa);
  TSU_DrawSurT_ (&os, Typ_Att_Fac1, 0L);





  UT3D_pt_3db (&ln1.p1, 300.,  200.,   0.);
  UT3D_pt_3db (&ln1.p2, 350.,  200.,   0.);
  // ruled obj # 1 = ln
  obj_obj (&oa[0], Typ_LN, Typ_LN, 1, &ln1);


  UT3D_pt_3db (&pt1, 350.,  200.,   100.);
  UT3D_pt_3db (&pt2, 300.,  200.,   100.);
  // Z-vector of active construction-plane
  AP_Get_ConstPl_vz (&v1);

  // Circ from center, startpoint, axis, opening angle
  UT3D_ci_ptptvcangr (&ci1, &pt1, &pt2, &v1, UT_RADIANS(-120.));
    UT3D_stru_dump (Typ_AC, &ci1, "ci1");
  obj_obj (&oa[1], Typ_AC, Typ_AC, 1, &ci1);

  // ruled obj #2 = circ
  obj_obj (&os, Typ_SURRU, Typ_ObjGX, 2, oa);
  TSU_DrawSurT_ (&os, Typ_Att_Fac1, 0L);







  UT3D_pt_3db (&pt1, 450.,  0.,  75.);
  UT3D_pt_3db (&pt2, 450.,  0.,   0.);
  id1 = 1;
  // cylinder (ID, att, cen1, cen2, rad1, rad2)
  GR_CreCyl (&id1, Typ_Att_Fac1, &pt1, &pt2, 15., 35.);





  id1 = 1;
  UT3D_pt_3db (&pt1, 450.,  0.,   0.);
  // disc (ID, att, cen, vector, inner_rad, outer_rad)
  GR_CreDisk (&id1, Typ_Att_Fac1, &pt1, &UT3D_VECTOR_Z, -35., -50.0);




  // triangle-fan (ID, att, startpt, nr_of_points, points)
  id1 = 1;
  UT3D_pt_3db (&pa[0], 350.,  300.,   0.);
  UT3D_pt_3db (&pa[1], 350.,  350.,   0.);
  UT3D_pt_3db (&pa[2], 350.,  350.,  75.);
  UT3D_pt_3db (&pa[3], 350.,  300.,  75.);
  GR_CreTriaFan (&id1, Typ_Att_Fac1, pa, 3, &pa[1]);



  // triangle-strip (ID, att, nr_of_points_dir1, nr_of_points_dir2, points)
  UT3D_pt_3db (&pa[0], 350.,  400.,   0.);
  UT3D_pt_3db (&pa[1], 350.,  450.,   0.);
  UT3D_pt_3db (&pa[2], 350.,  500.,   0.);

  UT3D_pt_3db (&pa[3], 348.,  400.,  25.);
  UT3D_pt_3db (&pa[4], 346.,  450.,  25.);
  UT3D_pt_3db (&pa[5], 348.,  500.,  25.);

  UT3D_pt_3db (&pa[6], 350.,  400.,  50.);
  UT3D_pt_3db (&pa[7], 350.,  450.,  50.);
  UT3D_pt_3db (&pa[8], 350.,  500.,  50.);

  GR_CreTriaStrip (&id1, Typ_Att_Fac1, 3, 3, pa);

  return 0;

}


//=========================================================
  int cre_7 () {
//=========================================================
// revolved surfaces ..

  int    typ1, typ2;
  long   id1, id2;
  Point  cvp[]={500.,100.,0.,
                520.,125.,0.,
                550.,150.,0.,
                520.,175.,0.,
                500.,200.,0.};
  Line     ln1, ln2;
  SurRev   srv;
  Memspc   memSeg1;
  CurvBSpl cv1;
  ObjGX    os, ocv;


  printf("cre_7 \n");


  // create Centerline
  UT3D_pt_3db (&ln1.p1, 450.,  100.,   0.);
  UT3D_pt_3db (&ln1.p2, 450.,  150.,   0.);
  // id1 = DB_StoreLine (DB_QueryNxtInd(Typ_LN, 1), &ln1);
  cre_obj (Typ_LN, Typ_LN, 1, (void*)&ln1);
  AP_obj_2_txt_query (&typ1, &id1);           // query index


  // create contour
  UME_init (&memSeg1, myMemspc, sizeof(myMemspc));  // init memoryseg (tempspc)
  //           (cvBsp, &memSeg1, pTab, ptNr, deg);
  bspl_bsp_ptn (&cv1,  &memSeg1, cvp,     5,   3);  // make BSP-curve from pTab
  // obj_obj (&ocv, Typ_CVBSP, Typ_CVBSP, 1, &cv1);
  // id2 = DB_StoreCurv (DB_QueryNxtInd(Typ_CV, 1), &ocv, 0);
  cre_obj (Typ_CVBSP, Typ_CVBSP, 1, (void*)&cv1);
  AP_obj_2_txt_query (&typ2, &id2);           // query index


  // RevSur
  srv.indCen = id1;              // Ind of Centerline (Typ = Typ_LN)
  srv.typCen = Typ_LN;           // typ of Centerline
  srv.indCov = id2;              // Ind of contourelement
  srv.typCov = Typ_CV;           // typ of contourelement
  srv.ang1   = UT_RADIANS(300.); // starting angle
  srv.ang2   = UT_RADIANS(360.); // ending angle
  srv.v0     = 0.;               // ending par.
  srv.v1     = 1.;               // ending par.


  cre_obj (Typ_SURRV, Typ_SURRV, 1, (void*)&srv);
  // obj_obj (&os, Typ_SURRV, Typ_SURRV, 1, &srv);
  // TSU_DrawSurT_ (&os, Typ_Att_Fac1, 0L);
  


  return 0;

}


//=========================================================
  int cre_8 () {
//=========================================================
// tesselated surfaces
// Surf = 1-n PlanarPatches
//            Planar patch = 1-n contours (and vector)
//                               Contour = ipoints (closed, tesselated)

  long  il;
  ObjGX gCont[10], gPat[2], gSur;

  Point pp1[]={600., 0., 0., 650., 0., 0.,
               650.,20., 0., 600.,20., 0., 600., 0., 0.,};
  Point pp2[]={600.,20., 0., 650.,20., 0.,
               650.,40., 0., 600.,40., 0., 600.,20., 0.,};
  Point pp3[]={600.,40., 0., 650.,40., 0.,
               650.,40.,40., 600.,40.,40., 600.,40., 0.,};


  //----------------------------------------------------------------
  // Create sur
  gSur.typ  = Typ_GL_Sur;
  gSur.form = Typ_ObjGX;
  gSur.siz  = 1;
  gSur.data = gPat;


  // Create 1. Patch
  gPat[0].typ  = Typ_GL_PP;
  gPat[0].form = Typ_ObjGX;
  gPat[0].siz  = 0;
  gPat[0].data = &gCont[0];


  //----------------------------------------------------------------
  // add  vector to 1. patch
  gCont[0].typ  = Typ_VC;
  gCont[0].form = Typ_VC;
  gCont[0].siz  = 1;
  gCont[0].data = &UT3D_VECTOR_Z;

  gPat[0].siz  = 1;


  //----------------------------------------------------------------
  // add 1. contour to 1. patch
  gCont[1].typ  = Typ_PT;
  gCont[1].form = Typ_PT;
  gCont[1].siz  = 5;
  gCont[1].data = pp1;
  gCont[1].aux  = GL_TRIANGLE_FAN;

  gPat[0].siz  = 2;


  //----------------------------------------------------------------
  // add 2. contour to 1. patch
  gCont[2].typ  = Typ_PT;
  gCont[2].form = Typ_PT;
  gCont[2].siz  = 5;
  gCont[2].data = pp2;
  gCont[2].aux  = GL_TRIANGLE_FAN;

  gPat[0].siz  = 3;


  //================================================================
  // add 2. patch to surf
  gPat[1].typ  = Typ_GL_PP;
  gPat[1].form = Typ_ObjGX;
  gPat[1].siz  = 0;
  gPat[1].data = &gCont[3];

  gSur.siz  = 2;


  //----------------------------------------------------------------
  // add vector to 2. patch
  gCont[3].typ  = Typ_VC;
  gCont[3].form = Typ_VC;
  gCont[3].siz  = 1;
  gCont[3].data = &UT3D_VECTOR_IY;

  gPat[1].siz  = 1;


  //----------------------------------------------------------------
  // add 1. contour to 2. patch
  gCont[4].typ  = Typ_PT;
  gCont[4].form = Typ_PT;
  gCont[4].siz  = 5;
  gCont[4].data = pp3;
  gCont[4].aux  = GL_TRIANGLE_FAN;

  gPat[1].siz  = 2;


  //----------------------------------------------------------------
  // display
  il = DL_StoreObj (Typ_SUR, 20L, Typ_Att_Fac1);  // identifier 20
  // UTO_dump_s_ (&gSur, "sur-tess:");
  // UTO_dump__ (&gSur, "sur-tess:");
  GL_DrawSur (&il, Typ_Att_Fac1, &gSur);


  return 0;

}



//=========================================================
  int cre_9 () {
//=========================================================
// planare surf; trimmed / perforated

  Point pp1[]={600.,100., 0., 650.,100., 0.,
               650.,200., 0., 600.,200., 0., 600.,100., 0.};
  Point pp2[]={625.,125., 0., 625.,175., 0.};

  long     id1, id2, id3, ids;
  Vector   v1;
  Circ     ci1;
  CurvPoly plg1;
  ObjGX    os, oa[4], otmp;
  Memspc   memSeg1;


  // Z-vector of active construction-plane
  AP_Get_ConstPl_vz (&v1);


  // save Polygon pp1
  UME_init (&memSeg1, myMemspc, sizeof(myMemspc));  // init memoryseg (tempspc)
  UT3D_plg_pta (&plg1, pp1, 5, &memSeg1);           // PolgonCurve from pt-tab
  obj_obj (&otmp, Typ_CVPOL, Typ_CVPOL, 1, &plg1);
  // UT3D_stru_dump(Typ_CVPOL, otmp.data, "plg1:");
  id1 = DB_StoreCurv (DB_QueryNxtInd(Typ_CV, 1), &otmp, 0);  // save in DB


  // save holes
  UT3D_ci_ptvcr (&ci1, &pp2[0], &v1, 20.);
  obj_obj (&otmp, Typ_AC, Typ_AC, 1, &ci1);
  id2 = DB_StoreCirc (DB_QueryNxtInd(Typ_AC, 1), &ci1);

  UT3D_ci_ptvcr (&ci1, &pp2[1], &v1, 20.);
  obj_obj (&otmp, Typ_AC, Typ_AC, 1, &ci1);
  id3 = DB_StoreCirc (DB_QueryNxtInd(Typ_AC, 1), &ci1);


  // 1.obj: define typ of supporting surface (planar)
  obj_obj (&oa[0], Typ_Typ, Typ_SURPLN, 0, NULL);

  // 2.obj: boundary
  obj_obj (&oa[1], Typ_CV, Typ_Index, 1, (void*)id1);

  // holes
  obj_obj (&oa[2], Typ_AC, Typ_Index, 1, (void*)id2);
  obj_obj (&oa[3], Typ_AC, Typ_Index, 1, (void*)id3);

  // all -> container
  obj_obj (&os, Typ_SUR, Typ_ObjGX, 4, &oa);
  // UTO_dump__ (&os, "os=");

  // draw
  ids = DB_QueryNxtInd(Typ_SUR, 1);
  ids = DB_StoreSur (ids, &os);
  TSU_DrawSurT_ (&os, Typ_Att_Fac1, ids);
  
  return 0;

}


//=========================================================
  int cre_10 () {
//=========================================================
// TestDisplayfunktions (_Disp_)


  int    i1;
  Point  pt1;
  Vector v1;
  Point  pp1[]={600.,300., 0., 650.,300., 0.,
                650.,400., 0., 600.,400., 0., 600.,300., 0.};


  GR_Disp_pTab (5, pp1, SYM_TRI_S, 2);


  for(i1=0; i1<4; ++i1) GR_Disp_txi (&pp1[i1], i1, 0);


  GR_Disp_cv (pp1, 5, 2);

  
  UT3D_pt_mid2pt (&pt1, &pp1[0], &pp1[2]);
  AP_Get_ConstPl_vz (&v1);
  GR_Disp_vc (&v1, &pt1, 2, 0); // 0="normiert", 1=wahre Groesse


  GR_Disp_spu (5, pp1, Typ_Att_Fac1);


  return 0;

}


//======================== EOF ======================
