/* example dialog.



make -f DemoPlugin_Dialog.mak

*/


#include "MS_Def0.h"

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>            // GDK_Esc


// gtk muss vor __declspec(dllimport) stehen
#include "../gtk/ut_gtk.h"             // f. xa_ui.h




#ifdef _MSC_VER
// die folgenden 2 Funktionen exportieren (werden vom Main gerufen):
__declspec(dllexport) int gCad_main ();
__declspec(dllexport) int gCad_fini ();
// nachfolgende externals werden aus dem Main-Exe imported:
#define extern __declspec(dllimport)
#endif



#include "../ut/ut_geo.h"              // Point ...
#include "../gr/ut_UI.h"               // UI_Func...
#include "../gr/ut_DL.h"               // DB_GetDLatt
#include "../gr/ut_GL.h"               // GL_GetCurpos0
#include "../db/ut_DB.h"               // DB_GetObjGX
#include "xa_ui.h"                     // UID_..



#define CBUFSIZ 1000



  static Point   pt1, pt_tab[5];        // pointbuffer
  static Line    ln1;
  static Vector  vc_tab[3];
  static int     dia_nr;                 // nr of points
  static  char   cBuf[CBUFSIZ];


  static GtkWidget *dia_ideg, *dia_lb_func;

  static long      ID_tab[3];
  static long      dl_start;



// prototypes:
  int dia_CB_1 (GtkWidget *parent, void *data);
  int Cre_Poly (GtkWidget *parent, void *data);






  static GtkWidget *win0;



//=========================================================
  int dia_sele2 (int src, long dl_ind) {
//=========================================================
// userselection-callback  turn-arrow
// (user selects arrow)

  int    i1, irc, ideg;
  long   l1;
  ObjGX  ox1;
  DL_Att att1;



  printf("dia_sele2 source=%d ind=%ld nr=%d\n",src,dl_ind,dia_nr);


  if(src != TYP_EvMouseL) goto L_err_1; // skip all but left mousebutt.

  // get DL-record
  att1 = DL_GetAtt(dl_ind);

  if(att1.typ != Typ_SymV) goto L_err_1;     // skip all but symbols


  for(i1=0; i1<3; ++i1) {
    if(ID_tab[i1] == dl_ind) {         // dynam. symbols report DL-Ind.
      printf(" arr %d sel\n",i1);
      goto L_1;
    }
  }
  goto L_err_1;



  //-----------------------------------------------------
  L_1:
  // delete selected obj
  GL_Del0 (ID_tab[i1]);

  // delete displist from dl_start -> end (points, line from last run)
  if(dl_start != 0) GL_Delete (dl_start+1);

  // redraw inverted vector
  UT3D_vc_invert (&vc_tab[i1], &vc_tab[i1]);   // invert vector
  APT_disp_SymV3 (SYM_ARROW, 2, &pt_tab[i1], &vc_tab[i1], 10.);
  ID_tab[i1] = GL_GetActInd();

  // save DL-posi (to delete all foll. objs)
  dl_start = GL_GetActInd(); // keep last obj

  // 2 point & 1 line
  UT3D_pt_traptvclen (&ln1.p1, &pt_tab[i1], &vc_tab[i1], -20.);
  l1 = -1;  // do not store obj in DB
  GR_CrePoint (&l1, Typ_Att_PT, &ln1.p1);
  UT3D_pt_traptvclen (&ln1.p2, &pt_tab[i1], &vc_tab[i1], -100.);
  l1 = -1;  // do not store obj in DB
  GR_CrePoint (&l1, Typ_Att_PT, &ln1.p2);
  l1 = -1;  // do not store obj in DB
  GR_CreLine (&l1, 1, &ln1);

  DL_Redraw (); // Redraw DispList

  return 0;



  //-----------------------------------------------------
  L_err_1:
  TX_Error (" select arrow !!");
  return 0;

}


//=========================================================
  int dia_sele1 (int src, long dl_ind) {
//=========================================================
// userselection-callback points->curve
// (user selects or indicates points)

  int      irc, ideg;
  long     l1;
  char     *p1;
  DL_Att   att1;


  printf("dia_sele1 source=%d ind=%ld nr=%d\n",src,dl_ind,dia_nr);



  // skip right & middle-mousebutton
  if(src != TYP_EvMouseL) {
    printf("right mousebutton not used\n");
    return 0;
  }


  // indicate position
  if(dl_ind < 0) {
    pt1 = GL_GetViewPos ();      // get curr. cursorposition


  // select Point
  } else {
    // get DL-record
    att1 = DL_GetAtt(dl_ind);

    if(att1.typ == Typ_PT) {
      pt1 = DB_GetPoint (att1.ind);
      // UT3D_stru_dump (Typ_PT, &pt1, "sel.P%d",att1.ind);

    } else {
      TX_Error (" select point or indicate position");
      return 0;
    }
  }



  printf("Pos=%f,%f,%f\n",pt1.x,pt1.y,pt1.z);
  pt_tab[dia_nr] = pt1;


  // display small triangle
  APT_disp_SymB (SYM_TRI_S,  0, &pt1);  // cr dynamic symbol


  // done for first 4 points
  if(dia_nr < 4) {
    ++dia_nr;
    DL_Redraw (); // Redraw DispList
    return 0;
  }


  // dim follow objects (and do not export these obj)
  ED_add_Line ("DIM");

  // create textline
  irc = cre_obj (Typ_CVPOL, Typ_PT, 5, (void*)&pt_tab);
  if(irc < 0) return irc;

  // get degree
  // p1 = gtk_entry_get_text (GTK_ENTRY(dia_ideg));
  p1 = gtk_entry_get_text ((GtkEntry*)(dia_ideg));
  ideg = atoi(p1);

  // reset dim (graf att 1 = default)
  ED_add_Line ("G1");

  // polygon -> B-spline
  sprintf(cBuf,"S%d=BSP,S%d,%d",irc+1,irc,ideg);
  ED_add_Line (cBuf);



  dia_nr = 0;


  return 0;


}


//=========================================================
  int dia_KeyIn (int key) {
//=========================================================
// userKeyin callback;    exit on 'q' or Esc-key.


  printf("dia_KeyIn %d\n",key);

  switch (key) {

    case GDK_Escape:
      gCad_fini ();
      break;

    case 'q':
      gCad_fini ();
      break;

  }

  return 0;

}


//=========================================================
  int gCad_fini () {
//=========================================================
// dll being unloaded - reset Input, kill all open windows !!!

  dia_win_main (NULL, (void*)UI_FuncKill);

  return 0;

}


//=========================================================
  int gCad_main () {
//=========================================================
// init userfunction


  TX_Print("--->>>>>> gCad_main aus DemoPlugin_Dialog <<<<<<<---\n");
  TX_Print("select Menu;  Esc = reset, q = exit");

  // attach KeyIn - connect KeyIn -> func dia_KeyIn
  AP_UserKeyIn_get (dia_KeyIn);

  // init diawin (create and display userpanel)
  dia_win_main (NULL, (void*)UI_FuncInit);


  return 0;
}





//=========================================================
  int dia_win_main (GtkWidget *parent, void *data) {
//=========================================================
// UI_FuncInit:  create and display userpanel
// UI_FuncKill:  kill userpanel


  static int       winStat=0;

  int i1;
  GtkWidget        *box0, *wact;


  printf("dia_win_main %d\n",(int)data);

  i1 = (int)data;


  switch (i1) {


    //---------------------------------------------------------
    case UI_FuncInit:
      printf("dia init\n");

      if(winStat != 0) {           // Win schon vorhanden ?
        gtk_widget_destroy (win0);
      }

      win0 = GUI_Window ("Demodialog",dia_win_main,(void*)UI_FuncKill,0);

      box0 = GUI_Vbox (win0, 0);    // create vertical box

      // textlabel
      GUI_Label (box0, "active function is:", 2);
      // textlabel
      dia_lb_func = GUI_Label (box0, "points->curve ", 2);


      // create buttons (parentwidget, textlabel, callback, CB-data, border)
      // box0 = GUI_Hbox (box0, 0);
      GUI_Butt (box0, " points->curve ", dia_CB_1, (void*)"p2c", 0);
      dia_ideg = GUI_Entry(box0,  "degree","2", NULL, -50);
      GUI_Butt (box0, " turn vec ", dia_CB_1, (void*)"turn", 0);
      GUI_Butt (box0, " polygon ", Cre_Poly, NULL, 0);
      GUI_Butt (box0, " Export ", dia_CB_1, (void*)"Export", 0);
      GUI_Butt (box0, " Clear ",  dia_CB_1, (void*)"Clear", 0);
      GUI_Butt (box0, " Exit ",   dia_win_main, (void*)UI_FuncKill, 0);


      // simulate buttonpress = init function points->curve
      // dia_CB_1 (NULL, (void*)"p2c");

      // inactivate box degree
      gtk_widget_set_sensitive (dia_ideg, FALSE);


      GUI_WinUp (win0);  // always on top

      gtk_widget_set_uposition (win0, 0, 0);  // Pos of mainwin

      gtk_widget_show (win0);
      winStat = 1;


      break;





    //---------------------------------------------------------
    case UI_FuncKill:
      printf("dia exit\n");

      // EXIT
      if(winStat != 0) {
        winStat = 0; // gtk_widget_destroy signals again !
        gtk_widget_destroy (win0);

        AP_UserKeyIn_reset ();      // reset  KeyIn (give back to mainApp)
        AP_UserSelection_reset ();  // reset  select (give back to mainApp)

        TX_Print("DemoPlugin_Dialog: bye ..");
      }


  }

  return 0;

}


//=========================================================
  int Cre_Poly (GtkWidget *parent, void *data) {
//=========================================================
// create polygon


  int    i1, i2;
static  Point  pta[32];
static  Plane  pln;

  printf("Cre_Poly\n");

  // clean undo-tables
  UI_undo_clear ();


  // polygonpoints
  for(i1=0; i1<32; ++i1) {
    pta[i1].x = i1 - 16.;
    pta[i1].y = (pta[i1].x * pta[i1].x)  *  0.1;
    pta[i1].z = i1 - 16;
    // printf(" p%d = %f,%f,%f\n",i1,pta[i1].x,pta[i1].y,pta[i1].z);
  }

  // create
  cre_obj (Typ_CVPOL, Typ_PT, 32, (void*)&pta);

  DL_Redraw ();
  TX_Print (" curve created ..");

  return 0;

}


//=========================================================
  int dia_CB_1 (GtkWidget *parent, void *data) {
//=========================================================
// dia-callbacks

  char      *cp1;


  printf("dia_CB_1 %s\n",(char*)data);

  cp1 = (char*)data;



  //-----------------------------------------------------
  if(!strcmp(cp1, "Clear")) {

    // Gesamtes File loeschen
    UI_menCB (NULL, "new");



  //-----------------------------------------------------
  } else if(!strcmp(cp1, "Export")) {

    sprintf(cBuf, "%sdat/dialog.ige",OS_get_bas_dir());
    AP_ExportIges__ (cBuf);



  //-----------------------------------------------------
  } else if(!strcmp(cp1, "p2c")) {

    // replace info
    gtk_label_set_text ((GtkLabel*)dia_lb_func, "points -> curve");

    // reactivate box degree
    gtk_widget_set_sensitive (dia_ideg, TRUE);

    // imply END-Button (Redraw)
    UI_butCB (NULL, (void*)"butEND");

    // attach grafic selections
    AP_UserSelection_get (dia_sele1);

    dia_nr = 0;                 // nr of points

    TX_Print(" --- select/indicate  5 points");




  //-----------------------------------------------------
  } else if(!strcmp(cp1, "turn")) {

    // replace info
    gtk_label_set_text ((GtkLabel*)dia_lb_func, "turn arrows");

    // inactivate box degree
    gtk_widget_set_sensitive (dia_ideg, FALSE);


    // clear model ("new")
    UI_menCB (NULL, "new");

    // create 3 pt's & 1 ln
    ED_add_Line ("P10=P(100,0)");
    ED_add_Line ("P11=P(120,0)");
    ED_add_Line ("P12=P(140,0)");
    ED_add_Line ("L10=P10,P12");

    // display 3 red arrows
    UT3D_pt_3db (&pt_tab[0], 100., 0., 0.);
    UT3D_pt_3db (&pt_tab[1], 120., 0., 0.);
    UT3D_pt_3db (&pt_tab[2], 140., 0., 0.);

    UT3D_vc_3db (&vc_tab[0], 0., 1., 1.);
    UT3D_vc_3db (&vc_tab[1], 0., 1., 1.);
    UT3D_vc_3db (&vc_tab[2], 0., 1., 1.);

    APT_disp_SymV3 (SYM_ARROW, 2, &pt_tab[0], &vc_tab[0], 10.);
    ID_tab[0] = GL_GetActInd();  // save dispListIndex
    APT_disp_SymV3 (SYM_ARROW, 2, &pt_tab[1], &vc_tab[1], 10.);
    ID_tab[1] = GL_GetActInd();
    APT_disp_SymV3 (SYM_ARROW, 2, &pt_tab[2], &vc_tab[2], 10.);
    ID_tab[2] = GL_GetActInd();
    printf(" arrID's=%d,%d,%d\n",ID_tab[0],ID_tab[1],ID_tab[2]);

    // Redraw DispList
    DL_Redraw ();
    TX_Print(" --- select arrow to invert");

    // attach grafic selections -> func dia_sele2
    AP_UserSelection_get (dia_sele2);

    dl_start = 0;

  //-----------------------------------------------------
  }

  dia_nr = 0;

  return 0;

}


//=========================================================
  int cre_obj (int typ, int form, int siz, void *obj) {
//=========================================================

  int    irc;
  long   ind;
  ObjGX  ox1;


  printf("cre_obj typ=%d form=%d siz=%d\n",typ,form,siz);


  // init Function Object->Text (prepare next ObjID)
  ox1.typ = TYP_FuncInit;
  AP_obj_2_txt (NULL, 0, NULL, 0);

  // prepare data
  ox1.typ  = typ;     // die Bedeutung der Daten im Feld <data>
  ox1.form = form;    // die Struktur der Daten im Feld <data>
  ox1.siz  = siz;     // Anzahl der Daten; wenn > 1: ein Array im Feld <data>
  ox1.data = obj;     //


  // change Object -> Text
  irc = AP_obj_2_txt (cBuf, CBUFSIZ, &ox1, -1);
  if(irc < 0) return irc;

  // query typ and index of created object
  AP_obj_2_txt_query (&typ, &ind);

  // add & execute line
  ED_add_Line (cBuf);


  return ind;

}


//======================== EOF ======================
