/* example Hili.



make -f DemoPlugin_Hili.mak

*/


#include "MS_Def1.h"

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include <gdk/gdkkeysyms.h>            // GDK_Esc



#include "../ut/ut_geo.h"              // DL_Att
#include "../gr/ut_DL.h"               // DB_GetDLatt




static long last_obj;


// protos:
  int hili_sele1 (int src, long dl_ind);
  int hili_key1 (int key);



#ifdef _MSC_VER
// die folgenden 2 Funktionen exportieren (werden vom Main gerufen):
__declspec(dllexport) int gCad_main ();
__declspec(dllexport) int gCad_fini ();
// nachfolgende externals werden aus dem Main-Exe imported:
#define extern __declspec(dllimport)
#endif








//=========================================================
  int gCad_main () {
//=========================================================


  // attach grafic selections
  AP_UserSelection_get (hili_sele1);


  // attach KeyIn
  AP_UserKeyIn_get (hili_key1);

  // display Info
  TX_Print(">>> select object to hilite, Esc=Unhilite, q=quit");

  return 0;
}




//=========================================================
  int gCad_fini () {
//=========================================================


  // reset  KeyIn (give back to mainApp)
  AP_UserKeyIn_reset ();

  // reset  select (give back to mainApp)
  AP_UserSelection_reset ();

  // display Info
  TX_Print(">>> exit DemoPlugin_Hili");

  return 0;

}




//=========================================================
  int hili_sele1 (int src, long dl_ind) {
//=========================================================
// userselection callback
// user selects obj.


  DL_Att att1;



  printf("hili_sele1 source=%d ind=%ld\n",src,dl_ind);


  if(src != TYP_EvMouseL) goto L_err_1; // skip all but left mousebutt.

  if(dl_ind < 0) goto L_err_1;          // skip indicate


  // get DL-record
  att1 = DL_GetAtt(dl_ind);
  printf("hili=%d\n",att1.hili);  // see hilite-bit


  last_obj = dl_ind;

  GL_HiliObj (last_obj);        // hilite obj
  DL_Redraw ();                 // Redraw DispList



  //-----------------------------------------------------
  L_err_1:

  return 0;

}



//=========================================================
  int hili_key1 (int key) {
//=========================================================
// userKeyin callback


  printf("dia_KeyIn %d\n",key);

  switch (key) {

    case GDK_Escape:
      GL_UnHiliObj (last_obj);    // unhilite last
      DL_Redraw ();               // Redraw DispList
      break;

    case 'q':
      GL_UnHiliObj (-1L);         //  -1 = unhilite all
      DL_Redraw ();               // Redraw DispList
      gCad_fini ();
      break;

  }

  return 0;

}




//======================== EOF ======================
