/* example Postprocessor for gCAD3D.                    2003-10-02

1) copy this to <baseDir>/xa
2) create DemoPostProc.so with make -f DemoPostProc.mak
   (Windows: nmake -f  DemoPostProc.nmak)
3) Start gCAD, load model sample_nc2.gcad, start DemoPostProc
4) if you modify this source: switch "Options/compile Dlls" to ON.
   (this compiles and links before starting).

*/



#include "MS_Def1.h"

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>            // GDK_Esc


#include "../ut/ut_geo.h"              // Point ...
#include "../ut/ut_txt.h"              // fnam_del
#include "../ut/ut_os.h"               // OS_get_bas_dir ..
#include "../gtk/ut_gtk.h"             // f. xa_ui.h
#include "../gr/ut_UI.h"               // UI_Func...
#include "xa_ui.h"                     // UID_..





  static  char   inFilnam[256];
  static  char   outFilnam[256];




// prototypes:
  int PP_CB_1 (GtkWidget *parent, void *data);



#ifdef _MSC_VER
// die folgenden 2 Funktionen exportieren (werden vom Main gerufen):
__declspec(dllexport) int gCad_main ();
__declspec(dllexport) int gCad_fini ();
// nachfolgende externals werden aus dem Main-Exe imported:
#define extern __declspec(dllimport)
#endif


// ext aus xa.c:
extern  char      WC_modnam[128];  // der Modelname





//=========================================================
  int PP_KeyIn (int key) {
//=========================================================
// userKeyin callback


  printf("PP_KeyIn %d\n",key);


  switch (key) {

    case GDK_Escape:
      gCad_fini ();
      break;

    case 'q':
      gCad_fini ();
      break;

  }

  return 0;

}


//=========================================================
  int gCad_fini () {
//=========================================================
// dll being unloaded - reset Input, kill all open windows !!!

  PP_win_main (NULL, (void*)UI_FuncKill);

  return 0;

}


//=========================================================
  int gCad_main () {
//=========================================================
// init userfunction

  char     *cp1;


  TX_Print("--->>>>>> gCad_main aus DemoPostProc <<<<<<<---\n");

  // create the ISO-file; output is <base>/tmp/pp.iso
  ED_work_PP (); 


  // fix inFilnam
  // strcpy (inFilnam, OS_get_bas_dir ());
  // strcat (inFilnam, "/tmp/pp.iso");
  sprintf(inFilnam,"%stmp%cpp.iso",OS_get_bas_dir(),fnam_del);
  printf(" inp.Fil = |%s|\n",inFilnam);


  // fix outFilnam
  // strcpy (outFilnam, OS_get_bas_dir ());
  // strcat (outFilnam, "/tmp/");
  sprintf(outFilnam,"%stmp%c",OS_get_bas_dir(),fnam_del);

  printf("Modelname=|%s|\n",WC_modnam);


  cp1 = strrchr(WC_modnam, fnam_del);
  if(cp1) {
    strcat (outFilnam, cp1);
  } else {
    strcat (outFilnam, WC_modnam);
  }

  // change filtyp (apt or dat ..) -> ppo
  cp1 = strrchr(outFilnam, '.');
  if(cp1) cp1 = '\0';
  strcat(outFilnam, ".ppo");
  printf(" outp.Fil = |%s|\n",outFilnam);


  // work ..
  if(PP_work () < 0) { gCad_fini (); return 0; }
  

  // init diawin
  PP_win_main (NULL, (void*)UI_FuncInit);

  // attach KeyIn
  AP_UserKeyIn_get (PP_KeyIn);


  return 0;
}




//=========================================================
  int PP_win_main (GtkWidget *parent, void *data) {
//=========================================================


  static GtkWidget *win0;
  static int       winStat=0;

  int i1;
  GtkWidget        *box0, *wact;


  printf("PP_win_main %d\n",(int)data);

  i1 = (int)data;


  switch (i1) {


    //---------------------------------------------------------
    case UI_FuncInit:
      printf("dia init\n");

      if(winStat != 0) {           // Win schon vorhanden ?
        gtk_widget_destroy (win0);
      }

      win0 = GUI_Window ("DemoPostprocessor",PP_win_main,(void*)UI_FuncKill,0);

      box0 = GUI_Vbox (win0, 0);

      GUI_Label (box0, " inspect files: ", 2);


      // box0 = GUI_Hbox (box0, 0);
      // PP_ideg = GUI_Entry(box0,  "degree","2", NULL, -50);
      GUI_Butt (box0, " Edit ISO-File",  PP_CB_1, (void*)"Edit1", 0);
      GUI_Butt (box0, " Edit PPO-File",  PP_CB_1, (void*)"Edit2", 0);
      GUI_Butt (box0, " Exit ",   PP_win_main, (void*)UI_FuncKill, 0);


      GUI_WinUp (win0); // always on top ..

      gtk_widget_set_uposition (win0, 0, 0);  // Pos of mainwin
      gtk_widget_show (win0);
      winStat = 1;


      break;





    //---------------------------------------------------------
    case UI_FuncKill:
      printf("dia exit\n");

      // EXIT
      if(winStat != 0) {
        winStat = 0; // gtk_widget_destroy signals again !
        gtk_widget_destroy (win0);

        AP_UserKeyIn_reset ();      // reset  KeyIn (give back to mainApp)
        AP_UserSelection_reset ();  // reset  select (give back to mainApp)

        TX_Print("DemoPostProc: bye ..");
      }


  }

  return 0;

}


//=========================================================
  int PP_CB_1 (GtkWidget *parent, void *data) {
//=========================================================
// dia-callbacks

  char      *cp1;
  char      cbuf[512];


  printf("PP_CB_1\n");

  cp1 = (char*)data;



  //-----------------------------------------------------
  if(!strcmp(cp1, "Edit1")) {

    strcpy(cbuf, OS_get_edi());
    strcat(cbuf, inFilnam);
    printf("%s\n",cbuf);
    system(cbuf);



  //-----------------------------------------------------
  } else if(!strcmp(cp1, "Edit2")) {

    strcpy(cbuf, OS_get_edi());
    strcat(cbuf, outFilnam);
    printf("%s\n",cbuf);
    system(cbuf);




  //-----------------------------------------------------
  }


  return 0;

}


//=========================================================
  int PP_work () {
//=========================================================

  FILE    *fpi, *fpo;
  char    cbuf[256];



  if((fpi=fopen(inFilnam,"r")) == NULL) {
    TX_Print("****** OPEN ERROR FILE %s **********\n",inFilnam);
    return -1;
  }



  if((fpo=fopen(outFilnam,"w")) == NULL) {
    TX_Print("****** OPEN ERROR FILE %s **********\n",outFilnam);
    return -1;
  }



  while (!feof (fpi)) {
    if (fgets (cbuf, 250, fpi) == NULL) break;
    UTX_CleanCR (cbuf);                            // remove foll CR,LF ..
    printf(" in:|%s|\n",cbuf);

    if((!strncmp(cbuf, "G1 ", 3))  ||
       (!strncmp(cbuf, "G2 ", 3))  ||
       (!strncmp(cbuf, "G3 ", 3)))     {
      fprintf(fpo, "%s\n", cbuf);
      printf(" out:|%s|\n",cbuf);



    } else if(!strncmp(cbuf, "GEO ", 4)) {
      fprintf(fpo, "( Contour %s )\n", &cbuf[4]);
      printf("( Contour %s)\n", &cbuf[4]);
    }

  }


  fclose(fpi);
  fclose(fpo);

  return 0;

}


/* ======================== EOF ====================== */
