/*

make -f DemoPlugin_Resolv.mak

*/


#include "MS_Def1.h"

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>            // GDK_Esc


#ifdef _MSC_VER
// die folgenden 2 Funktionen exportieren (werden vom Main gerufen):
__declspec(dllexport) int gCad_main ();
__declspec(dllexport) int gCad_fini ();
// nachfolgende externals werden aus dem Main-Exe imported:
#define extern __declspec(dllimport)
#endif



#include "../ut/ut_geo.h"              // Point ...
#include "../gtk/ut_gtk.h"             // f. xa_ui.h
#include "../gr/ut_UI.h"               // UI_Func...
#include "../gr/ut_DL.h"               // DB_GetDLatt
#include "../db/ut_DB.h"               // DB_GetObjGX
#include "xa_ui.h"                     // UID_..



// protos:
int decode_sele1 (int src, long dl_ind);
int decode_key1 (int key);





//=========================================================
  int gCad_fini () {
//=========================================================


  // reset  KeyIn (give back to mainApp)
  AP_UserKeyIn_reset ();

  // reset  select (give back to mainApp)
  AP_UserSelection_reset ();

  // display Info
  TX_Print(">>> exit Demo_Decode_Obj");

  return 0;
}





//=========================================================
  int gCad_main () {
//=========================================================


  // attach grafic selections
  AP_UserSelection_get (decode_sele1);

  // attach KeyIn
  AP_UserKeyIn_get (decode_key1);

  TX_Print(">>>>>>>>> gCad_main aus Demo_Decode_Obj <<<<<<<<<<");
  TX_Print("select obj. to decode or key Esc to quit");

  return 0;

}


//================================================================
  int decode_key1 (int key) {
//================================================================
// exit with q or Esc


  printf("dia_KeyIn %d\n",key);

  switch (key) {

    case GDK_Escape:
    case 'q':
      GL_UnHiliObj (-1L);         //  -1 = unhilite all
      DL_Redraw ();               // Redraw DispList
      gCad_fini ();
      break;
  }


  return 0;

}


//================================================================
  int decode_sele1 (int src, long dl_ind) {
//================================================================

  int    dbTyp, irc;
  long   dbInd;
  void   *oxo;
  char   oID[32];
  DL_Att att1;


  printf("decode_sele1 source=%d ind=%ld\n",src,dl_ind);


  // rechte maustaste: exit.
  if(src == TYP_EvMouseR) {decode_key1('q'); return 0;}

  if(src == TYP_EvMouseM) {TX_Print("middle button unuesed"); return 0;}

  // selection; what ?
  if(dl_ind < 0) {TX_Print("nothing selected; try again .."); return 0;}

  DL_DumpObj__(dl_ind);                  // dump DL-record

  att1  = DL_GetAtt(dl_ind);             // get DL-record
  dbTyp = att1.typ;
  dbInd = att1.ind;

  AP_name_typInd (oID, dbTyp, dbInd);     // make objName from typ and index

  printf("%s Sel. (typ=%d ind=%d)\n",oID,dbTyp,dbInd);
  TX_Print("%s selected (typ=%d ind=%d)",oID,dbTyp,dbInd);

  irc = UTO_get_DB (&oxo, &dbTyp, dbInd);        // get DB-record
  if(irc < 0) return irc;


  if(UTO_ck_oTyp (dbTyp) == 0) {                   // is it data or obj ?
    // oxo is simple data-structure
    UT3D_stru_dump (dbTyp, oxo, "%s:",oID);         // disp data-struct

  } else {
    // oxo is a ObjGX-struct (curve or surf ....)
    // UTO_dump__ (oxo, "%s:",oID);                // disp obj-data
    UTO_dump_s_ (oxo, oID);                        // disp structured display
  }

  TX_Print(">>> see Textwindow; then select next obj or Esc to exit.");

  return 0;

}


//======================== EOF ======================
