/*

GTK-OpenGl-Bindings mit gtkglarea.


2005-05-25 Extracted from xa_ui_gr.c. RF.


---------------------------------------------------
Compile:
cc -c GL_glarea.c `gtk-config --cflags`
cc -c GL_glarea.c `pkg-config --cflags gtkgl-2.0`

*/




#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gtk/gtk.h>
#include <gtkgl/gtkglarea.h>

#include "../ut/ut_txt.h"                            // fnam_del



extern GtkWidget *GL_widget;





//================================================================
  int UI_GR_DrawConfig (GtkWidget *widget) {
//================================================================
// im Callback von "realize" des GL_widget

  return 0;

}


//================================================================
  int UI_GR_DrawQuery () {
//================================================================

  /* Check if OpenGL (GLX extension) is supported. */
  if (gdk_gl_query() == FALSE) {
    printf("OpenGL not supported\n");
    return -1;
  }

  return 0;

}


//================================================================
  void UI_GR_DrawCreate () {
//================================================================

  int       i1;
  char      cbuf1[128], cbuf2[128], cbuf3[128];


  // GtkWidget *frm1;
  // GDK_GL_RED_SIZE: 1 bis 4; 1 reicht scheinbar (kein Unterschied erkennbar).


  // attrlist geht nach glXChooseVisual; see there for Doku.

  int attrlist[] = {
    GDK_GL_DOUBLEBUFFER,
    GDK_GL_RGBA,
    GDK_GL_RED_SIZE,  1,  // 4 oder 1; kein Unterschied erkennbar ...
    GDK_GL_GREEN_SIZE,1,  // 4
    GDK_GL_BLUE_SIZE, 1,  // 4
    // GDK_GL_DEPTH_SIZE, 16,    // depth buffer size; OHNE KEIN Z-BUFFER !!!!
                                 // 32-Bit DEPTH nur mit neuesten GL-Libs;
                                 // Laptop und alte crashen !!!
    // GDK_GL_DEPTH_SIZE,28,     // [8],[9] depth buffer size; OHNE KEIN Z-BUFFER
       // macht Crash, wenn DisplayEinstellung auf ColorDepth=16 Bit steht !
       // mit 24-Bit gehts.

    // GDK_GL_STENCIL_SIZE, 32,  // f HidelLineRemoval
    // GDK_GL_DOUBLEBUFFER,  // tut nix erkennbares ...
    GDK_GL_NONE                // definiert end of List !
  };

  sprintf(cbuf3,"%sxa%cgCAD3D.rc",OS_get_bas_dir(),fnam_del);

/*
  // depth of zBuf holen
  AP_Get_Setup (cbuf1, "ZBUFSIZ");
  i1 = atoi(cbuf1);
  if(i1 < 8) i1 = 8;
  if(i1 > 32) i1 = 32;
  printf("depth buffer size=%d\n",i1);
  attrlist[9] = i1;       // depth buffer size
*/


  L_retry:
  GL_widget = GTK_WIDGET(gtk_gl_area_new(attrlist));

  if(GL_widget == NULL) {
    if(attrlist[9] <= 16) {
      printf("permanent gtk_gl_area_new error\n");
      exit(0);
    }
    printf("***** Error gtk_gl_area_new *****\n");
    TX_Error("reset z_buf -> 16 bit");
    attrlist[9] = 16;
    goto L_retry;
  }

  
  printf("gtk_gl_area_new OK\n");


  return;
}


//================================================================
  void UI_GR_DrawInit () {
//================================================================
// 2007-04-20: fuer Linux nach wie vor erforderlich !!

  // printf("UI_GR_DrawInit\n");

  gtk_gl_area_make_current (GTK_GL_AREA(GL_widget));

  // gtk_gl_area_begingl (GTK_GL_AREA(GL_widget));


  return;
}


//================================================================
  void UI_GR_DrawExit () {
//================================================================

  // printf("UI_GR_DrawExit\n");

  gtk_gl_area_swap_buffers (GTK_GL_AREA(GL_widget));

  return;
}


//============= EOF ==============================================
 
